/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks"),require("os")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks","os"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks,e.require$$4)}(this,(function(e,t,n,a,r,s,u){"use strict";function i(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function o(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var a=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,a.get?a:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var d,l,p=i(n),c=i(a),m=i(r),f=i(s),h=i(u);let b;!function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(d||(d={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid",e[e.elu=6]="elu"}(l||(l={}));const _={kernelName:t._FusedMatMul,backendName:"wasm",setupFunc:function(e){b=e.wasm.cwrap(t._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{a:s,b:u,bias:i,preluActivationWeights:o}=n;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:d,transposeB:p,activation:c,leakyreluAlpha:m}=r,f=a.dataIdMap.get(s.dataId).id,h=a.dataIdMap.get(u.dataId).id;let _=0;if(null!=i){const e=a.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);_=e.id}const y=null==o?0:a.dataIdMap.get(o.dataId).id,g=l[c];if(null==g)throw new Error(`${c} activation not yet supported for FusedConv2D in the wasm backend.`);const k=d?s.shape[2]:s.shape[1],w=p?u.shape[1]:u.shape[2],I=t.broadcast_util.assertAndGetBroadcastShape(s.shape.slice(0,-2),u.shape.slice(0,-2)),S=a.makeOutput([...I,k,w],s.dtype),M=a.dataIdMap.get(S.dataId).id,A=new Uint8Array(new Int32Array(s.shape).buffer),v=new Uint8Array(new Int32Array(u.shape).buffer);return b(f,A,s.shape.length,h,v,u.shape.length,d,p,g,_,y,m||0,M),S}};function y(e,n){let a;return{kernelName:e,backendName:"wasm",setupFunc:function(t){a=t.wasm.cwrap(e,null,["number","number","number"])},kernelFunc:function(e){const{backend:r,inputs:{x:s}}=e,u=r.dataIdMap.get(s.dataId).id,i=r.makeOutput(s.shape,n||s.dtype),o=r.dataIdMap.get(i.dataId).id;return 0===t.util.sizeFromShape(i.shape)||a(u,d[s.dtype],o),i}}}const g=y(t.Abs);function k(e,n,a){let r;return{kernelName:e,backendName:"wasm",setupFunc:function(t){r=t.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:s}=e,{a:u,b:i}=s,o=n.dataIdMap.get(u.dataId).id,l=n.dataIdMap.get(i.dataId).id,p=null!=a?a:u.dtype,c=t.backend_util.assertAndGetBroadcastShape(u.shape,i.shape),m=n.makeOutput(c,p);if(0===t.util.sizeFromShape(c))return m;const f=new Uint8Array(new Int32Array(u.shape).buffer),h=new Uint8Array(new Int32Array(i.shape).buffer),b=n.dataIdMap.get(m.dataId).id;return r(o,f,u.shape.length,l,h,i.shape.length,d[u.dtype],b),m}}}const w=k(t.Add);let I;const S={kernelName:t.AddN,backendName:"wasm",setupFunc:function(e){I=e.wasm.cwrap(t.AddN,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a}=e,r=a.makeOutput(n[0].shape,n[0].dtype);if(0===t.util.sizeFromShape(r.shape))return r;const s=n.map((e=>a.dataIdMap.get(e.dataId).id)),u=new Uint8Array(new Int32Array(s).buffer),i=a.dataIdMap.get(r.dataId).id;return I(u,s.length,d[r.dtype],i),r}};function M(e){const{inputs:{x:n},backend:a}=e;if("string"===n.dtype)return t.tensor(a.readSync(n.dataId),n.shape,n.dtype);const r=a.makeOutput(n.shape,n.dtype),s=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(s),r}const A={kernelName:t.Identity,backendName:"wasm",kernelFunc:M};let v;function x(e){const{inputs:t,backend:n,attrs:a}=e,[r,s]=function(e,t){const n=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&n.push(e[r]),1!==e[t[r]]&&a.push(t[r]);for(let e=0;e<a.length;++e){let t=-1;for(let n=0;n<a.length;++n)a[n]>=e&&(-1===t||a[t]>a[n])&&(t=n);a[t]=e}return[n,a]}(t.x.shape,a.perm);let u=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(u=!1);const i=function(e,t){const n=new Array(e.length);for(let a=0;a<n.length;a++)n[a]=e[t[a]];return n}(t.x.shape,a.perm),o={dataId:t.x.dataId,shape:r,dtype:t.x.dtype};if(u){const e=M({inputs:t,backend:n});return e.shape=i,e}const l=n.makeOutput(i,o.dtype),p=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,m=new Uint8Array(new Int32Array(s).buffer),f=new Uint8Array(new Int32Array(o.shape).buffer);return v(p,f,o.shape.length,d[o.dtype],c,m,s.length),l}const F={kernelName:t.Transpose,backendName:"wasm",kernelFunc:x,setupFunc:function(e){v=e.wasm.cwrap(t.Transpose,null,["number","array","number","number","number","array","number"])}};function N(e,n,a){const r=e.shape,s=e.shape.length,u=t.util.parseAxisParam(n,r);let i=u;const o=t.backend_util.getAxesPermutation(i,s);let d=null,l=!1;if(null!=o){const n=new Array(s);for(let e=0;e<n.length;e++)n[e]=r[o[e]];i=t.backend_util.getInnerMostAxes(i.length,s),d=x({inputs:{x:e},attrs:{perm:o},backend:a});const u=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(d.dataId).id!==u&&(l=!0)}return{transposed:d,originalAxes:u,axes:i,inputWasTransposed:l}}let R;const E={kernelName:t.All,backendName:"wasm",setupFunc:function(e){R=e.wasm.cwrap(t.All,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,d=i;const{transposed:l,axes:p,originalAxes:c,inputWasTransposed:m}=N(i,s,n);if(m){d=l,o=n.dataIdMap.get(l.dataId).id}const f=d.shape.length;t.backend_util.assertAxesAreInnerMostDims("all",p,f);const[h,b]=t.backend_util.computeOutAndReduceShapes(d.shape,p),_=t.util.sizeFromShape(b),y=n.makeOutput(h,i.dtype);if(0!==t.util.sizeFromShape(d.shape)){const e=n.dataIdMap.get(y.dataId).id;R(o,_,e)}if(m&&n.disposeData(l.dataId),u){const e=t.backend_util.expandShapeToKeepDim(y.shape,c);y.shape=e}return y}};let D;const O={kernelName:t.Any,backendName:"wasm",setupFunc:function(e){D=e.wasm.cwrap(t.Any,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,d=i;const{transposed:l,axes:p,originalAxes:c,inputWasTransposed:m}=N(i,s,n);if(m){d=l,o=n.dataIdMap.get(l.dataId).id}const f=d.shape.length;t.backend_util.assertAxesAreInnerMostDims("any",p,f);const[h,b]=t.backend_util.computeOutAndReduceShapes(d.shape,p),_=t.util.sizeFromShape(b),y=n.makeOutput(h,i.dtype);if(0!==t.util.sizeFromShape(d.shape)){const e=n.dataIdMap.get(y.dataId).id;D(o,_,e)}if(m&&n.disposeData(l.dataId),u){const e=t.backend_util.expandShapeToKeepDim(y.shape,c);y.shape=e}return y}};let C;const T={kernelName:t.ArgMax,backendName:"wasm",kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s}=r,{x:u}=a,i=n.dataIdMap.get(u.dataId).id;let o=i,l=u;const{transposed:p,axes:c,inputWasTransposed:m}=N(u,s,n);if(m){const e=n.dataIdMap.get(p.dataId).id;e!==i&&(l=p,o=e)}const f=l.shape.slice(0,-1),h=n.makeOutput(f,"int32"),b=n.dataIdMap.get(h.dataId).id,_=t.util.sizeFromShape(h.shape),y=l.shape[c[0]];return C(o,d[l.dtype],_,y,b),m&&n.disposeData(p.dataId),h},setupFunc:function(e){C=e.wasm.cwrap(t.ArgMax,null,["number","number","number","number","number"])}};let P;const W={kernelName:t.AvgPool,backendName:"wasm",setupFunc:function(e){P=e.wasm.cwrap(t.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:d,dimRoundingMode:l}=a,p=t.backend_util.computePool2DInfo(s.shape,i,o,1,d,l),c=p.filterHeight,m=p.filterWidth,f=p.padInfo.top,h=p.padInfo.right,b=p.padInfo.bottom,_=p.padInfo.left,y=p.strideHeight,g=p.strideWidth,k=p.inChannels;if("channelsLast"!==p.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${p.dataFormat}'. Please use 'channelsLast'.`);if(1!==p.dilationWidth||1!==p.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${p.dilationHeight}, ${p.dilationWidth}].`);const w=r.makeOutput(p.outShape,"float32"),I=r.dataIdMap.get(w.dataId).id;return P(u,s.shape[0],s.shape[1],s.shape[2],c,m,f,h,b,_,y,g,k,I),w}};function z(e){const{inputs:n,attrs:a}=e,{x:r}=n,{shape:s}=a,u=t.util.sizeFromShape(r.shape),i=t.util.inferFromImplicitShape(s,u);return t.util.assert(u===t.util.sizeFromShape(i),(()=>`new shape: ${i}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:i,dtype:r.dtype}}const j={kernelName:t.Reshape,backendName:"wasm",kernelFunc:z};let L;const B={kernelName:t.BatchMatMul,backendName:"wasm",setupFunc:function(e){L=e.wasm.cwrap(t.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{a:s,b:u}=n,{transposeA:i,transposeB:o}=r;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const d=s.shape.length,l=u.shape.length,p=i?s.shape[d-2]:s.shape[d-1],c=o?u.shape[l-1]:u.shape[l-2],m=i?s.shape[d-1]:s.shape[d-2],f=o?u.shape[l-2]:u.shape[l-1],h=s.shape.slice(0,-2),b=u.shape.slice(0,-2),_=t.util.sizeFromShape(h),y=t.util.sizeFromShape(b),g=t.broadcast_util.assertAndGetBroadcastShape(s.shape.slice(0,-2),u.shape.slice(0,-2)).concat([m,f]);t.util.assert(p===c,(()=>`Error in matMul: inner shapes (${p}) and (${c}) of Tensors with shapes ${s.shape} and ${u.shape} and transposeA=${i} and transposeB=${o} must match.`));const k=o?[y,f,c]:[y,c,f],w=z({inputs:{x:s},backend:a,attrs:{shape:i?[_,p,m]:[_,m,p]}}),I=z({inputs:{x:u},backend:a,attrs:{shape:k}}),S=a.dataIdMap.get(w.dataId).id,M=a.dataIdMap.get(I.dataId).id,A=i?w.shape[2]:w.shape[1],v=o?I.shape[1]:I.shape[2],x=Math.max(_,y),F=a.makeOutput([x,A,v],w.dtype),N=a.dataIdMap.get(F.dataId).id,R=new Uint8Array(new Int32Array(w.shape).buffer),E=new Uint8Array(new Int32Array(I.shape).buffer);return L(S,R,w.shape.length,M,E,I.shape.length,i,o,N),a.disposeData(w.dataId),a.disposeData(I.dataId),F.shape=g,F}};function U(e,n,a,r,s){const u=t.slice_util.isSliceContinous(r,n,a),i=t.util.sizeFromShape(a),o=t.util.computeStrides(r);if(u){const a=t.slice_util.computeFlatOffset(n,o);return"string"===s?e.slice(a,a+i):e.subarray(a,a+i)}const d="string"===s?t.backend_util.fromUint8ToStringArray(e):e,l=t.buffer(r,s,d),p=t.buffer(a,s);for(let e=0;e<p.size;++e){const t=p.indexToLoc(e),a=t.map(((e,t)=>e+n[t]));p.set(l.get(...a),...t)}return"string"===s?t.backend_util.fromStringArrayToUint8(p.values):p.values}t.backend_util.RowPartitionType;class q{constructor(e,n,a,r,s,u){this.separator=t.util.encodeString(e),this.nGramWidths=n,this.leftPad=t.util.encodeString(a),this.rightPad=t.util.encodeString(r),this.padWidth=s,this.preserveShort=u}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,a,r,s){for(let u=0;u<r;++u){const i=this.getPadWidth(s),o=Math.max(0,i-u),d=Math.max(0,i-(r-(u+1))),l=s-(o+d),p=t+(o>0?0:u-i);let c=0;c+=o*this.leftPad.length;for(let t=0;t<l;++t)c+=e[p+t].length;c+=d*this.rightPad.length;c+=(o+d+l-1)*this.separator.length,n[a+u]=new Uint8Array(c);const m=n[a+u];let f=0;const h=e=>e.forEach((e=>m[f++]=e));for(let e=0;e<o;++e)h(this.leftPad),h(this.separator);for(let t=0;t<l-1;++t)h(e[p+t]),h(this.separator);if(l>0){h(e[p+l-1]);for(let e=0;e<d;++e)h(this.separator),h(this.rightPad)}else{for(let e=0;e<d-1;++e)h(this.rightPad),h(this.separator);h(this.rightPad)}}}compute(e,n){const a=e.length,r=n.length;if(r>0){let e=n[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let t=1;t<r;++t){let r=n[t]>=e;if(r=r&&n[t]<=a,!r)throw new Error(`Invalid split value ${n[t]}, must be in [${e}, ${a}]`);e=n[t]}if(e!==a)throw new Error(`Last split value must be data size. Expected ${a}, got ${e}`)}const s=r-1,u=t.util.getArrayFromDType("int32",r);if(0===a||0===r){const e=new Array(a);for(let e=0;e<=s;++e)u[e]=0;return[e,u]}u[0]=0;for(let e=1;e<=s;++e){const t=n[e]-n[e-1];let a=0;this.nGramWidths.forEach((e=>{a+=this.getNumNGrams(t,e)})),this.preserveShort&&t>0&&0===a&&(a=1),u[e]=u[e-1]+a}const i=new Array(u[s]);for(let t=0;t<s;++t){const a=n[t];let r=u[t];if(this.nGramWidths.forEach((s=>{const u=n[t+1]-n[t],o=this.getNumNGrams(u,s);this.createNGrams(e,a,i,r,o,s),r+=o})),this.preserveShort&&r===u[t]){const s=n[t+1]-n[t];if(0===s)continue;const u=s+2*this.padWidth,o=1;this.createNGrams(e,a,i,r,o,u)}}return[i,u]}}function H(e,t,n,a){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)a.push(e.subarray(t,t+1));return}if(1===t.length){const r=t[0];let s=e.indexOf(r);for(;-1!==s;){const t=e.subarray(0,s);n&&0===t.length||a.push(t),s=(e=e.subarray(s+1)).indexOf(r)}return void(n&&0===e.length||a.push(e))}let r=0;for(let s=0;s<e.length+1;s++)if(s===e.length||-1!==t.indexOf(e[s])){const t=e.subarray(r,s);n&&0===t.length||a.push(t),r=s+1}}function V(e){const{inputs:{x:n},attrs:{begin:a,size:r},backend:s}=e,[u,i]=t.slice_util.parseSliceParams(n,a,r),o=t.slice_util.isSliceContinous(n.shape,u,i),d=s.readSync(n.dataId),l=s.makeOutput(i,n.dtype),p=t.util.computeStrides(n.shape),c=s.dataIdMap.get(l.dataId);if(o){const e=t.slice_util.computeFlatOffset(u,p);if("string"===n.dtype)c.stringBytes=d.slice(e,e+t.util.sizeFromShape(i));else{s.typedArrayFromHeap(l).set(d.subarray(e,e+t.util.sizeFromShape(i)))}return l}if("string"===n.dtype){const e=U(d,u,i,n.shape,n.dtype);return c.stringBytes=e,l}const m=s.typedArrayFromHeap(l),f=n.shape.length;if(2===f)!function(e,t,n,a,r){let s=0;const u=a[0],i=a[1],o=u+r[0];for(let a=u;a<o;a++){const u=a*t+i;n.set(e.subarray(u,u+r[1]),s),s+=r[1]}}(d,p[0],m,u,i);else if(3===f)!function(e,t,n,a,r,s){let u=0;const i=r[0],o=r[1],d=r[2],l=i+s[0],p=o+s[1];for(let r=i;r<l;r++)for(let i=o;i<p;i++){const o=r*t+i*n+d;a.set(e.subarray(o,o+s[2]),u),u+=s[2]}}(d,p[0],p[1],m,u,i);else if(4===f)!function(e,t,n,a,r,s,u){let i=0;const o=s[0],d=s[1],l=s[2],p=o+u[0],c=d+u[1],m=l+u[2],f=s[3];for(let s=o;s<p;s++)for(let o=d;o<c;o++)for(let d=l;d<m;d++){const l=s*t+o*n+d*a+f;r.set(e.subarray(l,l+u[3]),i),i+=u[3]}}(d,p[0],p[1],p[2],m,u,i);else{const e=U(d,u,i,n.shape,n.dtype);m.set(e)}return l}const G={kernelName:t.Slice,backendName:"wasm",kernelFunc:V};const $={kernelName:t.BatchToSpaceND,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{blockShape:u,crops:i}=r,o=u.reduce(((e,t)=>e*t)),d=t.backend_util.getReshaped(s.shape,u,o),l=t.backend_util.getPermuted(d.length,u.length),p=t.backend_util.getReshapedPermuted(s.shape,u,o),c=t.backend_util.getSliceBeginCoords(i,u.length),m=t.backend_util.getSliceSize(p,i,u.length),f=z({inputs:{x:s},backend:a,attrs:{shape:d}}),h=x({inputs:{x:f},backend:a,attrs:{perm:l}}),b=V({inputs:{x:z({inputs:{x:h},backend:a,attrs:{shape:p}})},backend:a,attrs:{begin:c,size:m}});return a.disposeData(f.dataId),a.disposeData(h.dataId),a.disposeData(f.dataId),b}};function K(e){const{inputs:{x:t},attrs:{dtype:n},backend:a}=e,r=a.makeOutput(t.shape,n),s=a.typedArrayFromHeap(t);return a.typedArrayFromHeap(r).set(s),r}const X={kernelName:t.Cast,backendName:"wasm",kernelFunc:K},Q=y(t.Ceil);let J;const Z={kernelName:t.ClipByValue,backendName:"wasm",setupFunc:function(e){J=e.wasm.cwrap(t.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,{clipValueMin:s,clipValueMax:u}=a,i=n.dataIdMap.get(r.dataId).id,o=n.makeOutput(r.shape,r.dtype),d=n.dataIdMap.get(o.dataId).id;return J(i,s,u,d),o}};function Y(e){const{inputs:n,backend:a}=e,r=t.util.parseAxisParam(e.attrs.axis,n[0].shape)[0],s=n.map((e=>e.shape));t.backend_util.assertParamsConsistent(s,r);let u=t.backend_util.computeOutShape(n.map((e=>e.shape)),r);const i=n.filter((e=>t.util.sizeFromShape(e.shape)>0));if(1===i.length)return M({inputs:{x:i[0]},backend:a});const o=a.makeOutput(u,n[0].dtype);if(0===t.util.sizeFromShape(u))return o;if("string"===i[0].dtype){const e=i.map((e=>{const n=t.util.sizeFromShape(e.shape.slice(r));return z({inputs:{x:e},backend:a,attrs:{shape:[-1,n]}})})),s=e.map((e=>({vals:a.readSync(e.dataId),shape:e.shape})));u=t.backend_util.computeOutShape(e.map((e=>e.shape)),1);const d=1===e[0].shape[0],l=function(e,n,a,r){const s=t.util.getArrayFromDType(a,t.util.sizeFromShape(n));if(r&&"string"!==a){let n=0;e.forEach((e=>{const a=t.util.sizeFromShape(e.shape);s.set(e.vals,n),n+=a}))}else{let r=0;e.forEach((e=>{const u="string"===a?t.backend_util.fromUint8ToStringArray(e.vals):e.vals;let i=0;for(let t=0;t<e.shape[0];++t){const a=t*n[1]+r;for(let t=0;t<e.shape[1];++t)s[a+t]=u[i++]}r+=e.shape[1]}))}return s}(s,u,n[0].dtype,d),p=t.backend_util.computeOutShape(i.map((e=>e.shape)),r);o.shape=p;return a.dataIdMap.get(o.dataId).stringBytes=t.backend_util.fromStringArrayToUint8(l),e.forEach((e=>a.disposeData(e.dataId))),o}const d=t.util.sizeFromShape(i[0].shape.slice(0,r));let l=0;const p=i.map((e=>{const n=t.util.sizeFromShape(e.shape.slice(r));return l+=n,n})),c=i.map((e=>a.typedArrayFromHeap(e))),m=a.typedArrayFromHeap(o);for(let e=0;e<d;e++){let t=e*l;for(let n=0;n<c.length;n++){const a=p[n],r=e*a,s=c[n].subarray(r,r+a);m.set(s,t),t+=a}}return o}const ee={kernelName:t.Concat,backendName:"wasm",kernelFunc:Y};let te;const ne={kernelName:t.Conv2D,backendName:"wasm",setupFunc:function(e){te=e.wasm.cwrap(t.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u}=n,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:d,dilations:l,pad:p,dimRoundingMode:c,dataFormat:m}=a,f=t.backend_util.convertConv2DDataFormat(m),h=t.backend_util.computeConv2DInfo(s.shape,u.shape,d,l,p,c,!1,f),b=h.filterHeight,_=h.filterWidth,y=h.padInfo.top,g=h.padInfo.right,k=h.padInfo.bottom,w=h.padInfo.left,I=h.dilationHeight,S=h.dilationWidth,M=h.strideHeight,A=h.strideWidth,v=h.inChannels,x=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error(`wasm backend Conv2D does not support dataFormat:'${h.dataFormat}'. Please use 'channelsLast'.`);const N=r.makeOutput(h.outShape,"float32"),R=r.dataIdMap.get(N.dataId).id;return te(i,s.shape[0],s.shape[1],s.shape[2],o,b,_,y,g,k,w,F,I,S,M,A,v,x,R),N}};let ae;const re={kernelName:t.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){ae=e.wasm.cwrap(t.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{dy:s,filter:u}=a,{strides:i,pad:o,dataFormat:d,dimRoundingMode:l,inputShape:p}=r,c=t.backend_util.convertConv2DDataFormat(d),m=t.backend_util.computeConv2DInfo(p,u.shape,i,1,o,l,!1,c),{batchSize:f,filterHeight:h,filterWidth:b,inChannels:_,inHeight:y,inWidth:g,outChannels:k,outHeight:w,outWidth:I,strideHeight:S,strideWidth:M}=m,A=h-1-m.padInfo.top,v=b-1-m.padInfo.left,x="channelsLast"===m.dataFormat,F=t.util.computeStrides(m.inShape),N=t.util.computeStrides(s.shape),[R,E,D]=t.util.computeStrides(u.shape),O=F[0],C=x?F[1]:F[2],T=x?F[2]:1,P=x?1:F[1],W=N[0],z=x?N[1]:N[2],j=x?N[2]:1,L=x?1:N[1],B=n.makeOutput(m.inShape,"float32"),U=n.dataIdMap.get(B.dataId).id,q=n.dataIdMap.get(s.dataId).id,H=n.dataIdMap.get(u.dataId).id;return ae(q,H,f,h,b,y,g,_,w,I,k,S,M,A,v,R,E,D,O,C,T,P,W,z,j,L,U),B}},se=y(t.Cos),ue=y(t.Cosh);var ie;let oe;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(ie||(ie={}));const de={kernelName:t.CropAndResize,backendName:"wasm",setupFunc:function(e){oe=e.wasm.cwrap(t.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{method:r,extrapolationValue:s,cropSize:u}=a,{image:i,boxes:o,boxInd:d}=n,l=o.shape[0],[p,c]=u,m=[l,p,c,i.shape[3]];let f,h=t.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(f=K({backend:t,inputs:{x:i},attrs:{dtype:"float32"}}),h=t.dataIdMap.get(f.dataId));const b=h.id,_=t.dataIdMap.get(o.dataId).id,y=t.dataIdMap.get(d.dataId).id,g=t.makeOutput(m,"float32"),k=t.dataIdMap.get(g.dataId).id,w=new Uint8Array(new Int32Array(i.shape).buffer);return oe(b,_,y,l,w,p,c,ie[r],s,k),null!=f&&t.disposeData(f.dataId),g}};let le;const pe={kernelName:t.Cumprod,backendName:"wasm",setupFunc:function(e){le=e.wasm.cwrap(t.Cumprod,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{axis:u,exclusive:i,reverse:o}=r,l=s.shape.length;t.util.assert("float32"===s.dtype||"int32"===s.dtype,(()=>`cumprod does not support ${s.dtype} tensors in the WASM backend`));const p=t.backend_util.getAxesPermutation([u],l);let c=s;null!==p&&(c=x({inputs:{x:s},attrs:{perm:p},backend:a}));const m=t.backend_util.getInnerMostAxes(1,l)[0];t.backend_util.assertAxesAreInnerMostDims("cumprod",[m],l);const f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,_=a.dataIdMap.get(f.dataId).id;le(b,i?1:0,o?1:0,h,_,d[s.dtype]);let y=f;if(null!==p){y=x({inputs:{x:f},attrs:{perm:t.backend_util.getUndoAxesPermutation(p)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)}return y}};let ce;const me={kernelName:t.Cumsum,backendName:"wasm",setupFunc:function(e){ce=e.wasm.cwrap(t.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{axis:u,exclusive:i,reverse:o}=r,l=s.shape.length;t.util.assert("float32"===s.dtype||"int32"===s.dtype,(()=>`cumsum does not support ${s.dtype} tensors in the WASM backend`));const p=t.backend_util.getAxesPermutation([u],l);let c=s;null!==p&&(c=x({inputs:{x:s},attrs:{perm:p},backend:a}));const m=t.backend_util.getInnerMostAxes(1,l)[0];t.backend_util.assertAxesAreInnerMostDims("cumsum",[m],l);const f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,_=a.dataIdMap.get(f.dataId).id;ce(b,i?1:0,o?1:0,h,_,d[s.dtype]);let y=f;if(null!==p){y=x({inputs:{x:f},attrs:{perm:t.backend_util.getUndoAxesPermutation(p)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)}return y}};let fe;const he={kernelName:t.DepthToSpace,backendName:"wasm",setupFunc:function(e){fe=e.wasm.cwrap(t.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s}=a,{blockSize:u,dataFormat:i}=r,o=s.shape[0],d=("NHWC"===i?s.shape[1]:s.shape[2])*u,l=("NHWC"===i?s.shape[2]:s.shape[3])*u,p=("NHWC"===i?s.shape[3]:s.shape[1])/(u*u),c="NHWC"===i?[o,d,l,p]:[o,p,d,l],m=n.makeOutput(c,"float32"),f=n.dataIdMap.get(s.dataId).id,h=new Uint8Array(new Int32Array(t.util.computeStrides(s.shape)).buffer),b=new Uint8Array(new Int32Array(c).buffer),_=new Uint8Array(new Int32Array(t.util.computeStrides(c)).buffer),y=n.dataIdMap.get(m.dataId).id;return fe(f,u,"NHWC"===i?1:0,h,s.shape.length-1,b,_,c.length,y),m}};let be;const _e={kernelName:t.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){be=e.wasm.cwrap(t.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u}=n,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:d,dilations:l,pad:p,dimRoundingMode:c}=a,m=null==l?[1,1]:l,f=t.backend_util.computeConv2DInfo(s.shape,u.shape,d,m,p,c,!0),h=f.filterHeight,b=f.filterWidth,_=f.padInfo.top,y=f.padInfo.right,g=f.padInfo.bottom,k=f.padInfo.left,w=f.dilationHeight,I=f.dilationWidth,S=f.strideHeight,M=f.strideWidth,A=f.inChannels,v=f.outChannels,x="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error(`wasm backend DepthwiseConv2dNative does not support dataFormat:'${f.dataFormat}'. Please use 'channelsLast'.`);const F=r.makeOutput(f.outShape,"float32"),N=r.dataIdMap.get(F.dataId).id;return be(i,s.shape[0],s.shape[1],s.shape[2],o,h,b,_,y,g,k,x,w,I,S,M,A,v,N),F}},ye=y(t.Elu),ge=k(t.Equal,0,"bool"),ke=y(t.Exp,"float32");function we(e){const{inputs:n,attrs:a,backend:r}=e,{input:s}=n,{dim:u}=a,i=s.shape.length,o=s.shape.slice();let d=u;return u<0&&(t.util.assert(-(i+1)<=u,(()=>`Axis must be in the interval [${-(i+1)}, ${i}]`)),d=i+u+1),o.splice(d,0,1),z({inputs:{x:s},backend:r,attrs:{shape:o}})}const Ie={kernelName:t.ExpandDims,backendName:"wasm",kernelFunc:we};function Se(e){const{attrs:{shape:t,value:n,dtype:a},backend:r}=e,s=r.makeOutput(t,a);return r.typedArrayFromHeap(s).fill(n),s}const Me={kernelName:t.Fill,backendName:"wasm",kernelFunc:Se};let Ae;const ve={kernelName:t.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n}=e,{image:a}=t,r=n.makeOutput(a.shape,a.dtype),s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id,[i,o,d,l]=a.shape;return Ae(s,i,o,d,l,u),r},setupFunc:function(e){Ae=e.wasm.cwrap(t.FlipLeftRight,null,["number","number","number","number","number","number"])}},xe=y(t.Floor),Fe=k(t.FloorDiv);let Ne;const Re={kernelName:t.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){Ne=e.wasm.cwrap(t.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{varianceEpsilon:s}=r,{x:u,mean:i,variance:o,offset:d,scale:l}=a,p=n.dataIdMap.get(u.dataId).id,c=n.dataIdMap.get(i.dataId).id,m=n.dataIdMap.get(o.dataId).id,f=null!=d?n.dataIdMap.get(d.dataId).id:0,h=null!=l?n.dataIdMap.get(l.dataId).id:0,b=n.makeOutput(u.shape,u.dtype);if(0===t.util.sizeFromShape(u.shape))return b;const _=n.dataIdMap.get(b.dataId).id;return Ne(p,c,m,f,h,s,_),b}};let Ee;const De={kernelName:t.FusedConv2D,backendName:"wasm",setupFunc:function(e){Ee=e.wasm.cwrap(t.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u,bias:i,preluActivationWeights:o}=n,{strides:d,pad:p,dilations:c,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=t.backend_util.computeConv2DInfo(s.shape,u.shape,d,c,p,f),y=l[h];if(null==y)throw new Error(`${h} activation not yet supported for FusedConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,k=r.dataIdMap.get(u.dataId).id,w=_.outChannels;let I=0;if(null!=i){const e=r.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);I=e.id}const S=_.filterHeight,M=_.filterWidth,A=_.padInfo.top,v=_.padInfo.right,x=_.padInfo.bottom,F=_.padInfo.left,N=_.dilationHeight,R=_.dilationWidth,E=_.strideHeight,D=_.strideWidth,O=_.inChannels,C="SAME"===_.padInfo.type?1:0,T=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error(`wasm backend FusedConv2D does not support dataFormat:'${m}'. Please use 'NHWC'.`);const z=r.makeOutput(_.outShape,"float32"),j=r.dataIdMap.get(z.dataId).id,L=null==o?0:r.dataIdMap.get(o.dataId).id;return Ee(g,T,P,W,k,S,M,I,A,v,x,F,C,N,R,E,D,O,w,y,L,b||0,j),z}};let Oe;const Ce={kernelName:t.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){Oe=e.wasm.cwrap(t.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u,bias:i,preluActivationWeights:o}=n,{strides:d,pad:p,dilations:c,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=t.backend_util.computeConv2DInfo(s.shape,u.shape,d,c,p,f,!0),y=l[h];if(null==y)throw new Error(`${h} activation not yet supported for FusedDepthwiseConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,k=r.dataIdMap.get(u.dataId).id,w=_.outChannels;let I=0;if(null!=i){const e=r.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);I=e.id}const S=_.filterHeight,M=_.filterWidth,A=_.padInfo.top,v=_.padInfo.right,x=_.padInfo.bottom,F=_.padInfo.left,N=_.dilationHeight,R=_.dilationWidth,E=_.strideHeight,D=_.strideWidth,O=_.inChannels,C="SAME"===_.padInfo.type?1:0,T=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error(`wasm backend FusedDepthwiseConv2D does not support dataFormat:'${m}'. Please use 'NHWC'.`);const z=r.makeOutput(_.outShape,"float32"),j=r.dataIdMap.get(z.dataId).id,L=null==o?0:r.dataIdMap.get(o.dataId).id;return Oe(g,T,P,W,k,S,M,I,A,v,x,F,C,N,R,E,D,O,w,y,L,b||0,j),z}};let Te;const Pe={kernelName:t.GatherNd,backendName:"wasm",setupFunc:function(e){Te=e.wasm.cwrap(t.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:a}=e,{params:r,indices:s}=a,[u,i,o,l]=t.gather_util.prepareAndValidate(r,s),p=n.makeOutput(u,r.dtype);if(0===i)return p;const c=s.shape,m=c[c.length-1],f=n.dataIdMap.get(r.dataId).id,h=n.dataIdMap.get(s.dataId).id,b=new Uint8Array(new Int32Array(l).buffer),_=n.dataIdMap.get(p.dataId).id;return Te(f,d[r.dtype],h,i,m,o,b,_),p}};let We;const ze={kernelName:t.GatherV2,backendName:"wasm",setupFunc:function(e){We=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s,indices:u}=a,{axis:i,batchDims:o}=r,l=t.util.parseAxisParam(i,s.shape)[0],p=n.readSync(u.dataId),c=s.shape[l];for(let e=0;e<p.length;++e){const n=p[e];t.util.assert(n<=c-1&&n>=0,(()=>`GatherV2: the index value ${n} is not in [0, ${c-1}]`))}const m=t.backend_util.segment_util.collectGatherOpShapeInfo(s,u,l,o),f=z({inputs:{x:s},attrs:{shape:[m.batchSize,m.outerSize,m.dimSize,m.sliceSize]},backend:n}),h=t.util.sizeFromShape(u.shape),b=z({inputs:{x:u},attrs:{shape:[m.batchSize,h/m.batchSize]},backend:n}),_=[m.batchSize,m.outerSize,h/m.batchSize,m.sliceSize],y=n.makeOutput(_,s.dtype);if(0===t.util.sizeFromShape(s.shape))return y;const g=f.shape.length-1,k=n.dataIdMap.get(f.dataId).id,w=n.dataIdMap.get(b.dataId).id,I=n.dataIdMap.get(y.dataId).id,S=new Uint8Array(new Int32Array(t.util.computeStrides(f.shape)).buffer),M=new Uint8Array(new Int32Array(t.util.computeStrides(_)).buffer);return We(k,d[s.dtype],S,g,w,m.batchSize,M,I),n.disposeData(f.dataId),n.disposeData(b.dataId),y.shape=m.outputShape,y}},je=k(t.Greater,0,"bool"),Le=k(t.GreaterEqual,0,"bool");let Be;const Ue={kernelName:t.LeakyRelu,backendName:"wasm",setupFunc:function(e){Be=e.wasm.cwrap(t.LeakyRelu,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:{x:n},attrs:{alpha:a},backend:r}=e,s=r.dataIdMap.get(n.dataId).id,u=r.makeOutput(n.shape,"float32");if(0!==t.util.sizeFromShape(n.shape)){const e=r.dataIdMap.get(u.dataId).id;Be(s,d[n.dtype],a,e)}return u}},qe=k(t.Less,0,"bool"),He=k(t.LessEqual,0,"bool"),Ve=y(t.Log),Ge=k(t.LogicalAnd,0,"bool"),$e=y(t.LogicalNot),Ke=k(t.LogicalOr,0,"bool"),Xe=k(t.LogicalXor,0,"bool");let Qe;const Je={kernelName:t.Max,backendName:"wasm",setupFunc:function(e){Qe=e.wasm.cwrap(t.Max,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{reductionIndices:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,l=i;const{transposed:p,axes:c,originalAxes:m,inputWasTransposed:f}=N(i,s,n);if(f){l=p,o=n.dataIdMap.get(p.dataId).id}const h=l.shape.length;t.backend_util.assertAxesAreInnerMostDims("max",c,h);const[b,_]=t.backend_util.computeOutAndReduceShapes(l.shape,c),y=t.util.sizeFromShape(_),g=n.makeOutput(b,i.dtype);if(0!==t.util.sizeFromShape(l.shape)){const e=n.dataIdMap.get(g.dataId).id;Qe(o,d[i.dtype],y,e)}if(f&&n.disposeData(p.dataId),u){const e=t.backend_util.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},Ze=k(t.Maximum);let Ye;const et={kernelName:t.MaxPool,backendName:"wasm",setupFunc:function(e){Ye=e.wasm.cwrap(t.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id;t.util.assert("float32"===s.dtype,(()=>`Error in MaxPool: only float32 input is supported. Got ${s.dtype}.`));const{filterSize:i,strides:o,pad:d,dimRoundingMode:l}=a,p=t.backend_util.computePool2DInfo(s.shape,i,o,1,d,l),c=p.filterHeight,m=p.filterWidth,f=p.padInfo.top,h=p.padInfo.right,b=p.padInfo.bottom,_=p.padInfo.left,y=p.dilationHeight,g=p.dilationWidth,k=p.strideHeight,w=p.strideWidth,I=p.inChannels,S=p.outChannels;if("channelsLast"!==p.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${p.dataFormat}'. Please use 'channelsLast'.`);const M=r.makeOutput(p.outShape,"float32"),A=r.dataIdMap.get(M.dataId).id;return Ye(u,s.shape[0],s.shape[1],s.shape[2],c,m,f,h,b,_,y,g,k,w,I,S,A),M}};let tt;const nt={kernelName:t.Mean,backendName:"wasm",setupFunc:function(e){tt=e.wasm.cwrap(t.Mean,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let d=o,l=i;const{transposed:p,axes:c,originalAxes:m,inputWasTransposed:f}=N(i,s,n);let h=c;if(f){const e=n.dataIdMap.get(p.dataId).id;e!==o&&(l=p,d=e,h=t.backend_util.getInnerMostAxes(h.length,l.shape.length))}t.backend_util.assertAxesAreInnerMostDims("mean",h,l.shape.length);const[b,_]=t.backend_util.computeOutAndReduceShapes(l.shape,h),y=t.util.sizeFromShape(_);let g=l;"float32"!==l.dtype&&(g=K({backend:n,inputs:{x:l},attrs:{dtype:"float32"}}),d=n.dataIdMap.get(g.dataId).id);const k=n.makeOutput(b,"float32");if(0!==t.util.sizeFromShape(l.shape)){const e=n.dataIdMap.get(k.dataId).id;tt(d,y,e)}if(f&&n.disposeData(p.dataId),u){const e=t.backend_util.expandShapeToKeepDim(k.shape,m);k.shape=e}return"float32"!==l.dtype&&n.disposeData(g.dataId),k}};let at;const rt={kernelName:t.Min,backendName:"wasm",setupFunc:function(e){at=e.wasm.cwrap(t.Min,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,p=i;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=N(i,s,n);if(h){const e=n.dataIdMap.get(c.dataId).id;e!==o&&(p=c,l=e)}const b=p.shape.length;t.backend_util.assertAxesAreInnerMostDims("min",m,b);const[_,y]=t.backend_util.computeOutAndReduceShapes(p.shape,m),g=t.util.sizeFromShape(y),k=n.makeOutput(_,p.dtype);if(0!==t.util.sizeFromShape(p.shape)){const e=n.dataIdMap.get(k.dataId).id;at(l,d[i.dtype],g,e)}if(h&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(k.shape,f);k.shape=e}return k}},st=k(t.Minimum);var ut;let it;!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(ut||(ut={}));const ot={kernelName:t.MirrorPad,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n,attrs:{paddings:a,mode:r}}=e,s=a.map(((e,n)=>e[0]+t.shape[n]+e[1])),u=n.dataIdMap.get(t.dataId).id,i=n.makeOutput(s,t.dtype),o=n.dataIdMap.get(i.dataId).id,l=new Uint8Array(new Int32Array(t.shape).buffer),p=a.map((e=>e[0])),c=a.map((e=>e[1])),m=new Uint8Array(new Int32Array(p).buffer),f=new Uint8Array(new Int32Array(c).buffer);return it(u,l,t.shape.length,d[t.dtype],m,f,ut[r],o),i},setupFunc:function(e){it=e.wasm.cwrap(t.MirrorPad,null,["number","array","number","number","array","array","number","number"])}},dt=k(t.Multiply),lt=y(t.Neg);function pt(e,t){const n=new Int32Array(e.wasm.HEAPU8.buffer,t,4),a=n[0],r=n[1],s=n[2],u=n[3];return e.wasm._free(t),{pSelectedIndices:a,selectedSize:r,pSelectedScores:s,pValidOutputs:u}}let ct;const mt={kernelName:t.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){ct=e.wasm.cwrap(t.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u}=a,{boxes:i,scores:o}=n,d=t.dataIdMap.get(i.dataId).id,l=t.dataIdMap.get(o.dataId).id,p=ct(d,l,s,r,u),{pSelectedIndices:c,selectedSize:m,pSelectedScores:f,pValidOutputs:h}=pt(t,p);return t.wasm._free(f),t.wasm._free(h),t.makeOutput([m],"int32",c)}};let ft;const ht={kernelName:t.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){ft=e.wasm.cwrap(t.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,padToMaxOutputSize:i}=a,{boxes:o,scores:d}=n,l=t.dataIdMap.get(o.dataId).id,p=t.dataIdMap.get(d.dataId).id,c=ft(l,p,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=pt(t,c);return t.wasm._free(h),[t.makeOutput([f],"int32",m),t.makeOutput([],"int32",b)]}};let bt;const _t={kernelName:t.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){bt=e.wasm.cwrap(t.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,softNmsSigma:i}=a,{boxes:o,scores:d}=n,l=t.dataIdMap.get(o.dataId).id,p=t.dataIdMap.get(d.dataId).id,c=bt(l,p,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=pt(t,c);return t.wasm._free(b),[t.makeOutput([f],"int32",m),t.makeOutput([f],"float32",h)]}},yt=k(t.NotEqual,0,"bool");let gt;const kt={kernelName:t.OneHot,backendName:"wasm",setupFunc:function(e){gt=e.wasm.cwrap(t.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{indices:r}=t,{dtype:s,depth:u,onValue:i,offValue:o}=a,d=n.makeOutput([...r.shape,u],s),l=n.dataIdMap.get(d.dataId).id,p=n.dataIdMap.get(r.dataId).id;return gt(p,u,i,o,l),d}};const wt={kernelName:t.OnesLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(1),a}};const It={kernelName:t.Pack,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{axis:s}=r;if(1===n.length)return we({inputs:{input:n[0]},backend:a,attrs:{dim:s}});const u=n[0].shape,i=n[0].dtype;n.forEach((e=>{t.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),t.util.assert(i===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const o=[],d=Y({inputs:n.map((e=>{const t=we({inputs:{input:e},backend:a,attrs:{dim:s}});return o.push(t),t})),backend:a,attrs:{axis:s}});return o.forEach((e=>a.disposeData(e.dataId))),d}};let St;const Mt={kernelName:t.PadV2,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:a,attrs:{paddings:r,constantValue:s}}=e,u=r.map(((e,t)=>e[0]+n.shape[t]+e[1]));if(0===t.util.sizeFromShape(n.shape))return Se({backend:a,attrs:{shape:u,value:s,dtype:n.dtype}});const i=a.dataIdMap.get(n.dataId).id,o=a.makeOutput(u,n.dtype),l=a.dataIdMap.get(o.dataId).id,p=new Uint8Array(new Int32Array(n.shape).buffer),c=r.map((e=>e[0])),m=r.map((e=>e[1])),f=new Uint8Array(new Int32Array(c).buffer),h=new Uint8Array(new Int32Array(m).buffer);return St(i,p,n.shape.length,d[n.dtype],f,h,s,l),o},setupFunc:function(e){St=e.wasm.cwrap(t.PadV2,null,["number","array","number","number","array","array","number","number"])}},At=k(t.Pow);let vt;const xt={kernelName:t.Prelu,backendName:"wasm",setupFunc:function(e){vt=e.wasm.cwrap(t.Prelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:a,alpha:r}=t,s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id;let i=s;const o=a;let d=o;"float32"!==o.dtype&&(d=K({backend:n,inputs:{x:a},attrs:{dtype:"float32"}}),i=n.dataIdMap.get(d.dataId).id);const l=n.makeOutput(a.shape,"float32"),p=n.dataIdMap.get(l.dataId).id;return vt(i,u,p),"float32"!==o.dtype&&n.disposeData(d.dataId),l}};let Ft;const Nt={kernelName:t.Prod,backendName:"wasm",setupFunc:function(e){Ft=e.wasm.cwrap(t.Prod,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,p=i;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=N(i,s,n);let b=m;if(h){const e=n.dataIdMap.get(c.dataId).id;e!==o&&(p=c,l=e,b=t.backend_util.getInnerMostAxes(b.length,p.shape.length))}t.backend_util.assertAxesAreInnerMostDims("prod",b,p.shape.length);const[_,y]=t.backend_util.computeOutAndReduceShapes(p.shape,b),g=t.util.sizeFromShape(y),k=n.makeOutput(_,p.dtype);if(0!==t.util.sizeFromShape(p.shape)){const e=n.dataIdMap.get(k.dataId).id;Ft(l,g,d[k.dtype],e)}if(h&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(k.shape,f);k.shape=e}return k}},Rt={kernelName:t.Range,backendName:"wasm",kernelFunc:e=>{const{backend:n,attrs:a}=e,{start:r,stop:s,step:u,dtype:i}=a,o=function(e,n,a,r){if(e===n||e<n&&a<0||n<e&&a>1)return t.util.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((n-e)/a)),u=t.util.makeZerosTypedArray(s,r);n<e&&1===a&&(a=-1),u[0]=e;for(let e=1;e<u.length;e++)u[e]=u[e-1]+a;return u}(r,s,u,i),d=n.makeOutput([o.length],i);return n.typedArrayFromHeap(d).set(o),d}},Et=k(t.RealDiv),Dt=y(t.Relu),Ot=y(t.Relu6);let Ct;const Tt={kernelName:t.ResizeBilinear,backendName:"wasm",setupFunc:function(e){Ct=e.wasm.cwrap(t.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[d,l]=o,[p,c,m,f]=s.shape,h=[p,d,l,f];let b,_=n.dataIdMap.get(s.dataId);"float32"!==_.dtype&&(b=K({backend:n,inputs:{x:s},attrs:{dtype:"float32"}}),_=n.dataIdMap.get(b.dataId));const y=_.id,g=n.makeOutput(h,"float32");if(0===t.util.sizeFromShape(s.shape))return g;const k=n.dataIdMap.get(g.dataId).id;return Ct(y,p,c,m,f,d,l,u?1:0,i?1:0,k),null!=b&&n.disposeData(b.dataId),g}};let Pt;const Wt={kernelName:t.ResizeNearestNeighbor,backendName:"wasm",setupFunc:function(e){Pt=e.wasm.cwrap(t.ResizeNearestNeighbor,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[d,l]=o,[p,c,m,f]=s.shape,h=[p,d,l,f],b=n.makeOutput(h,"float32");if(0===t.util.sizeFromShape(s.shape))return b;let _,y=n.dataIdMap.get(s.dataId);"float32"!==y.dtype&&(_=K({backend:n,inputs:{x:s},attrs:{dtype:"float32"}}),y=n.dataIdMap.get(_.dataId));const g=y.id,k=n.dataIdMap.get(b.dataId).id;return Pt(g,p,c,m,f,d,l,u?1:0,i?1:0,k),null!=_&&n.disposeData(_.dataId),b}};let zt;const jt={kernelName:t.Reverse,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{dims:u}=r,i=t.util.parseAxisParam(u,s.shape);if(0===s.shape.length)return M({inputs:{x:s},backend:a});const o=a.makeOutput(s.shape,s.dtype),d=a.dataIdMap.get(s.dataId).id,l=a.dataIdMap.get(o.dataId).id,p=new Uint8Array(new Int32Array(i).buffer),c=new Uint8Array(new Int32Array(s.shape).buffer);zt(d,p,i.length,c,s.shape.length,l);const m=z({inputs:{x:o},attrs:{shape:s.shape},backend:a});return a.disposeData(o.dataId),m},setupFunc:function(e){zt=e.wasm.cwrap(t.Reverse,null,["number","array","number","array","number","number"])}};let Lt;const Bt={kernelName:t.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{image:s}=n,{radians:u,fillValue:i,center:o}=r,d=a.makeOutput(s.shape,s.dtype),l=a.dataIdMap.get(s.dataId).id,p=a.dataIdMap.get(d.dataId).id,[c,m,f,h]=s.shape,[b,_]=t.backend_util.getImageCenter(o,m,f),y="number"==typeof i?[i,i,i,0===i?0:255]:[...i,255],g=new Uint8Array(new Int32Array(y).buffer);return Lt(l,c,m,f,h,u,b,_,g,y.length,p),d},setupFunc:function(e){Lt=e.wasm.cwrap(t.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},Ut=y(t.Round),qt=y(t.Rsqrt);let Ht;const Vt={kernelName:t.ScatterNd,backendName:"wasm",setupFunc:function(e){Ht=e.wasm.cwrap(t.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{indices:s,updates:u}=a,{shape:i}=r,o=n.makeOutput(i,u.dtype);if(0===t.util.sizeFromShape(i))return o;const{sliceRank:l,numUpdates:p,sliceSize:c,strides:m,outputSize:f}=t.scatter_util.calculateShapes(u,s,i),h=n.dataIdMap.get(s.dataId).id,b=n.dataIdMap.get(u.dataId).id,_=new Uint8Array(new Int32Array(m).buffer),y=n.dataIdMap.get(o.dataId).id;return Ht(h,b,d[u.dtype],l,p,c,_,f,y),o}};let Gt;const $t={kernelName:t.Select,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a}=e,{condition:r,t:s,e:u}=n,i=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(s.dataId).id,d=a.dataIdMap.get(u.dataId).id,l=a.makeOutput(s.shape,s.dtype),p=a.dataIdMap.get(l.dataId).id,c=r.shape.length,m=s.shape.length,f=0===c||c>1||1===m?1:t.util.sizeFromShape(s.shape.slice(1));return Gt(i,o,d,f,p),l},setupFunc:function(e){Gt=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}};let Kt;const Xt={kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){Kt=e.wasm.cwrap(t.Sigmoid,null,["number","number"])},kernelFunc:function(e){const{backend:n,inputs:{x:a}}=e,r=n.dataIdMap.get(a.dataId).id,s=n.makeOutput(a.shape,a.dtype),u=n.dataIdMap.get(s.dataId).id;return 0===t.util.sizeFromShape(s.shape)||Kt(r,u),s}},Qt=y(t.Sin);let Jt;const Zt={kernelName:t.Softmax,backendName:"wasm",setupFunc:function(e){Jt=e.wasm.cwrap(t.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:{logits:a},attrs:{dim:r}}=e,s=n.dataIdMap.get(a.dataId).id,u=n.makeOutput(a.shape,a.dtype),i=n.dataIdMap.get(u.dataId).id,o=a.shape[r],d=t.util.sizeFromShape(a.shape)/o;return 0===t.util.sizeFromShape(u.shape)||Jt(s,i,o,d),u}};const Yt={kernelName:t.SpaceToBatchND,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{blockShape:u,paddings:i}=r,o=t.util.sizeFromShape(u),d=[[0,0]];d.push(...i);for(let e=1+u.length;e<s.shape.length;++e)d.push([0,0]);const l=Mt.kernelFunc({inputs:{x:s},backend:a,attrs:{paddings:d,constantValue:0}}),p=t.backend_util.getReshaped(l.shape,u,o,!1),c=t.backend_util.getPermuted(p.length,u.length,!1),m=t.backend_util.getReshapedPermuted(l.shape,u,o,!1),f=z({inputs:{x:l},backend:a,attrs:{shape:p}}),h=x({inputs:{x:f},backend:a,attrs:{perm:c}}),b=z({inputs:{x:h},backend:a,attrs:{shape:m}});return a.disposeData(l.dataId),a.disposeData(f.dataId),a.disposeData(h.dataId),b}};let en;const tn={kernelName:t.SparseFillEmptyRows,backendName:"wasm",setupFunc:function(e){en=e.wasm.cwrap("SparseFillEmptyRows","number",["number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a}=e,{indices:r,values:s,denseShape:u,defaultValue:i}=a,o=r.shape[0],l=r.shape[1],p=n.readSync(u.dataId)[0],c=[o+p,l],m=n.dataIdMap.get(r.dataId).id,f=n.dataIdMap.get(s.dataId).id,h=n.dataIdMap.get(i.dataId).id,b=n.makeOutput(c,r.dtype),_=n.dataIdMap.get(b.dataId).id,y=n.makeOutput(c.slice(0,1),s.dtype),g=n.dataIdMap.get(y.dataId).id,k=n.makeOutput([p],"bool"),w=n.dataIdMap.get(k.dataId).id,I=n.makeOutput([o],r.dtype),S=n.dataIdMap.get(I.dataId).id,M=n.makeOutput([4],"int32"),A=n.dataIdMap.get(M.dataId).id,v=en(m,f,d[s.dtype],o,p,l,h,_,g,w,S,A),x=n.readSync(M.dataId);let F;switch(x[0]){case 1:F=t.backend_util.getSparseFillEmptyRowsIndicesDenseShapeMismatch(x[1]);break;case 2:F=t.backend_util.getSparseFillEmptyRowsNegativeIndexErrorMessage(x[1],x[2]);break;case 3:F=t.backend_util.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(x[1],x[2],x[3]);break;default:F=""}if(n.disposeData(M.dataId),F)throw n.disposeData(b.dataId),n.disposeData(y.dataId),n.disposeData(k.dataId),n.disposeData(I.dataId),new Error(F);let N=b,R=y;return v!==c[0]&&(N=V({inputs:{x:b},attrs:{begin:0,size:[v,l]},backend:n}),R=V({inputs:{x:y},attrs:{begin:0,size:v},backend:n}),n.disposeData(b.dataId),n.disposeData(y.dataId)),[N,R,k,I]}};let nn;const an={kernelName:t.SparseReshape,backendName:"wasm",setupFunc:function(e){nn=e.wasm.cwrap(t.SparseReshape,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a}=e,{inputIndices:r,inputShape:s,newShape:u}=a;if(2!==r.shape.length)throw new Error(`Input indices should be a matrix but received shape\n        ${r.shape}`);if(1!==s.shape.length)throw new Error(`Input shape should be a vector but received shape\n        ${s.shape}`);if(1!==u.shape.length)throw new Error(`Target shape should be a vector but received shape ${u.shape}`);const i=n.dataIdMap.get(r.dataId).id,o=n.dataIdMap.get(s.dataId).id,d=n.dataIdMap.get(u.dataId).id,l=r.shape[0],p=t.util.sizeFromShape(u.shape),c=n.makeOutput([l,p],r.dtype),m=n.dataIdMap.get(c.dataId).id,f=n.makeOutput([p],u.dtype),h=n.dataIdMap.get(f.dataId).id,b=n.makeOutput([3],"int32"),_=n.dataIdMap.get(b.dataId).id;nn(i,o,d,l,m,h,_);const y=n.readSync(b.dataId);let g;switch(y[0]){case 0:g=t.backend_util.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(y[1],y[2]);break;case 1:g=t.backend_util.getSparseReshapeNegativeOutputDimErrorMessage(y[1],y[2]);break;case 2:g=t.backend_util.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage();break;case 3:{const e=Array.from(n.readSync(s.dataId)),a=Array.from(n.readSync(f.dataId));g=t.backend_util.getSparseReshapeInputOutputMultipleErrorMessage(e,a);break}case 4:{const e=Array.from(n.readSync(s.dataId)),a=Array.from(n.readSync(f.dataId));g=t.backend_util.getSparseReshapeInputOutputMismatchErrorMessage(e,a);break}default:g=""}if(n.disposeData(b.dataId),g)throw n.disposeData(c.dataId),n.disposeData(f.dataId),new Error(g);return[c,f]}};let rn;function sn(e){rn=e.wasm.cwrap("SparseSegmentReduction",null,["number","number","number","number","number","number","number","number","number"])}function un(e,n){const{backend:a,inputs:r}=e,{data:s,indices:u,segmentIds:i}=r,o=u.shape[0],l=a.readSync(i.dataId,o-1,o)[0],p=o>0?l+1:0;if(p<0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const c=s.shape.slice();c[0]=p;const m=a.dataIdMap.get(s.dataId).id,f=a.dataIdMap.get(u.dataId).id,h=a.dataIdMap.get(i.dataId).id,b=a.makeOutput(c,s.dtype),_=a.dataIdMap.get(b.dataId).id,y=a.makeOutput([4],"int32"),g=a.dataIdMap.get(y.dataId).id;rn(m,d[s.dtype],s.shape[0],f,h,_,g,n,0);const k=a.readSync(y.dataId);let w;switch(k[0]){case 0:w=t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage();break;case 1:w=t.backend_util.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage();break;case 2:w=t.backend_util.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(k[1],k[2]);break;case 3:w=t.backend_util.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(k[1],k[2],k[3]);break;default:w=""}if(a.disposeData(y.dataId),w)throw a.disposeData(b.dataId),new Error(w);return b}const on={kernelName:t.SparseSegmentMean,backendName:"wasm",setupFunc:sn,kernelFunc:function(e){return un(e,!0)}};const dn={kernelName:t.SparseSegmentSum,backendName:"wasm",setupFunc:sn,kernelFunc:function(e){return un(e,!1)}};const ln={kernelName:t.SplitV,backendName:"wasm",kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s}=n,{numOrSizeSplits:u,axis:i}=a,o=t.util.parseAxisParam(i,s.shape)[0],d=t.backend_util.prepareSplitSize(s,u,o),l=new Array(s.shape.length).fill(0),p=s.shape.slice();return d.map((e=>{const t=[...p];t[o]=e;const n=V({inputs:{x:s},attrs:{begin:l,size:t},backend:r});return l[o]+=e,n}))}},pn=y(t.Sqrt),cn=y(t.Square),mn=k(t.SquaredDifference);let fn;const hn={kernelName:t.Step,backendName:"wasm",setupFunc:function(e){fn=e.wasm.cwrap(t.Step,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{alpha:r}=a,{x:s}=n,u=t.dataIdMap.get(s.dataId).id,i=t.makeOutput(s.shape,s.dtype),o=t.dataIdMap.get(i.dataId).id;return fn(u,r,d[s.dtype],o),i}};let bn;const _n={kernelName:t.StridedSlice,backendName:"wasm",setupFunc:function(e){bn=e.wasm.cwrap(t.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s}=a,{begin:u,end:i,strides:o,beginMask:d,endMask:l,ellipsisMask:p,newAxisMask:c,shrinkAxisMask:m}=r,{finalShapeSparse:f,finalShape:h,isIdentity:b,sliceDim0:_,isSimpleSlice:y,begin:g,end:k,strides:w}=t.slice_util.sliceInfo(s.shape,u,i,o,d,l,p,c,m);let I;if(b)I=z({inputs:{x:s},backend:n,attrs:{shape:h}});else if(_||y){t.util.assert(s.shape.length>=1,(()=>`Input must have rank at least 1, got: ${s.shape.length}`));const e=t.slice_util.computeOutShape(g,k,w),a=V({inputs:{x:s},backend:n,attrs:{begin:g,size:e}});I=z({inputs:{x:a},backend:n,attrs:{shape:h}}),n.disposeData(a.dataId)}else{const e=n.makeOutput(f,"float32"),a=n.dataIdMap.get(s.dataId).id,r=new Uint8Array(new Int32Array(t.util.computeStrides(s.shape)).buffer),u=new Uint8Array(new Int32Array(g).buffer),i=new Uint8Array(new Int32Array(k).buffer),o=new Uint8Array(new Int32Array(w).buffer),d=new Uint8Array(new Int32Array(f).buffer),l=new Uint8Array(new Int32Array(t.util.computeStrides(f)).buffer),p=n.dataIdMap.get(e.dataId).id;bn(a,r,s.shape.length,u,i,o,d,l,f.length,p),I=z({inputs:{x:e},backend:n,attrs:{shape:h}}),n.disposeData(e.dataId)}return I}};const yn={kernelName:t.StringNGrams,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{data:r,dataSplits:s}=n,{separator:u,nGramWidths:i,leftPad:o,rightPad:d,padWidth:l,preserveShortSequences:p}=a,c=t.readSync(r.dataId),m=t.readSync(s.dataId),[f,h]=function(e,t,n,a,r,s,u,i){return new q(n,a,r,s,u,i).compute(e,t)}(c,m,u,i,o,d,l,p),b=t.makeOutput([f.length],"string");t.dataIdMap.get(b.dataId).stringBytes=f;const _=t.makeOutput(s.shape,"int32");return t.typedArrayFromHeap(_).set(h),[b,_]}};const gn={kernelName:t.StringSplit,backendName:"wasm",kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{input:s,delimiter:u}=a,{skipEmpty:i}=r,o=n.readSync(s.dataId),d=n.readSync(u.dataId),[l,p,c]=function(e,n,a){const r=e.length,s=[];let u=0,i=0;const o=new Array(r);for(let t=0;t<r;++t){const r=s.length;H(e[t],n,a,s);const d=s.length-r;o[t]=d,u+=d,i=Math.max(i,d)}const d=t.util.getArrayFromDType("int32",2*u),l=new Array(u),p=[r,i];let c=0;for(let e=0;e<r;++e)for(let t=0;t<o[e];++t)d[2*c]=e,d[2*c+1]=t,l[c]=s[c],++c;return[d,l,p]}(o,d[0],i),m=p.length,f=n.makeOutput([m,2],"int32");n.typedArrayFromHeap(f).set(l);const h=n.makeOutput([m],"string");n.dataIdMap.get(h.dataId).stringBytes=p;const b=n.makeOutput([2],"int32");return n.typedArrayFromHeap(b).set(c),[f,h,b]}};const kn={kernelName:t.StringToHashBucketFast,backendName:"wasm",kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{input:s}=a,{numBuckets:u}=r,i=function(e,n){const a=t.util.getArrayFromDType("int32",e.length);for(let r=0;r<e.length;++r)a[r]=t.util.fingerPrint64(e[r]).modulo(n).getLowBitsUnsigned();return a}(n.readSync(s.dataId),u),o=n.makeOutput(s.shape,"int32");return n.typedArrayFromHeap(o).set(i),o}},wn=k(t.Sub);let In;const Sn={kernelName:t.Sum,backendName:"wasm",setupFunc:function(e){In=e.wasm.cwrap(t.Sum,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,p=i;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=N(i,s,n);let b=m;if(h){const e=n.dataIdMap.get(c.dataId).id;e!==o&&(p=c,l=e,b=t.backend_util.getInnerMostAxes(b.length,p.shape.length))}t.backend_util.assertAxesAreInnerMostDims("sum",b,p.shape.length);const[_,y]=t.backend_util.computeOutAndReduceShapes(p.shape,b),g=t.util.sizeFromShape(y),k=n.makeOutput(_,p.dtype);if(0!==t.util.sizeFromShape(p.shape)){const e=n.dataIdMap.get(k.dataId).id;In(l,g,d[k.dtype],e)}if(h&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(k.shape,f);k.shape=e}return k}},Mn=y(t.Tan),An=y(t.Tanh);let vn;const xn={kernelName:t.Tile,backendName:"wasm",setupFunc:function(e){vn=e.wasm.cwrap(t.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,s=n.dataIdMap.get(r.dataId).id,{reps:u}=a,i=new Array(r.shape.length);for(let e=0;e<i.length;e++)i[e]=r.shape[e]*u[e];const o=new Uint8Array(new Int32Array(r.shape).buffer),l=new Uint8Array(new Int32Array(i).buffer),p=n.makeOutput(i,r.dtype),c=n.dataIdMap.get(p.dataId).id;return vn(s,o,r.shape.length,l,i.length,d[p.dtype],c),p}};let Fn;const Nn={kernelName:t.TopK,backendName:"wasm",setupFunc:function(e){Fn=e.wasm.cwrap(t.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:t,attrs:n})=>{const{x:a}=e,{k:r,sorted:s}=n,u=t.dataIdMap.get(a.dataId).id,i=new Uint8Array(new Int32Array(a.shape).buffer),o=a.shape.slice();o[o.length-1]=r;const l=t.makeOutput(o,a.dtype),p=t.dataIdMap.get(l.dataId).id,c=t.makeOutput(o,"int32"),m=t.dataIdMap.get(c.dataId).id;return Fn(u,i,a.shape.length,d[a.dtype],r,s,p,m),[l,c]}};let Rn;const En={kernelName:t.Transform,backendName:"wasm",setupFunc:function(e){Rn=e.wasm.cwrap(t.Transform,null,["number","number","bool","number","number","number","number","number","number","array","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{image:s,transforms:u}=a,{interpolation:i,fillMode:o,fillValue:d,outputShape:l}=r,[p,c,m,f]=s.shape,[h,b]=null!=l?l:[c,m],_=[p,h,b,f],y=new Uint8Array(new Int32Array(t.util.computeStrides(s.shape)).buffer),g=new Uint8Array(new Int32Array(t.util.computeStrides(_)).buffer),k=n.makeOutput(_,s.dtype),w=n.dataIdMap.get(k.dataId).id,I=n.dataIdMap.get(s.dataId).id,S=n.dataIdMap.get(u.dataId).id,M="nearest"===i?1:2;let A;switch(o){case"constant":default:A=1;break;case"reflect":A=2;break;case"wrap":A=3;break;case"nearest":A=4}return Rn(I,S,u.shape[0]>1,p,h,b,f,m,c,y,s.shape.length-1,g,_.length-1,M,A,d,w),k}};const Dn={kernelName:t.Unpack,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{value:r}=t;let{axis:s}=a;s<0&&(s+=r.shape.length);const u=r.shape[s],i=r.shape.length,o=new Array(i-1);let d=0;for(let e=0;e<i;e++)e!==s&&(o[d++]=r.shape[e]);const l=new Array(u),p=new Array(i).fill(0),c=r.shape.slice();c[s]=1;for(let e=0;e<l.length;e++)p[s]=e,l[e]=V({inputs:{x:r},attrs:{begin:p,size:c},backend:n});return l.map((({dataId:e,dtype:t})=>({dataId:e,dtype:t,shape:o})))}};const On={kernelName:t.ZerosLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(0),a}},Cn=[_,g,w,S,E,O,T,W,B,$,X,Q,Z,ee,ne,re,se,ue,de,pe,me,he,_e,ye,ge,ke,Ie,Me,ve,xe,Fe,Re,De,Ce,Pe,ze,je,Le,A,Ue,qe,He,Ve,Ge,$e,Ke,Xe,Je,Ze,et,nt,rt,st,ot,dt,lt,mt,ht,_t,yt,kt,wt,It,Mt,At,xt,Nt,Rt,Et,Dt,Ot,j,Tt,Wt,jt,Bt,Ut,qt,Vt,$t,Xt,Qt,G,Zt,Yt,tn,an,on,dn,ln,pn,cn,mn,hn,_n,yn,gn,kn,wn,Sn,Mn,An,xn,Nn,En,F,Dn,On];for(const e of Cn)t.registerKernel(e);const Tn=t.env();Tn.registerFlag("WASM_HAS_SIMD_SUPPORT",(async()=>{try{return WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))}catch(e){return!1}})),Tn.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(async()=>{if(Tn.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}}));var Pn="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Wn(e){var t={exports:{}};return e(t,t.exports),t.exports}function zn(e){throw new Error('Could not dynamically require "'+e+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var jn=Wn((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){function t(){return C.buffer!=z&&$(C.buffer),j}function a(){return C.buffer!=z&&$(C.buffer),L}function r(){return C.buffer!=z&&$(C.buffer),B}function s(){return C.buffer!=z&&$(C.buffer),U}function u(){return C.buffer!=z&&$(C.buffer),q}var i,o,d,l="undefined"!=typeof(e=e||{})?e:{};l.ready=new Promise((function(e,t){i=e,o=t})),"undefined"!=typeof process&&process.listeners&&(d={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var b,_,y,g=Object.assign({},l),k=(e,t)=>{throw t},w="object"==typeof window,I="function"==typeof importScripts,S="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,M=l.ENVIRONMENT_IS_PTHREAD||!1,A="";function v(e){return l.locateFile?l.locateFile(e,A):A+e}if(S){var x,F;let e;A=I?p.default.dirname(A)+"/":__dirname+"/","function"==typeof zn&&(x=c.default,F=p.default),b=(e,t)=>(e=F.normalize(e),x.readFileSync(e,t?void 0:"utf8")),y=e=>{var t=b(e,!0);return t.buffer||(t=new Uint8Array(t)),t},_=(e,t,n)=>{e=F.normalize(e),x.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof de))throw e})),process.on("unhandledRejection",(function(e){throw e})),k=(e,t)=>{if(Y())throw process.exitCode=e,t;var n;(n=t)instanceof de||O("exiting due to exception: "+n),process.exit(e)},l.inspect=function(){return"[Emscripten Module object]"};try{e=m.default}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Pn.Worker=e.Worker}else(w||I)&&(I?A=self.location.href:"undefined"!=typeof document&&document.currentScript&&(A=document.currentScript.src),"undefined"!=typeof n&&n&&(A=n),A=0!==A.indexOf("blob:")?A.substr(0,A.replace(/[?#].*/,"").lastIndexOf("/")+1):"",S||(b=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},I&&(y=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),_=(e,t,n)=>{var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=()=>{200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)}));S&&"undefined"==typeof performance&&(Pn.performance=f.default.performance);var N=console.log.bind(console),R=console.warn.bind(console);S&&(N=e=>x.writeSync(1,e+"\n"),R=e=>x.writeSync(2,e+"\n"));var E,D=l.print||N,O=l.printErr||R;Object.assign(l,g),g=null,l.arguments,l.thisProgram,l.quit&&(k=l.quit),l.wasmBinary&&(E=l.wasmBinary);var C,T,P=l.noExitRuntime||!0;"object"!=typeof WebAssembly&&re("no native wasm support detected");var W,z,j,L,B,U,q,H=!1,V="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function G(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&V)return V.decode(e.buffer instanceof SharedArrayBuffer?e.slice(t,r):e.subarray(t,r));for(var s="";t<r;){var u=e[t++];if(128&u){var i=63&e[t++];if(192!=(224&u)){var o=63&e[t++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[t++])<65536)s+=String.fromCharCode(u);else{var d=u-65536;s+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function $(e){z=e,l.HEAP8=j=new Int8Array(e),l.HEAP16=new Int16Array(e),l.HEAP32=B=new Int32Array(e),l.HEAPU8=L=new Uint8Array(e),l.HEAPU16=new Uint16Array(e),l.HEAPU32=U=new Uint32Array(e),l.HEAPF32=new Float32Array(e),l.HEAPF64=q=new Float64Array(e)}M&&(z=l.buffer);var K,X=l.INITIAL_MEMORY||16777216;if(M)C=l.wasmMemory,z=l.buffer;else if(l.wasmMemory)C=l.wasmMemory;else if(!((C=new WebAssembly.Memory({initial:X/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw O("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),S&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");C&&(z=C.buffer),X=z.byteLength,$(z);var Q=[],J=[],Z=[];function Y(){return P}function ee(){M||he(J)}var te,ne=0,ae=null;function re(e){M?postMessage({cmd:"onAbort",arg:e}):l.onAbort&&l.onAbort(e),O(e="Aborted("+e+")"),H=!0,W=1,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw o(t),t}function se(e){return e.startsWith("data:application/octet-stream;base64,")}function ue(e){return e.startsWith("file://")}function ie(e){try{if(e==te&&E)return new Uint8Array(E);if(y)return y(e);throw"both async and sync fetching of the wasm failed"}catch(e){re(e)}}se(te="tfjs-backend-wasm-threaded-simd.wasm")||(te=v(te));var oe={};function de(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function le(e){var t,n=fe.pthreads[e];n||re(t),fe.returnWorkerToPool(n)}function pe(e){var t=fe.getNewWorker();if(!t)return 6;fe.runningWorkers.push(t),fe.pthreads[e.pthread_ptr]=t,t.pthread_ptr=e.pthread_ptr;var n={cmd:"run",start_routine:e.startRoutine,arg:e.arg,pthread_ptr:e.pthread_ptr};return t.runPthread=()=>{n.time=performance.now(),t.postMessage(n,e.transferList)},t.loaded&&(t.runPthread(),delete t.runPthread),0}function ce(e){if(M)return Me(1,1,e);W=e,Y()||(fe.terminateAllThreads(),l.onExit&&l.onExit(e),H=!0),k(e,new de(e))}var me=function(e,t){if(W=e,!t&&M)throw _e(e),"unwind";ce(e)},fe={unusedWorkers:[],runningWorkers:[],tlsInitFunctions:[],pthreads:{},init:function(){M?fe.initWorker():fe.initMainThread()},initMainThread:function(){for(var e=8;e--;)fe.allocateUnusedWorker()},initWorker:function(){P=!1},setExitStatus:function(e){W=e},terminateAllThreads:function(){for(var e of Object.values(fe.pthreads))fe.returnWorkerToPool(e);for(var e of fe.unusedWorkers)e.terminate();fe.unusedWorkers=[]},returnWorkerToPool:function(e){var t=e.pthread_ptr;delete fe.pthreads[t],fe.unusedWorkers.push(e),fe.runningWorkers.splice(fe.runningWorkers.indexOf(e),1),e.pthread_ptr=0,qe(t)},receiveObjectTransfer:function(e){},threadInitTLS:function(){fe.tlsInitFunctions.forEach((e=>e()))},loadWasmModuleToWorker:function(e,t){e.onmessage=n=>{var a,r=n.data,s=r.cmd;if(e.pthread_ptr&&(fe.currentProxiedOperationCallerThread=e.pthread_ptr),r.targetThread&&r.targetThread!=Pe()){var u=fe.pthreads[r.targetThread];return u?u.postMessage(r,r.transferList):O('Internal error! Worker sent a message "'+s+'" to target pthread '+r.targetThread+", but that thread no longer exists!"),void(fe.currentProxiedOperationCallerThread=void 0)}"processProxyingQueue"===s?Ie(r.queue):"spawnThread"===s?pe(r):"cleanupThread"===s?le(r.thread):"killThread"===s?function(e){var t=fe.pthreads[e];delete fe.pthreads[e],t.terminate(),qe(e),fe.runningWorkers.splice(fe.runningWorkers.indexOf(t),1),t.pthread_ptr=0}(r.thread):"cancelThread"===s?(a=r.thread,fe.pthreads[a].postMessage({cmd:"cancel"})):"loaded"===s?(e.loaded=!0,t&&t(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===s?D("Thread "+r.threadId+": "+r.text):"printErr"===s?O("Thread "+r.threadId+": "+r.text):"alert"===s?alert("Thread "+r.threadId+": "+r.text):"setimmediate"===r.target?e.postMessage(r):"onAbort"===s?l.onAbort&&l.onAbort(r.arg):s&&O("worker sent an unknown command "+s),fe.currentProxiedOperationCallerThread=void 0},e.onerror=e=>{throw O("worker sent an error! "+e.filename+":"+e.lineno+": "+e.message),e},S&&(e.on("message",(function(t){e.onmessage({data:t})})),e.on("error",(function(t){e.onerror(t)})),e.on("detachedExit",(function(){}))),e.postMessage({cmd:"load",urlOrBlob:l.mainScriptUrlOrBlob||n,wasmMemory:C,wasmModule:T})},allocateUnusedWorker:function(){var e=v("tfjs-backend-wasm-threaded-simd.worker.js");fe.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==fe.unusedWorkers.length&&(fe.allocateUnusedWorker(),fe.loadWasmModuleToWorker(fe.unusedWorkers[0])),fe.unusedWorkers.pop()}};function he(e){for(;e.length>0;)e.shift()(l)}function be(e){var t=Ge(),n=e();return $e(t),n}function _e(e){if(M)return Me(2,0,e);try{me(e)}catch(e){!function(e){if(e instanceof de||"unwind"==e)return W;k(1,e)}(e)}}l.PThread=fe,l.establishStackSpace=function(){var e=Pe(),t=r()[e+44>>2],n=r()[e+48>>2];Ve(t,t-n),$e(t)};var ye,ge=[];function ke(e,t,n,a){return M?Me(3,1,e,t,n,a):we(e,t,n,a)}function we(e,t,n,a){if("undefined"==typeof SharedArrayBuffer)return O("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;var r=[];if(M&&0===r.length)return ke(e,t,n,a);var s={startRoutine:n,pthread_ptr:e,arg:a,transferList:r};return M?(s.cmd="spawnThread",postMessage(s,r),0):pe(s)}function Ie(e){Atomics.store(r(),e>>2,1),Pe()&&Ue(e),Atomics.compareExchange(r(),e>>2,1,0)}function Se(e){Se.shown||(Se.shown={}),Se.shown[e]||(Se.shown[e]=1,S&&(e="warning: "+e),O(e))}function Me(e,t){var n=arguments.length-2,a=arguments;return be((()=>{for(var r=n,s=Ke(8*r),i=s>>3,o=0;o<n;o++){var d=a[2+o];u()[i+o]=d}return ze(e,r,s,t)}))}l.invokeEntryPoint=function(e,t){var n,a,r=((a=ge[n=e])||(n>=ge.length&&(ge.length=n+1),ge[n]=a=K.get(n)),a)(t);Y()?fe.setExitStatus(r):He(r)},l.executeNotifiedProxyingQueue=Ie,ye=S?()=>{var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:M?()=>performance.now()-l.__performance_now_clock_drift:()=>performance.now();var Ae=[];function ve(e){try{return C.grow(e-z.byteLength+65535>>>16),$(C.buffer),1}catch(e){}}function xe(e){return M?Me(4,1,e):52}function Fe(e,t,n,a,r){return M?Me(5,1,e,t,n,a,r):70}var Ne=[null,[],[]];function Re(e,t){var n=Ne[e];0===t||10===t?((1===e?D:O)(G(n,0)),n.length=0):n.push(t)}function Ee(e,t,n,r){if(M)return Me(6,1,e,t,n,r);for(var u=0,i=0;i<n;i++){var o=s()[t>>2],d=s()[t+4>>2];t+=8;for(var l=0;l<d;l++)Re(e,a()[o+l]);u+=d}return s()[r>>2]=u,0}function De(e){return l["_"+e]}function Oe(e,n,r,s,u){var i={string:e=>{var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,s=0;s<e.length;++s){var u=e.charCodeAt(s);if(u>=55296&&u<=57343&&(u=65536+((1023&u)<<10)|1023&e.charCodeAt(++s)),u<=127){if(n>=r)break;t[n++]=u}else if(u<=2047){if(n+1>=r)break;t[n++]=192|u>>6,t[n++]=128|63&u}else if(u<=65535){if(n+2>=r)break;t[n++]=224|u>>12,t[n++]=128|u>>6&63,t[n++]=128|63&u}else{if(n+3>=r)break;t[n++]=240|u>>18,t[n++]=128|u>>12&63,t[n++]=128|u>>6&63,t[n++]=128|63&u}}t[n]=0}(e,a(),t,n)}(e,t=Ke(n),n)}return t},array:e=>{var n=Ke(e.length);return function(e,n){t().set(e,n)}(e,n),n}};function o(e){return"string"===n?(t=e)?G(a(),t,r):"":"boolean"===n?Boolean(e):e;var t,r}var d=De(e),l=[],p=0;if(s)for(var c=0;c<s.length;c++){var m=i[r[c]];m?(0===p&&(p=Ge()),l[c]=m(s[c])):l[c]=s[c]}var f=d.apply(null,l);return f=function(e){return 0!==p&&$e(p),o(e)}(f)}fe.init();var Ce=[null,ce,_e,ke,xe,Fe,Ee],Te={__emscripten_init_main_thread_js:function(e){We(e,!I,1,!w),fe.threadInitTLS()},__emscripten_thread_cleanup:function(e){M?postMessage({cmd:"cleanupThread",thread:e}):le(e)},__pthread_create_js:we,_emscripten_default_pthread_stack_size:function(){return 2097152},_emscripten_get_now_is_monotonic:function(){return!0},_emscripten_notify_task_queue:function(e,t,n,a){if(e==t)setTimeout((()=>Ie(a)));else if(M)postMessage({targetThread:e,cmd:"processProxyingQueue",queue:a});else{var r=fe.pthreads[e];if(!r)return;r.postMessage({cmd:"processProxyingQueue",queue:a})}return 1},_emscripten_set_offscreencanvas_size:function(e,t,n){return-1},abort:function(){re("")},emscripten_check_blocking_allowed:function(){S||I||Se("Blocking on the main thread is very dangerous, see https://emscripten.org/docs/porting/pthreads.html#blocking-on-the-main-browser-thread")},emscripten_date_now:function(){return Date.now()},emscripten_get_heap_max:function(){return 2147483648},emscripten_get_now:ye,emscripten_memcpy_big:function(e,t,n){a().copyWithin(e,t,t+n)},emscripten_num_logical_cores:function(){return S?h.default.cpus().length:navigator.hardwareConcurrency},emscripten_receive_on_main_thread_js:function(e,t,n){Ae.length=t;for(var a=n>>3,r=0;r<t;r++)Ae[r]=u()[a+r];return(e<0?oe[-e-1]:Ce[e]).apply(null,Ae)},emscripten_resize_heap:function(e){var t=a().length;if((e>>>=0)<=t)return!1;var n,r,s=2147483648;if(e>s)return!1;for(var u=1;u<=4;u*=2){var i=t*(1+.2/u);if(i=Math.min(i,e+100663296),ve(Math.min(s,(n=Math.max(e,i))+((r=65536)-n%r)%r)))return!0}return!1},emscripten_unwind_to_js_event_loop:function(){throw"unwind"},exit:me,fd_close:xe,fd_seek:Fe,fd_write:Ee,memory:C||l.wasmMemory};!function(){var e={env:Te,wasi_snapshot_preview1:Te};function t(e,t){var n,a,r=e.exports;if(l.asm=r,n=l.asm._emscripten_tls_init,fe.tlsInitFunctions.push(n),K=l.asm.__indirect_function_table,a=l.asm.__wasm_call_ctors,J.unshift(a),T=t,!M){var s=fe.unusedWorkers.length;fe.unusedWorkers.forEach((function(e){fe.loadWasmModuleToWorker(e,(function(){--s||function(e){if(ne--,l.monitorRunDependencies&&l.monitorRunDependencies(ne),0==ne&&ae){var t=ae;ae=null,t()}}()}))}))}}function n(e){t(e.instance,e.module)}function a(t){return function(){if(!E&&(w||I)){if("function"==typeof fetch&&!ue(te))return fetch(te,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+te+"'";return e.arrayBuffer()})).catch((function(){return ie(te)}));if(_)return new Promise((function(e,t){_(te,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return ie(te)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){O("failed to asynchronously prepare wasm: "+e),re(e)}))}if(M||(ne++,l.monitorRunDependencies&&l.monitorRunDependencies(ne)),l.instantiateWasm)try{return l.instantiateWasm(e,t)}catch(e){O("Module.instantiateWasm callback failed with error: "+e),o(e)}(E||"function"!=typeof WebAssembly.instantiateStreaming||se(te)||ue(te)||S||"function"!=typeof fetch?a(n):fetch(te,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return O("wasm streaming compile failed: "+e),O("falling back to ArrayBuffer instantiation"),a(n)}))}))).catch(o)}(),l.___wasm_call_ctors=function(){return(l.___wasm_call_ctors=l.asm.__wasm_call_ctors).apply(null,arguments)},l._init=function(){return(l._init=l.asm.init).apply(null,arguments)},l._init_with_threads_count=function(){return(l._init_with_threads_count=l.asm.init_with_threads_count).apply(null,arguments)},l._get_threads_count=function(){return(l._get_threads_count=l.asm.get_threads_count).apply(null,arguments)},l._register_tensor=function(){return(l._register_tensor=l.asm.register_tensor).apply(null,arguments)},l._dispose_data=function(){return(l._dispose_data=l.asm.dispose_data).apply(null,arguments)},l._dispose=function(){return(l._dispose=l.asm.dispose).apply(null,arguments)},l._Abs=function(){return(l._Abs=l.asm.Abs).apply(null,arguments)},l._Add=function(){return(l._Add=l.asm.Add).apply(null,arguments)},l._AddN=function(){return(l._AddN=l.asm.AddN).apply(null,arguments)},l._All=function(){return(l._All=l.asm.All).apply(null,arguments)},l._Any=function(){return(l._Any=l.asm.Any).apply(null,arguments)},l._ArgMax=function(){return(l._ArgMax=l.asm.ArgMax).apply(null,arguments)},l._AvgPool=function(){return(l._AvgPool=l.asm.AvgPool).apply(null,arguments)},l._BatchMatMul=function(){return(l._BatchMatMul=l.asm.BatchMatMul).apply(null,arguments)},l._Ceil=function(){return(l._Ceil=l.asm.Ceil).apply(null,arguments)},l._ClipByValue=function(){return(l._ClipByValue=l.asm.ClipByValue).apply(null,arguments)},l._Conv2D=function(){return(l._Conv2D=l.asm.Conv2D).apply(null,arguments)},l._Conv2DBackpropInput=function(){return(l._Conv2DBackpropInput=l.asm.Conv2DBackpropInput).apply(null,arguments)},l._Cos=function(){return(l._Cos=l.asm.Cos).apply(null,arguments)},l._Cosh=function(){return(l._Cosh=l.asm.Cosh).apply(null,arguments)},l._CropAndResize=function(){return(l._CropAndResize=l.asm.CropAndResize).apply(null,arguments)},l._Cumprod=function(){return(l._Cumprod=l.asm.Cumprod).apply(null,arguments)},l._Cumsum=function(){return(l._Cumsum=l.asm.Cumsum).apply(null,arguments)},l._DepthToSpace=function(){return(l._DepthToSpace=l.asm.DepthToSpace).apply(null,arguments)},l._DepthwiseConv2dNative=function(){return(l._DepthwiseConv2dNative=l.asm.DepthwiseConv2dNative).apply(null,arguments)},l._Elu=function(){return(l._Elu=l.asm.Elu).apply(null,arguments)},l._Equal=function(){return(l._Equal=l.asm.Equal).apply(null,arguments)},l._Exp=function(){return(l._Exp=l.asm.Exp).apply(null,arguments)},l._FlipLeftRight=function(){return(l._FlipLeftRight=l.asm.FlipLeftRight).apply(null,arguments)},l._Floor=function(){return(l._Floor=l.asm.Floor).apply(null,arguments)},l._FloorDiv=function(){return(l._FloorDiv=l.asm.FloorDiv).apply(null,arguments)},l._FusedBatchNorm=function(){return(l._FusedBatchNorm=l.asm.FusedBatchNorm).apply(null,arguments)},l._FusedConv2D=function(){return(l._FusedConv2D=l.asm.FusedConv2D).apply(null,arguments)},l._FusedDepthwiseConv2D=function(){return(l._FusedDepthwiseConv2D=l.asm.FusedDepthwiseConv2D).apply(null,arguments)},l._Gather=function(){return(l._Gather=l.asm.Gather).apply(null,arguments)},l._GatherNd=function(){return(l._GatherNd=l.asm.GatherNd).apply(null,arguments)},l._Greater=function(){return(l._Greater=l.asm.Greater).apply(null,arguments)},l._GreaterEqual=function(){return(l._GreaterEqual=l.asm.GreaterEqual).apply(null,arguments)},l._LeakyRelu=function(){return(l._LeakyRelu=l.asm.LeakyRelu).apply(null,arguments)},l._Less=function(){return(l._Less=l.asm.Less).apply(null,arguments)},l._LessEqual=function(){return(l._LessEqual=l.asm.LessEqual).apply(null,arguments)},l._Log=function(){return(l._Log=l.asm.Log).apply(null,arguments)},l._LogicalAnd=function(){return(l._LogicalAnd=l.asm.LogicalAnd).apply(null,arguments)},l._LogicalNot=function(){return(l._LogicalNot=l.asm.LogicalNot).apply(null,arguments)},l._LogicalOr=function(){return(l._LogicalOr=l.asm.LogicalOr).apply(null,arguments)},l._LogicalXor=function(){return(l._LogicalXor=l.asm.LogicalXor).apply(null,arguments)},l._Max=function(){return(l._Max=l.asm.Max).apply(null,arguments)},l._MaxPool=function(){return(l._MaxPool=l.asm.MaxPool).apply(null,arguments)},l._Maximum=function(){return(l._Maximum=l.asm.Maximum).apply(null,arguments)},l._Mean=function(){return(l._Mean=l.asm.Mean).apply(null,arguments)},l._Min=function(){return(l._Min=l.asm.Min).apply(null,arguments)},l._Minimum=function(){return(l._Minimum=l.asm.Minimum).apply(null,arguments)},l._MirrorPad=function(){return(l._MirrorPad=l.asm.MirrorPad).apply(null,arguments)},l._Multiply=function(){return(l._Multiply=l.asm.Multiply).apply(null,arguments)},l._Neg=function(){return(l._Neg=l.asm.Neg).apply(null,arguments)},l._NonMaxSuppressionV3=function(){return(l._NonMaxSuppressionV3=l.asm.NonMaxSuppressionV3).apply(null,arguments)},l._NonMaxSuppressionV4=function(){return(l._NonMaxSuppressionV4=l.asm.NonMaxSuppressionV4).apply(null,arguments)},l._NonMaxSuppressionV5=function(){return(l._NonMaxSuppressionV5=l.asm.NonMaxSuppressionV5).apply(null,arguments)},l._NotEqual=function(){return(l._NotEqual=l.asm.NotEqual).apply(null,arguments)},l._OneHot=function(){return(l._OneHot=l.asm.OneHot).apply(null,arguments)},l._PadV2=function(){return(l._PadV2=l.asm.PadV2).apply(null,arguments)},l._Pow=function(){return(l._Pow=l.asm.Pow).apply(null,arguments)},l._Prelu=function(){return(l._Prelu=l.asm.Prelu).apply(null,arguments)},l._Prod=function(){return(l._Prod=l.asm.Prod).apply(null,arguments)},l._RealDiv=function(){return(l._RealDiv=l.asm.RealDiv).apply(null,arguments)},l._Relu=function(){return(l._Relu=l.asm.Relu).apply(null,arguments)},l._Relu6=function(){return(l._Relu6=l.asm.Relu6).apply(null,arguments)},l._ResizeBilinear=function(){return(l._ResizeBilinear=l.asm.ResizeBilinear).apply(null,arguments)},l._ResizeNearestNeighbor=function(){return(l._ResizeNearestNeighbor=l.asm.ResizeNearestNeighbor).apply(null,arguments)},l._Reverse=function(){return(l._Reverse=l.asm.Reverse).apply(null,arguments)},l._RotateWithOffset=function(){return(l._RotateWithOffset=l.asm.RotateWithOffset).apply(null,arguments)},l._Round=function(){return(l._Round=l.asm.Round).apply(null,arguments)},l._Rsqrt=function(){return(l._Rsqrt=l.asm.Rsqrt).apply(null,arguments)},l._ScatterNd=function(){return(l._ScatterNd=l.asm.ScatterNd).apply(null,arguments)},l._SelectV2=function(){return(l._SelectV2=l.asm.SelectV2).apply(null,arguments)},l._Sigmoid=function(){return(l._Sigmoid=l.asm.Sigmoid).apply(null,arguments)},l._Sin=function(){return(l._Sin=l.asm.Sin).apply(null,arguments)},l._Softmax=function(){return(l._Softmax=l.asm.Softmax).apply(null,arguments)},l._SparseFillEmptyRows=function(){return(l._SparseFillEmptyRows=l.asm.SparseFillEmptyRows).apply(null,arguments)},l._SparseReshape=function(){return(l._SparseReshape=l.asm.SparseReshape).apply(null,arguments)},l._SparseSegmentReduction=function(){return(l._SparseSegmentReduction=l.asm.SparseSegmentReduction).apply(null,arguments)},l._Sqrt=function(){return(l._Sqrt=l.asm.Sqrt).apply(null,arguments)},l._Square=function(){return(l._Square=l.asm.Square).apply(null,arguments)},l._SquaredDifference=function(){return(l._SquaredDifference=l.asm.SquaredDifference).apply(null,arguments)},l._Step=function(){return(l._Step=l.asm.Step).apply(null,arguments)},l._StridedSlice=function(){return(l._StridedSlice=l.asm.StridedSlice).apply(null,arguments)},l._Sub=function(){return(l._Sub=l.asm.Sub).apply(null,arguments)},l._Sum=function(){return(l._Sum=l.asm.Sum).apply(null,arguments)},l._Tan=function(){return(l._Tan=l.asm.Tan).apply(null,arguments)},l._Tanh=function(){return(l._Tanh=l.asm.Tanh).apply(null,arguments)},l._Tile=function(){return(l._Tile=l.asm.Tile).apply(null,arguments)},l._TopK=function(){return(l._TopK=l.asm.TopK).apply(null,arguments)},l._Transform=function(){return(l._Transform=l.asm.Transform).apply(null,arguments)},l._Transpose=function(){return(l._Transpose=l.asm.Transpose).apply(null,arguments)},l.__FusedMatMul=function(){return(l.__FusedMatMul=l.asm._FusedMatMul).apply(null,arguments)},l._malloc=function(){return(l._malloc=l.asm.malloc).apply(null,arguments)},l._free=function(){return(l._free=l.asm.free).apply(null,arguments)},l.__emscripten_tls_init=function(){return(l.__emscripten_tls_init=l.asm._emscripten_tls_init).apply(null,arguments)};var Pe=l._pthread_self=function(){return(Pe=l._pthread_self=l.asm.pthread_self).apply(null,arguments)};l.___errno_location=function(){return(l.___errno_location=l.asm.__errno_location).apply(null,arguments)};var We=l.__emscripten_thread_init=function(){return(We=l.__emscripten_thread_init=l.asm._emscripten_thread_init).apply(null,arguments)};l.__emscripten_thread_crashed=function(){return(l.__emscripten_thread_crashed=l.asm._emscripten_thread_crashed).apply(null,arguments)},l._emscripten_main_thread_process_queued_calls=function(){return(l._emscripten_main_thread_process_queued_calls=l.asm.emscripten_main_thread_process_queued_calls).apply(null,arguments)},l._emscripten_main_browser_thread_id=function(){return(l._emscripten_main_browser_thread_id=l.asm.emscripten_main_browser_thread_id).apply(null,arguments)};var ze=l._emscripten_run_in_main_runtime_thread_js=function(){return(ze=l._emscripten_run_in_main_runtime_thread_js=l.asm.emscripten_run_in_main_runtime_thread_js).apply(null,arguments)};l._emscripten_dispatch_to_thread_=function(){return(l._emscripten_dispatch_to_thread_=l.asm.emscripten_dispatch_to_thread_).apply(null,arguments)};var je,Le,Be,Ue=l.__emscripten_proxy_execute_task_queue=function(){return(Ue=l.__emscripten_proxy_execute_task_queue=l.asm._emscripten_proxy_execute_task_queue).apply(null,arguments)},qe=l.__emscripten_thread_free_data=function(){return(qe=l.__emscripten_thread_free_data=l.asm._emscripten_thread_free_data).apply(null,arguments)},He=l.__emscripten_thread_exit=function(){return(He=l.__emscripten_thread_exit=l.asm._emscripten_thread_exit).apply(null,arguments)},Ve=l._emscripten_stack_set_limits=function(){return(Ve=l._emscripten_stack_set_limits=l.asm.emscripten_stack_set_limits).apply(null,arguments)},Ge=l.stackSave=function(){return(Ge=l.stackSave=l.asm.stackSave).apply(null,arguments)},$e=l.stackRestore=function(){return($e=l.stackRestore=l.asm.stackRestore).apply(null,arguments)},Ke=l.stackAlloc=function(){return(Ke=l.stackAlloc=l.asm.stackAlloc).apply(null,arguments)};function Xe(e){if(!(ne>0)){if(M)return i(l),ee(),void postMessage({cmd:"loaded"});!function(){if(l.preRun)for("function"==typeof l.preRun&&(l.preRun=[l.preRun]);l.preRun.length;)e=l.preRun.shift(),Q.unshift(e);var e;he(Q)}(),ne>0||(l.setStatus?(l.setStatus("Running..."),setTimeout((function(){setTimeout((function(){l.setStatus("")}),1),t()}),1)):t())}function t(){je||(je=!0,l.calledRun=!0,H||(ee(),i(l),l.onRuntimeInitialized&&l.onRuntimeInitialized(),function(){if(!M){if(l.postRun)for("function"==typeof l.postRun&&(l.postRun=[l.postRun]);l.postRun.length;)e=l.postRun.shift(),Z.unshift(e);var e;he(Z)}}()))}}if(l.dynCall_iijjiiii=function(){return(l.dynCall_iijjiiii=l.asm.dynCall_iijjiiii).apply(null,arguments)},l.dynCall_jiji=function(){return(l.dynCall_jiji=l.asm.dynCall_jiji).apply(null,arguments)},l.keepRuntimeAlive=Y,l.wasmMemory=C,l.cwrap=function(e,t,n,a){var r=(n=n||[]).every((e=>"number"===e||"boolean"===e));return"string"!==t&&r&&!a?De(e):function(){return Oe(e,t,n,arguments)}},l.ExitStatus=de,l.PThread=fe,ae=function e(){je||Xe(),je||(ae=e)},l.preInit)for("function"==typeof l.preInit&&(l.preInit=[l.preInit]);l.preInit.length>0;)l.preInit.pop()();if(Xe(),d&&(Le={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!d.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!d.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof WasmBackendModule)Be=WasmBackendModule;else{if("undefined"==typeof e)throw new Error("Could not find wasm module in post.js");Be=e}if(Le){var Qe=Be._dispose;Be._dispose=function(){Qe(),Le.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),Le.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a})),Ln=o({__proto__:null,default:jn},[jn]),Bn='"use strict";var Module={};var ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string";if(ENVIRONMENT_IS_NODE){var nodeWorkerThreads=require("worker_threads");var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",data=>onmessage({data:data}));var fs=require("fs");Object.assign(global,{self:global,require:require,Module:Module,location:{href:__filename},Worker:nodeWorkerThreads.Worker,importScripts:function(f){(0,eval)(fs.readFileSync(f,"utf8"))},postMessage:function(msg){parentPort.postMessage(msg)},performance:global.performance||{now:function(){return Date.now()}}})}var initializedJS=false;var pendingNotifiedProxyingQueues=[];function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");if(ENVIRONMENT_IS_NODE){fs.writeSync(2,text+"\n");return}console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;self.alert=threadAlert;Module["instantiateWasm"]=(info,receiveInstance)=>{var instance=new WebAssembly.Instance(Module["wasmModule"],info);receiveInstance(instance);Module["wasmModule"]=null;return instance.exports};self.onunhandledrejection=e=>{throw e.reason??e};self.onmessage=e=>{try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob=="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance})}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.pthread_ptr,0,0,1);Module["establishStackSpace"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].threadInitTLS();if(!initializedJS){pendingNotifiedProxyingQueues.forEach(queue=>{Module["executeNotifiedProxyingQueue"](queue)});pendingNotifiedProxyingQueues=[];initializedJS=true}try{Module["invokeEntryPoint"](e.data.start_routine,e.data.arg)}catch(ex){if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["keepRuntimeAlive"]()){}else{Module["__emscripten_thread_exit"](ex.status)}}else{throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["__emscripten_thread_exit"](-1)}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processProxyingQueue"){if(initializedJS){Module["executeNotifiedProxyingQueue"](e.data.queue)}else{pendingNotifiedProxyingQueues.push(e.data.queue)}}else if(e.data.cmd){err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){if(Module["__emscripten_thread_crashed"]){Module["__emscripten_thread_crashed"]()}throw ex}};',Un=Wn((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){var t,a,r,s="undefined"!=typeof(e=e||{})?e:{};s.ready=new Promise((function(e,n){t=e,a=n})),"undefined"!=typeof process&&process.listeners&&(r={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var u,i,o,d,l,m=Object.assign({},s),f="object"==typeof window,h="function"==typeof importScripts,b="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,_="";b?(_=h?p.default.dirname(_)+"/":__dirname+"/","function"==typeof zn&&(d=c.default,l=p.default),u=(e,t)=>(e=l.normalize(e),d.readFileSync(e,t?void 0:"utf8")),o=e=>{var t=u(e,!0);return t.buffer||(t=new Uint8Array(t)),t},i=(e,t,n)=>{e=l.normalize(e),d.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof B))throw e})),process.on("unhandledRejection",(function(e){throw e})),s.inspect=function(){return"[Emscripten Module object]"}):(f||h)&&(h?_=self.location.href:"undefined"!=typeof document&&document.currentScript&&(_=document.currentScript.src),n&&(_=n),_=0!==_.indexOf("blob:")?_.substr(0,_.replace(/[?#].*/,"").lastIndexOf("/")+1):"",u=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},h&&(o=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),i=(e,t,n)=>{var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=()=>{200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)});var y,g,k=s.print||console.log.bind(console),w=s.printErr||console.warn.bind(console);Object.assign(s,m),m=null,s.arguments,s.thisProgram,s.quit,s.wasmBinary&&(y=s.wasmBinary),s.noExitRuntime,"object"!=typeof WebAssembly&&W("no native wasm support detected");var I,S,M,A,v=!1,x="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function F(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&x)return x.decode(e.subarray(t,r));for(var s="";t<r;){var u=e[t++];if(128&u){var i=63&e[t++];if(192!=(224&u)){var o=63&e[t++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[t++])<65536)s+=String.fromCharCode(u);else{var d=u-65536;s+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function N(e){I=e,s.HEAP8=S=new Int8Array(e),s.HEAP16=new Int16Array(e),s.HEAP32=new Int32Array(e),s.HEAPU8=M=new Uint8Array(e),s.HEAPU16=new Uint16Array(e),s.HEAPU32=A=new Uint32Array(e),s.HEAPF32=new Float32Array(e),s.HEAPF64=new Float64Array(e)}s.INITIAL_MEMORY;var R,E,D=[],O=[],C=[],T=0,P=null;function W(e){s.onAbort&&s.onAbort(e),w(e="Aborted("+e+")"),v=!0,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw a(t),t}function z(e){return e.startsWith("data:application/octet-stream;base64,")}function j(e){return e.startsWith("file://")}function L(e){try{if(e==R&&y)return new Uint8Array(y);if(o)return o(e);throw"both async and sync fetching of the wasm failed"}catch(e){W(e)}}function B(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function U(e){for(;e.length>0;)e.shift()(s)}function q(e){try{return g.grow(e-I.byteLength+65535>>>16),N(g.buffer),1}catch(e){}}z(R="tfjs-backend-wasm.wasm")||(E=R,R=s.locateFile?s.locateFile(E,_):_+E);var H=[null,[],[]];function V(e,t){var n=H[e];0===t||10===t?((1===e?k:w)(F(n,0)),n.length=0):n.push(t)}function G(e){return s["_"+e]}function $(e,t,n,a,r){var s={string:e=>{var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,s=0;s<e.length;++s){var u=e.charCodeAt(s);if(u>=55296&&u<=57343&&(u=65536+((1023&u)<<10)|1023&e.charCodeAt(++s)),u<=127){if(n>=r)break;t[n++]=u}else if(u<=2047){if(n+1>=r)break;t[n++]=192|u>>6,t[n++]=128|63&u}else if(u<=65535){if(n+2>=r)break;t[n++]=224|u>>12,t[n++]=128|u>>6&63,t[n++]=128|63&u}else{if(n+3>=r)break;t[n++]=240|u>>18,t[n++]=128|u>>12&63,t[n++]=128|u>>6&63,t[n++]=128|63&u}}t[n]=0}(e,M,t,n)}(e,t=ee(n),n)}return t},array:e=>{var t=ee(e.length);return function(e,t){S.set(e,t)}(e,t),t}};function u(e){return"string"===t?(n=e)?F(M,n,a):"":"boolean"===t?Boolean(e):e;var n,a}var i=G(e),o=[],d=0;if(a)for(var l=0;l<a.length;l++){var p=s[n[l]];p?(0===d&&(d=Z()),o[l]=p(a[l])):o[l]=a[l]}var c=i.apply(null,o);return c=function(e){return 0!==d&&Y(d),u(e)}(c)}var K={abort:function(){W("")},emscripten_get_heap_max:function(){return 2147483648},emscripten_memcpy_big:function(e,t,n){M.copyWithin(e,t,t+n)},emscripten_resize_heap:function(e){var t,n,a=M.length,r=2147483648;if((e>>>=0)>r)return!1;for(var s=1;s<=4;s*=2){var u=a*(1+.2/s);if(u=Math.min(u,e+100663296),q(Math.min(r,(t=Math.max(e,u))+((n=65536)-t%n)%n)))return!0}return!1},fd_close:function(e){return 52},fd_seek:function(e,t,n,a,r){return 70},fd_write:function(e,t,n,a){for(var r=0,s=0;s<n;s++){var u=A[t>>2],i=A[t+4>>2];t+=8;for(var o=0;o<i;o++)V(e,M[u+o]);r+=i}return A[a>>2]=r,0}};!function(){var e={env:K,wasi_snapshot_preview1:K};function t(e,t){var n,a=e.exports;s.asm=a,N((g=s.asm.memory).buffer),s.asm.__indirect_function_table,n=s.asm.__wasm_call_ctors,O.unshift(n),function(e){if(T--,s.monitorRunDependencies&&s.monitorRunDependencies(T),0==T&&P){var t=P;P=null,t()}}()}function n(e){t(e.instance)}function r(t){return function(){if(!y&&(f||h)){if("function"==typeof fetch&&!j(R))return fetch(R,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+R+"'";return e.arrayBuffer()})).catch((function(){return L(R)}));if(i)return new Promise((function(e,t){i(R,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return L(R)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){w("failed to asynchronously prepare wasm: "+e),W(e)}))}if(T++,s.monitorRunDependencies&&s.monitorRunDependencies(T),s.instantiateWasm)try{return s.instantiateWasm(e,t)}catch(e){w("Module.instantiateWasm callback failed with error: "+e),a(e)}(y||"function"!=typeof WebAssembly.instantiateStreaming||z(R)||j(R)||b||"function"!=typeof fetch?r(n):fetch(R,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return w("wasm streaming compile failed: "+e),w("falling back to ArrayBuffer instantiation"),r(n)}))}))).catch(a)}(),s.___wasm_call_ctors=function(){return(s.___wasm_call_ctors=s.asm.__wasm_call_ctors).apply(null,arguments)},s._init=function(){return(s._init=s.asm.init).apply(null,arguments)},s._init_with_threads_count=function(){return(s._init_with_threads_count=s.asm.init_with_threads_count).apply(null,arguments)},s._get_threads_count=function(){return(s._get_threads_count=s.asm.get_threads_count).apply(null,arguments)},s._register_tensor=function(){return(s._register_tensor=s.asm.register_tensor).apply(null,arguments)},s._dispose_data=function(){return(s._dispose_data=s.asm.dispose_data).apply(null,arguments)},s._dispose=function(){return(s._dispose=s.asm.dispose).apply(null,arguments)},s._Abs=function(){return(s._Abs=s.asm.Abs).apply(null,arguments)},s._Add=function(){return(s._Add=s.asm.Add).apply(null,arguments)},s._AddN=function(){return(s._AddN=s.asm.AddN).apply(null,arguments)},s._All=function(){return(s._All=s.asm.All).apply(null,arguments)},s._Any=function(){return(s._Any=s.asm.Any).apply(null,arguments)},s._ArgMax=function(){return(s._ArgMax=s.asm.ArgMax).apply(null,arguments)},s._AvgPool=function(){return(s._AvgPool=s.asm.AvgPool).apply(null,arguments)},s._BatchMatMul=function(){return(s._BatchMatMul=s.asm.BatchMatMul).apply(null,arguments)},s._Ceil=function(){return(s._Ceil=s.asm.Ceil).apply(null,arguments)},s._ClipByValue=function(){return(s._ClipByValue=s.asm.ClipByValue).apply(null,arguments)},s._Conv2D=function(){return(s._Conv2D=s.asm.Conv2D).apply(null,arguments)},s._Conv2DBackpropInput=function(){return(s._Conv2DBackpropInput=s.asm.Conv2DBackpropInput).apply(null,arguments)},s._Cos=function(){return(s._Cos=s.asm.Cos).apply(null,arguments)},s._Cosh=function(){return(s._Cosh=s.asm.Cosh).apply(null,arguments)},s._CropAndResize=function(){return(s._CropAndResize=s.asm.CropAndResize).apply(null,arguments)},s._Cumprod=function(){return(s._Cumprod=s.asm.Cumprod).apply(null,arguments)},s._Cumsum=function(){return(s._Cumsum=s.asm.Cumsum).apply(null,arguments)},s._DepthToSpace=function(){return(s._DepthToSpace=s.asm.DepthToSpace).apply(null,arguments)},s._DepthwiseConv2dNative=function(){return(s._DepthwiseConv2dNative=s.asm.DepthwiseConv2dNative).apply(null,arguments)},s._Elu=function(){return(s._Elu=s.asm.Elu).apply(null,arguments)},s._Equal=function(){return(s._Equal=s.asm.Equal).apply(null,arguments)},s._Exp=function(){return(s._Exp=s.asm.Exp).apply(null,arguments)},s._FlipLeftRight=function(){return(s._FlipLeftRight=s.asm.FlipLeftRight).apply(null,arguments)},s._Floor=function(){return(s._Floor=s.asm.Floor).apply(null,arguments)},s._FloorDiv=function(){return(s._FloorDiv=s.asm.FloorDiv).apply(null,arguments)},s._FusedBatchNorm=function(){return(s._FusedBatchNorm=s.asm.FusedBatchNorm).apply(null,arguments)},s._FusedConv2D=function(){return(s._FusedConv2D=s.asm.FusedConv2D).apply(null,arguments)},s._FusedDepthwiseConv2D=function(){return(s._FusedDepthwiseConv2D=s.asm.FusedDepthwiseConv2D).apply(null,arguments)},s._Gather=function(){return(s._Gather=s.asm.Gather).apply(null,arguments)},s._GatherNd=function(){return(s._GatherNd=s.asm.GatherNd).apply(null,arguments)},s._Greater=function(){return(s._Greater=s.asm.Greater).apply(null,arguments)},s._GreaterEqual=function(){return(s._GreaterEqual=s.asm.GreaterEqual).apply(null,arguments)},s._LeakyRelu=function(){return(s._LeakyRelu=s.asm.LeakyRelu).apply(null,arguments)},s._Less=function(){return(s._Less=s.asm.Less).apply(null,arguments)},s._LessEqual=function(){return(s._LessEqual=s.asm.LessEqual).apply(null,arguments)},s._Log=function(){return(s._Log=s.asm.Log).apply(null,arguments)},s._LogicalAnd=function(){return(s._LogicalAnd=s.asm.LogicalAnd).apply(null,arguments)},s._LogicalNot=function(){return(s._LogicalNot=s.asm.LogicalNot).apply(null,arguments)},s._LogicalOr=function(){return(s._LogicalOr=s.asm.LogicalOr).apply(null,arguments)},s._LogicalXor=function(){return(s._LogicalXor=s.asm.LogicalXor).apply(null,arguments)},s._Max=function(){return(s._Max=s.asm.Max).apply(null,arguments)},s._MaxPool=function(){return(s._MaxPool=s.asm.MaxPool).apply(null,arguments)},s._Maximum=function(){return(s._Maximum=s.asm.Maximum).apply(null,arguments)},s._Mean=function(){return(s._Mean=s.asm.Mean).apply(null,arguments)},s._Min=function(){return(s._Min=s.asm.Min).apply(null,arguments)},s._Minimum=function(){return(s._Minimum=s.asm.Minimum).apply(null,arguments)},s._MirrorPad=function(){return(s._MirrorPad=s.asm.MirrorPad).apply(null,arguments)},s._Multiply=function(){return(s._Multiply=s.asm.Multiply).apply(null,arguments)},s._Neg=function(){return(s._Neg=s.asm.Neg).apply(null,arguments)},s._NonMaxSuppressionV3=function(){return(s._NonMaxSuppressionV3=s.asm.NonMaxSuppressionV3).apply(null,arguments)},s._NonMaxSuppressionV4=function(){return(s._NonMaxSuppressionV4=s.asm.NonMaxSuppressionV4).apply(null,arguments)},s._NonMaxSuppressionV5=function(){return(s._NonMaxSuppressionV5=s.asm.NonMaxSuppressionV5).apply(null,arguments)},s._NotEqual=function(){return(s._NotEqual=s.asm.NotEqual).apply(null,arguments)},s._OneHot=function(){return(s._OneHot=s.asm.OneHot).apply(null,arguments)},s._PadV2=function(){return(s._PadV2=s.asm.PadV2).apply(null,arguments)},s._Pow=function(){return(s._Pow=s.asm.Pow).apply(null,arguments)},s._Prelu=function(){return(s._Prelu=s.asm.Prelu).apply(null,arguments)},s._Prod=function(){return(s._Prod=s.asm.Prod).apply(null,arguments)},s._RealDiv=function(){return(s._RealDiv=s.asm.RealDiv).apply(null,arguments)},s._Relu=function(){return(s._Relu=s.asm.Relu).apply(null,arguments)},s._Relu6=function(){return(s._Relu6=s.asm.Relu6).apply(null,arguments)},s._ResizeBilinear=function(){return(s._ResizeBilinear=s.asm.ResizeBilinear).apply(null,arguments)},s._ResizeNearestNeighbor=function(){return(s._ResizeNearestNeighbor=s.asm.ResizeNearestNeighbor).apply(null,arguments)},s._Reverse=function(){return(s._Reverse=s.asm.Reverse).apply(null,arguments)},s._RotateWithOffset=function(){return(s._RotateWithOffset=s.asm.RotateWithOffset).apply(null,arguments)},s._Round=function(){return(s._Round=s.asm.Round).apply(null,arguments)},s._Rsqrt=function(){return(s._Rsqrt=s.asm.Rsqrt).apply(null,arguments)},s._ScatterNd=function(){return(s._ScatterNd=s.asm.ScatterNd).apply(null,arguments)},s._SelectV2=function(){return(s._SelectV2=s.asm.SelectV2).apply(null,arguments)},s._Sigmoid=function(){return(s._Sigmoid=s.asm.Sigmoid).apply(null,arguments)},s._Sin=function(){return(s._Sin=s.asm.Sin).apply(null,arguments)},s._Softmax=function(){return(s._Softmax=s.asm.Softmax).apply(null,arguments)},s._SparseFillEmptyRows=function(){return(s._SparseFillEmptyRows=s.asm.SparseFillEmptyRows).apply(null,arguments)},s._SparseReshape=function(){return(s._SparseReshape=s.asm.SparseReshape).apply(null,arguments)},s._SparseSegmentReduction=function(){return(s._SparseSegmentReduction=s.asm.SparseSegmentReduction).apply(null,arguments)},s._Sqrt=function(){return(s._Sqrt=s.asm.Sqrt).apply(null,arguments)},s._Square=function(){return(s._Square=s.asm.Square).apply(null,arguments)},s._SquaredDifference=function(){return(s._SquaredDifference=s.asm.SquaredDifference).apply(null,arguments)},s._Step=function(){return(s._Step=s.asm.Step).apply(null,arguments)},s._StridedSlice=function(){return(s._StridedSlice=s.asm.StridedSlice).apply(null,arguments)},s._Sub=function(){return(s._Sub=s.asm.Sub).apply(null,arguments)},s._Sum=function(){return(s._Sum=s.asm.Sum).apply(null,arguments)},s._Tan=function(){return(s._Tan=s.asm.Tan).apply(null,arguments)},s._Tanh=function(){return(s._Tanh=s.asm.Tanh).apply(null,arguments)},s._Tile=function(){return(s._Tile=s.asm.Tile).apply(null,arguments)},s._TopK=function(){return(s._TopK=s.asm.TopK).apply(null,arguments)},s._Transform=function(){return(s._Transform=s.asm.Transform).apply(null,arguments)},s._Transpose=function(){return(s._Transpose=s.asm.Transpose).apply(null,arguments)},s.__FusedMatMul=function(){return(s.__FusedMatMul=s.asm._FusedMatMul).apply(null,arguments)},s._malloc=function(){return(s._malloc=s.asm.malloc).apply(null,arguments)},s._free=function(){return(s._free=s.asm.free).apply(null,arguments)},s.___errno_location=function(){return(s.___errno_location=s.asm.__errno_location).apply(null,arguments)};var X,Q,J,Z=s.stackSave=function(){return(Z=s.stackSave=s.asm.stackSave).apply(null,arguments)},Y=s.stackRestore=function(){return(Y=s.stackRestore=s.asm.stackRestore).apply(null,arguments)},ee=s.stackAlloc=function(){return(ee=s.stackAlloc=s.asm.stackAlloc).apply(null,arguments)};function te(e){function n(){X||(X=!0,s.calledRun=!0,v||(U(O),t(s),s.onRuntimeInitialized&&s.onRuntimeInitialized(),function(){if(s.postRun)for("function"==typeof s.postRun&&(s.postRun=[s.postRun]);s.postRun.length;)e=s.postRun.shift(),C.unshift(e);var e;U(C)}()))}T>0||(function(){if(s.preRun)for("function"==typeof s.preRun&&(s.preRun=[s.preRun]);s.preRun.length;)e=s.preRun.shift(),D.unshift(e);var e;U(D)}(),T>0||(s.setStatus?(s.setStatus("Running..."),setTimeout((function(){setTimeout((function(){s.setStatus("")}),1),n()}),1)):n()))}if(s.dynCall_iijjiiii=function(){return(s.dynCall_iijjiiii=s.asm.dynCall_iijjiiii).apply(null,arguments)},s.dynCall_jiji=function(){return(s.dynCall_jiji=s.asm.dynCall_jiji).apply(null,arguments)},s.cwrap=function(e,t,n,a){var r=(n=n||[]).every((e=>"number"===e||"boolean"===e));return"string"!==t&&r&&!a?G(e):function(){return $(e,t,n,arguments)}},P=function e(){X||te(),X||(P=e)},s.preInit)for("function"==typeof s.preInit&&(s.preInit=[s.preInit]);s.preInit.length>0;)s.preInit.pop()();if(te(),r&&(Q={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!r.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!r.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof e)J=e;else{if("undefined"==typeof WasmBackendModuleThreadedSimd)throw new Error("Could not find wasm module in post.js");J=WasmBackendModuleThreadedSimd}if(Q){var ne=J._dispose;J._dispose=function(){ne(),Q.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),Q.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a}));const qn=jn||Ln,Hn=Un||o({__proto__:null,default:Un},[Un]);class Vn extends t.KernelBackend{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.initWithThreadsCount(ea),ta=this.wasm.tfjs.getThreadsCount(),this.dataIdMap=new t.DataStorage(this,t.engine())}write(e,t,n){const a={id:this.dataIdNextNumber++};return this.move(a,e,t,n,1),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const n=t.util.now();e();return{kernelMs:t.util.now()-n}}move(e,n,a,r,s){const u=this.dataIdNextNumber++;if("string"===r){const t=n;return void this.dataIdMap.set(e,{id:u,stringBytes:t,shape:a,dtype:r,memoryOffset:null,refCount:s})}const i=t.util.sizeFromShape(a),o=i*t.util.bytesPerElement(r),d=this.wasm._malloc(o);this.dataIdMap.set(e,{id:u,memoryOffset:d,shape:a,dtype:r,refCount:s}),this.wasm.tfjs.registerTensor(u,i,d),null!=n&&this.wasm.HEAPU8.set(new Uint8Array(n.buffer,n.byteOffset,o),d)}async read(e){return this.readSync(e)}readSync(e,n,a){const{memoryOffset:r,dtype:s,shape:u,stringBytes:i}=this.dataIdMap.get(e);if("string"===s)return null!=n&&0!==n||!(null==a||a>=i.length)?i.slice(n,a):i;n=n||0,a=a||t.util.sizeFromShape(u);const o=t.util.bytesPerElement(s);return function(e,t){switch(t){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${t}`)}}(this.wasm.HEAPU8.slice(r+n*o,r+a*o).buffer,s)}disposeData(e,t=!1){if(this.dataIdMap.has(e)){const n=this.dataIdMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}return!0}refCount(e){if(this.dataIdMap.has(e)){return this.dataIdMap.get(e).refCount}return 0}incRef(e){const t=this.dataIdMap.get(e);null!=t&&t.refCount++}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,n,a){let r;if(null==a)r=this.write(null,e,n);else{const s=this.dataIdNextNumber++;r={id:s},this.dataIdMap.set(r,{id:s,memoryOffset:a,shape:e,dtype:n,refCount:1});const u=t.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(s,u,a)}return{dataId:r,shape:e,dtype:n}}typedArrayFromHeap({shape:e,dtype:n,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:s}=this.dataIdMap.get(a),u=t.util.sizeFromShape(e);switch(n){case"float32":return new Float32Array(r,s,u);case"int32":return new Int32Array(r,s,u);case"bool":return new Uint8Array(r,s,u);default:throw new Error(`Unknown dtype ${n}`)}}}function Gn(e,t,n){if(null!=Xn)return Xn;let a="tfjs-backend-wasm.wasm";return e&&t?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=Jn&&null!=Jn[a]?Jn[a]:n+a}async function $n(){const[e,n]=await Promise.all([t.env().getAsync("WASM_HAS_SIMD_SUPPORT"),t.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise(((a,r)=>{const s={};var u;s.locateFile=(t,a)=>{if(t.endsWith(".worker.js")){const e=Bn.replace(/\n/g,"\\n"),t=new Blob([e],{type:"application/javascript"});return URL.createObjectURL(t)}return t.endsWith(".wasm")?Gn(e,n,null!=Qn?Qn:a):a+t},Yn&&(s.instantiateWasm=(u=Gn(e,n,null!=Qn?Qn:""),(e,n)=>(t.util.fetch(u,{credentials:"same-origin"}).then((t=>{t.ok||e.env.a(`failed to load wasm binary file at '${u}'`),t.arrayBuffer().then((t=>{WebAssembly.instantiate(t,e).then((e=>{n(e.instance,e.module)}))}))})),{})));let i,o=!1;s.onAbort=()=>{if(o)return;if(Zn)return;Zn=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})},n&&e&&null==Xn?(s.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+qn.toString()],{type:"text/javascript"}),i=qn(s)):i=Hn(s),i.then((e=>{o=!0,Zn=!1;e.tfjs={init:e.cwrap("init",null,[]),initWithThreadsCount:e.cwrap("init_with_threads_count",null,["number"]),getThreadsCount:e.cwrap("get_threads_count","number",[]),registerTensor:e.cwrap("register_tensor",null,["number","number","number"]),disposeData:e.cwrap("dispose_data",null,["number"]),dispose:e.cwrap("dispose",null,[])},a({wasm:e})})).catch(r)}))}const Kn=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let Xn=null,Qn=null,Jn={},Zn=!1,Yn=!1;let ea=-1,ta=-1;t.registerBackend("wasm",(async()=>{const{wasm:e}=await $n();return new Vn(e)}),2),e.BackendWasm=Vn,e.getThreadsCount=function(){if(-1===ta)throw new Error("WASM backend not initialized.");return ta},e.setThreadsCount=function(e){ea=e},e.setWasmPath=function(e,n=!1){if(t.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),Zn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Xn=e,Yn=n},e.setWasmPaths=function(e,t=!1){if(Zn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)Qn=e;else{Jn=e;const t=Kn.filter((e=>null==Jn[e]));if(t.length>0)throw new Error(`There were no entries found for the following binaries: ${t.join(",")}. Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.`)}Yn=t},e.version_wasm="4.0.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.es2017.min.js.map
