/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import{_FusedMatMul as e,broadcast_util as t,util as n,Abs as a,backend_util as r,Add as s,AddN as u,Identity as i,tensor as o,Transpose as d,All as p,Any as l,ArgMax as c,AvgPool as m,Reshape as f,BatchMatMul as h,slice_util as b,buffer as y,Slice as _,BatchToSpaceND as g,Cast as w,Ceil as k,ClipByValue as I,Concat as M,Conv2D as S,Conv2DBackpropInput as A,Cos as v,Cosh as x,CropAndResize as F,Cumprod as N,Cumsum as R,DepthToSpace as E,DepthwiseConv2dNative as D,Elu as O,Equal as T,Exp as C,ExpandDims as P,Fill as W,FlipLeftRight as z,Floor as j,FloorDiv as U,FusedBatchNorm as L,FusedConv2D as H,FusedDepthwiseConv2D as B,GatherNd as q,gather_util as V,GatherV2 as G,Greater as $,GreaterEqual as K,LeakyRelu as X,Less as Q,LessEqual as J,Log as Z,LogicalAnd as Y,LogicalNot as ee,LogicalOr as te,LogicalXor as ne,Max as ae,Maximum as re,MaxPool as se,Mean as ue,Min as ie,Minimum as oe,MirrorPad as de,Multiply as pe,Neg as le,NonMaxSuppressionV3 as ce,NonMaxSuppressionV4 as me,NonMaxSuppressionV5 as fe,NotEqual as he,OneHot as be,OnesLike as ye,Pack as _e,PadV2 as ge,Pow as we,Prelu as ke,Prod as Ie,Range as Me,RealDiv as Se,Relu as Ae,Relu6 as ve,ResizeBilinear as xe,ResizeNearestNeighbor as Fe,Reverse as Ne,RotateWithOffset as Re,Round as Ee,Rsqrt as De,ScatterNd as Oe,scatter_util as Te,Select as Ce,Sigmoid as Pe,Sin as We,Softmax as ze,SpaceToBatchND as je,SparseFillEmptyRows as Ue,SparseReshape as Le,SparseSegmentMean as He,SparseSegmentSum as Be,SplitV as qe,Sqrt as Ve,Square as Ge,SquaredDifference as $e,Step as Ke,StridedSlice as Xe,StringNGrams as Qe,StringSplit as Je,StringToHashBucketFast as Ze,Sub as Ye,Sum as et,Tan as tt,Tanh as nt,Tile as at,TopK as rt,Transform as st,Unpack as ut,ZerosLike as it,registerKernel as ot,env as dt,KernelBackend as pt,DataStorage as lt,engine as ct,deprecationWarn as mt,registerBackend as ft}from"@tensorflow/tfjs-core";import ht from"path";import bt from"fs";import yt from"worker_threads";import _t from"perf_hooks";import gt from"os";function wt(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var a=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,a.get?a:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var kt,It;let Mt;!function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(kt||(kt={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid",e[e.elu=6]="elu"}(It||(It={}));const St={kernelName:e,backendName:"wasm",setupFunc:function(t){Mt=t.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{a:s,b:u,bias:i,preluActivationWeights:o}=n;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:d,transposeB:p,activation:l,leakyreluAlpha:c}=r,m=a.dataIdMap.get(s.dataId).id,f=a.dataIdMap.get(u.dataId).id;let h=0;if(null!=i){const e=a.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);h=e.id}const b=null==o?0:a.dataIdMap.get(o.dataId).id,y=It[l];if(null==y)throw new Error(`${l} activation not yet supported for FusedConv2D in the wasm backend.`);const _=d?s.shape[2]:s.shape[1],g=p?u.shape[1]:u.shape[2],w=t.assertAndGetBroadcastShape(s.shape.slice(0,-2),u.shape.slice(0,-2)),k=a.makeOutput([...w,_,g],s.dtype),I=a.dataIdMap.get(k.dataId).id,M=new Uint8Array(new Int32Array(s.shape).buffer),S=new Uint8Array(new Int32Array(u.shape).buffer);return Mt(m,M,s.shape.length,f,S,u.shape.length,d,p,y,h,b,c||0,I),k}};function At(e,t){let a;return{kernelName:e,backendName:"wasm",setupFunc:function(t){a=t.wasm.cwrap(e,null,["number","number","number"])},kernelFunc:function(e){const{backend:r,inputs:{x:s}}=e,u=r.dataIdMap.get(s.dataId).id,i=r.makeOutput(s.shape,t||s.dtype),o=r.dataIdMap.get(i.dataId).id;return 0===n.sizeFromShape(i.shape)||a(u,kt[s.dtype],o),i}}}const vt=At(a);function xt(e,t,a){let s;return{kernelName:e,backendName:"wasm",setupFunc:function(t){s=t.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:u}=e,{a:i,b:o}=u,d=t.dataIdMap.get(i.dataId).id,p=t.dataIdMap.get(o.dataId).id,l=null!=a?a:i.dtype,c=r.assertAndGetBroadcastShape(i.shape,o.shape),m=t.makeOutput(c,l);if(0===n.sizeFromShape(c))return m;const f=new Uint8Array(new Int32Array(i.shape).buffer),h=new Uint8Array(new Int32Array(o.shape).buffer),b=t.dataIdMap.get(m.dataId).id;return s(d,f,i.shape.length,p,h,o.shape.length,kt[i.dtype],b),m}}}const Ft=xt(s);let Nt;const Rt={kernelName:u,backendName:"wasm",setupFunc:function(e){Nt=e.wasm.cwrap(u,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,r=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.sizeFromShape(r.shape))return r;const s=t.map((e=>a.dataIdMap.get(e.dataId).id)),u=new Uint8Array(new Int32Array(s).buffer),i=a.dataIdMap.get(r.dataId).id;return Nt(u,s.length,kt[r.dtype],i),r}};function Et(e){const{inputs:{x:t},backend:n}=e;if("string"===t.dtype)return o(n.readSync(t.dataId),t.shape,t.dtype);const a=n.makeOutput(t.shape,t.dtype),r=n.typedArrayFromHeap(t);return n.typedArrayFromHeap(a).set(r),a}const Dt={kernelName:i,backendName:"wasm",kernelFunc:Et};let Ot;function Tt(e){const{inputs:t,backend:n,attrs:a}=e,[r,s]=function(e,t){const n=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&n.push(e[r]),1!==e[t[r]]&&a.push(t[r]);for(let e=0;e<a.length;++e){let t=-1;for(let n=0;n<a.length;++n)a[n]>=e&&(-1===t||a[t]>a[n])&&(t=n);a[t]=e}return[n,a]}(t.x.shape,a.perm);let u=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(u=!1);const i=function(e,t){const n=new Array(e.length);for(let a=0;a<n.length;a++)n[a]=e[t[a]];return n}(t.x.shape,a.perm),o={dataId:t.x.dataId,shape:r,dtype:t.x.dtype};if(u){const e=Et({inputs:t,backend:n});return e.shape=i,e}const d=n.makeOutput(i,o.dtype),p=n.dataIdMap.get(o.dataId).id,l=n.dataIdMap.get(d.dataId).id,c=new Uint8Array(new Int32Array(s).buffer),m=new Uint8Array(new Int32Array(o.shape).buffer);return Ot(p,m,o.shape.length,kt[o.dtype],l,c,s.length),d}const Ct={kernelName:d,backendName:"wasm",kernelFunc:Tt,setupFunc:function(e){Ot=e.wasm.cwrap(d,null,["number","array","number","number","number","array","number"])}};function Pt(e,t,a){const s=e.shape,u=e.shape.length,i=n.parseAxisParam(t,s);let o=i;const d=r.getAxesPermutation(o,u);let p=null,l=!1;if(null!=d){const t=new Array(u);for(let e=0;e<t.length;e++)t[e]=s[d[e]];o=r.getInnerMostAxes(o.length,u),p=Tt({inputs:{x:e},attrs:{perm:d},backend:a});const n=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(p.dataId).id!==n&&(l=!0)}return{transposed:p,originalAxes:i,axes:o,inputWasTransposed:l}}let Wt;const zt={kernelName:p,backendName:"wasm",setupFunc:function(e){Wt=e.wasm.cwrap(p,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a;let d=t.dataIdMap.get(o.dataId).id,p=o;const{transposed:l,axes:c,originalAxes:m,inputWasTransposed:f}=Pt(o,u,t);if(f){p=l,d=t.dataIdMap.get(l.dataId).id}const h=p.shape.length;r.assertAxesAreInnerMostDims("all",c,h);const[b,y]=r.computeOutAndReduceShapes(p.shape,c),_=n.sizeFromShape(y),g=t.makeOutput(b,o.dtype);if(0!==n.sizeFromShape(p.shape)){const e=t.dataIdMap.get(g.dataId).id;Wt(d,_,e)}if(f&&t.disposeData(l.dataId),i){const e=r.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}};let jt;const Ut={kernelName:l,backendName:"wasm",setupFunc:function(e){jt=e.wasm.cwrap(l,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a;let d=t.dataIdMap.get(o.dataId).id,p=o;const{transposed:l,axes:c,originalAxes:m,inputWasTransposed:f}=Pt(o,u,t);if(f){p=l,d=t.dataIdMap.get(l.dataId).id}const h=p.shape.length;r.assertAxesAreInnerMostDims("any",c,h);const[b,y]=r.computeOutAndReduceShapes(p.shape,c),_=n.sizeFromShape(y),g=t.makeOutput(b,o.dtype);if(0!==n.sizeFromShape(p.shape)){const e=t.dataIdMap.get(g.dataId).id;jt(d,_,e)}if(f&&t.disposeData(l.dataId),i){const e=r.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}};let Lt;const Ht={kernelName:c,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s}=r,{x:u}=a,i=t.dataIdMap.get(u.dataId).id;let o=i,d=u;const{transposed:p,axes:l,inputWasTransposed:c}=Pt(u,s,t);if(c){const e=t.dataIdMap.get(p.dataId).id;e!==i&&(d=p,o=e)}const m=d.shape.slice(0,-1),f=t.makeOutput(m,"int32"),h=t.dataIdMap.get(f.dataId).id,b=n.sizeFromShape(f.shape),y=d.shape[l[0]];return Lt(o,kt[d.dtype],b,y,h),c&&t.disposeData(p.dataId),f},setupFunc:function(e){Lt=e.wasm.cwrap(c,null,["number","number","number","number","number"])}};let Bt;const qt={kernelName:m,backendName:"wasm",setupFunc:function(e){Bt=e.wasm.cwrap(m,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:n,backend:a}=e,s=t.x,u=a.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:d,dimRoundingMode:p}=n,l=r.computePool2DInfo(s.shape,i,o,1,d,p),c=l.filterHeight,m=l.filterWidth,f=l.padInfo.top,h=l.padInfo.right,b=l.padInfo.bottom,y=l.padInfo.left,_=l.strideHeight,g=l.strideWidth,w=l.inChannels;if("channelsLast"!==l.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${l.dataFormat}'. Please use 'channelsLast'.`);if(1!==l.dilationWidth||1!==l.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${l.dilationHeight}, ${l.dilationWidth}].`);const k=a.makeOutput(l.outShape,"float32"),I=a.dataIdMap.get(k.dataId).id;return Bt(u,s.shape[0],s.shape[1],s.shape[2],c,m,f,h,b,y,_,g,w,I),k}};function Vt(e){const{inputs:t,attrs:a}=e,{x:r}=t,{shape:s}=a,u=n.sizeFromShape(r.shape),i=n.inferFromImplicitShape(s,u);return n.assert(u===n.sizeFromShape(i),(()=>`new shape: ${i}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:i,dtype:r.dtype}}const Gt={kernelName:f,backendName:"wasm",kernelFunc:Vt};let $t;const Kt={kernelName:h,backendName:"wasm",setupFunc:function(e){$t=e.wasm.cwrap(h,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:a,backend:r,attrs:s}=e,{a:u,b:i}=a,{transposeA:o,transposeB:d}=s;if("float32"!==u.dtype||"float32"!==i.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const p=u.shape.length,l=i.shape.length,c=o?u.shape[p-2]:u.shape[p-1],m=d?i.shape[l-1]:i.shape[l-2],f=o?u.shape[p-1]:u.shape[p-2],h=d?i.shape[l-2]:i.shape[l-1],b=u.shape.slice(0,-2),y=i.shape.slice(0,-2),_=n.sizeFromShape(b),g=n.sizeFromShape(y),w=t.assertAndGetBroadcastShape(u.shape.slice(0,-2),i.shape.slice(0,-2)).concat([f,h]);n.assert(c===m,(()=>`Error in matMul: inner shapes (${c}) and (${m}) of Tensors with shapes ${u.shape} and ${i.shape} and transposeA=${o} and transposeB=${d} must match.`));const k=d?[g,h,m]:[g,m,h],I=Vt({inputs:{x:u},backend:r,attrs:{shape:o?[_,c,f]:[_,f,c]}}),M=Vt({inputs:{x:i},backend:r,attrs:{shape:k}}),S=r.dataIdMap.get(I.dataId).id,A=r.dataIdMap.get(M.dataId).id,v=o?I.shape[2]:I.shape[1],x=d?M.shape[1]:M.shape[2],F=Math.max(_,g),N=r.makeOutput([F,v,x],I.dtype),R=r.dataIdMap.get(N.dataId).id,E=new Uint8Array(new Int32Array(I.shape).buffer),D=new Uint8Array(new Int32Array(M.shape).buffer);return $t(S,E,I.shape.length,A,D,M.shape.length,o,d,R),r.disposeData(I.dataId),r.disposeData(M.dataId),N.shape=w,N}};function Xt(e,t,a,s,u){const i=b.isSliceContinous(s,t,a),o=n.sizeFromShape(a),d=n.computeStrides(s);if(i){const n=b.computeFlatOffset(t,d);return"string"===u?e.slice(n,n+o):e.subarray(n,n+o)}const p="string"===u?r.fromUint8ToStringArray(e):e,l=y(s,u,p),c=y(a,u);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),a=n.map(((e,n)=>e+t[n]));c.set(l.get(...a),...n)}return"string"===u?r.fromStringArrayToUint8(c.values):c.values}r.RowPartitionType;class Qt{constructor(e,t,a,r,s,u){this.separator=n.encodeString(e),this.nGramWidths=t,this.leftPad=n.encodeString(a),this.rightPad=n.encodeString(r),this.padWidth=s,this.preserveShort=u}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,a,r,s){for(let u=0;u<r;++u){const i=this.getPadWidth(s),o=Math.max(0,i-u),d=Math.max(0,i-(r-(u+1))),p=s-(o+d),l=t+(o>0?0:u-i);let c=0;c+=o*this.leftPad.length;for(let t=0;t<p;++t)c+=e[l+t].length;c+=d*this.rightPad.length;c+=(o+d+p-1)*this.separator.length,n[a+u]=new Uint8Array(c);const m=n[a+u];let f=0;const h=e=>e.forEach((e=>m[f++]=e));for(let e=0;e<o;++e)h(this.leftPad),h(this.separator);for(let t=0;t<p-1;++t)h(e[l+t]),h(this.separator);if(p>0){h(e[l+p-1]);for(let e=0;e<d;++e)h(this.separator),h(this.rightPad)}else{for(let e=0;e<d-1;++e)h(this.rightPad),h(this.separator);h(this.rightPad)}}}compute(e,t){const a=e.length,r=t.length;if(r>0){let e=t[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let n=1;n<r;++n){let r=t[n]>=e;if(r=r&&t[n]<=a,!r)throw new Error(`Invalid split value ${t[n]}, must be in [${e}, ${a}]`);e=t[n]}if(e!==a)throw new Error(`Last split value must be data size. Expected ${a}, got ${e}`)}const s=r-1,u=n.getArrayFromDType("int32",r);if(0===a||0===r){const e=new Array(a);for(let e=0;e<=s;++e)u[e]=0;return[e,u]}u[0]=0;for(let e=1;e<=s;++e){const n=t[e]-t[e-1];let a=0;this.nGramWidths.forEach((e=>{a+=this.getNumNGrams(n,e)})),this.preserveShort&&n>0&&0===a&&(a=1),u[e]=u[e-1]+a}const i=new Array(u[s]);for(let n=0;n<s;++n){const a=t[n];let r=u[n];if(this.nGramWidths.forEach((s=>{const u=t[n+1]-t[n],o=this.getNumNGrams(u,s);this.createNGrams(e,a,i,r,o,s),r+=o})),this.preserveShort&&r===u[n]){const s=t[n+1]-t[n];if(0===s)continue;const u=s+2*this.padWidth,o=1;this.createNGrams(e,a,i,r,o,u)}}return[i,u]}}function Jt(e,t,n,a){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)a.push(e.subarray(t,t+1));return}if(1===t.length){const r=t[0];let s=e.indexOf(r);for(;-1!==s;){const t=e.subarray(0,s);n&&0===t.length||a.push(t),s=(e=e.subarray(s+1)).indexOf(r)}return void(n&&0===e.length||a.push(e))}let r=0;for(let s=0;s<e.length+1;s++)if(s===e.length||-1!==t.indexOf(e[s])){const t=e.subarray(r,s);n&&0===t.length||a.push(t),r=s+1}}function Zt(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:s}=e,[u,i]=b.parseSliceParams(t,a,r),o=b.isSliceContinous(t.shape,u,i),d=s.readSync(t.dataId),p=s.makeOutput(i,t.dtype),l=n.computeStrides(t.shape),c=s.dataIdMap.get(p.dataId);if(o){const e=b.computeFlatOffset(u,l);if("string"===t.dtype)c.stringBytes=d.slice(e,e+n.sizeFromShape(i));else{s.typedArrayFromHeap(p).set(d.subarray(e,e+n.sizeFromShape(i)))}return p}if("string"===t.dtype){const e=Xt(d,u,i,t.shape,t.dtype);return c.stringBytes=e,p}const m=s.typedArrayFromHeap(p),f=t.shape.length;if(2===f)!function(e,t,n,a,r){let s=0;const u=a[0],i=a[1],o=u+r[0];for(let a=u;a<o;a++){const u=a*t+i;n.set(e.subarray(u,u+r[1]),s),s+=r[1]}}(d,l[0],m,u,i);else if(3===f)!function(e,t,n,a,r,s){let u=0;const i=r[0],o=r[1],d=r[2],p=i+s[0],l=o+s[1];for(let r=i;r<p;r++)for(let i=o;i<l;i++){const o=r*t+i*n+d;a.set(e.subarray(o,o+s[2]),u),u+=s[2]}}(d,l[0],l[1],m,u,i);else if(4===f)!function(e,t,n,a,r,s,u){let i=0;const o=s[0],d=s[1],p=s[2],l=o+u[0],c=d+u[1],m=p+u[2],f=s[3];for(let s=o;s<l;s++)for(let o=d;o<c;o++)for(let d=p;d<m;d++){const p=s*t+o*n+d*a+f;r.set(e.subarray(p,p+u[3]),i),i+=u[3]}}(d,l[0],l[1],l[2],m,u,i);else{const e=Xt(d,u,i,t.shape,t.dtype);m.set(e)}return p}const Yt={kernelName:_,backendName:"wasm",kernelFunc:Zt};const en={kernelName:g,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:s}=t,{blockShape:u,crops:i}=a,o=u.reduce(((e,t)=>e*t)),d=r.getReshaped(s.shape,u,o),p=r.getPermuted(d.length,u.length),l=r.getReshapedPermuted(s.shape,u,o),c=r.getSliceBeginCoords(i,u.length),m=r.getSliceSize(l,i,u.length),f=Vt({inputs:{x:s},backend:n,attrs:{shape:d}}),h=Tt({inputs:{x:f},backend:n,attrs:{perm:p}}),b=Zt({inputs:{x:Vt({inputs:{x:h},backend:n,attrs:{shape:l}})},backend:n,attrs:{begin:c,size:m}});return n.disposeData(f.dataId),n.disposeData(h.dataId),n.disposeData(f.dataId),b}};function tn(e){const{inputs:{x:t},attrs:{dtype:n},backend:a}=e,r=a.makeOutput(t.shape,n),s=a.typedArrayFromHeap(t);return a.typedArrayFromHeap(r).set(s),r}const nn={kernelName:w,backendName:"wasm",kernelFunc:tn},an=At(k);let rn;const sn={kernelName:I,backendName:"wasm",setupFunc:function(e){rn=e.wasm.cwrap(I,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,{clipValueMin:s,clipValueMax:u}=a,i=n.dataIdMap.get(r.dataId).id,o=n.makeOutput(r.shape,r.dtype),d=n.dataIdMap.get(o.dataId).id;return rn(i,s,u,d),o}};function un(e){const{inputs:t,backend:a}=e,s=n.parseAxisParam(e.attrs.axis,t[0].shape)[0],u=t.map((e=>e.shape));r.assertParamsConsistent(u,s);let i=r.computeOutShape(t.map((e=>e.shape)),s);const o=t.filter((e=>n.sizeFromShape(e.shape)>0));if(1===o.length)return Et({inputs:{x:o[0]},backend:a});const d=a.makeOutput(i,t[0].dtype);if(0===n.sizeFromShape(i))return d;if("string"===o[0].dtype){const e=o.map((e=>{const t=n.sizeFromShape(e.shape.slice(s));return Vt({inputs:{x:e},backend:a,attrs:{shape:[-1,t]}})})),u=e.map((e=>({vals:a.readSync(e.dataId),shape:e.shape})));i=r.computeOutShape(e.map((e=>e.shape)),1);const p=1===e[0].shape[0],l=function(e,t,a,s){const u=n.getArrayFromDType(a,n.sizeFromShape(t));if(s&&"string"!==a){let t=0;e.forEach((e=>{const a=n.sizeFromShape(e.shape);u.set(e.vals,t),t+=a}))}else{let n=0;e.forEach((e=>{const s="string"===a?r.fromUint8ToStringArray(e.vals):e.vals;let i=0;for(let a=0;a<e.shape[0];++a){const r=a*t[1]+n;for(let t=0;t<e.shape[1];++t)u[r+t]=s[i++]}n+=e.shape[1]}))}return u}(u,i,t[0].dtype,p),c=r.computeOutShape(o.map((e=>e.shape)),s);d.shape=c;return a.dataIdMap.get(d.dataId).stringBytes=r.fromStringArrayToUint8(l),e.forEach((e=>a.disposeData(e.dataId))),d}const p=n.sizeFromShape(o[0].shape.slice(0,s));let l=0;const c=o.map((e=>{const t=n.sizeFromShape(e.shape.slice(s));return l+=t,t})),m=o.map((e=>a.typedArrayFromHeap(e))),f=a.typedArrayFromHeap(d);for(let e=0;e<p;e++){let t=e*l;for(let n=0;n<m.length;n++){const a=c[n],r=e*a,s=m[n].subarray(r,r+a);f.set(s,t),t+=a}}return d}const on={kernelName:M,backendName:"wasm",kernelFunc:un};let dn;const pn={kernelName:S,backendName:"wasm",setupFunc:function(e){dn=e.wasm.cwrap(S,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:n,backend:a}=e,{x:s,filter:u}=t,i=a.dataIdMap.get(s.dataId).id,o=a.dataIdMap.get(u.dataId).id,{strides:d,dilations:p,pad:l,dimRoundingMode:c,dataFormat:m}=n,f=r.convertConv2DDataFormat(m),h=r.computeConv2DInfo(s.shape,u.shape,d,p,l,c,!1,f),b=h.filterHeight,y=h.filterWidth,_=h.padInfo.top,g=h.padInfo.right,w=h.padInfo.bottom,k=h.padInfo.left,I=h.dilationHeight,M=h.dilationWidth,S=h.strideHeight,A=h.strideWidth,v=h.inChannels,x=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error(`wasm backend Conv2D does not support dataFormat:'${h.dataFormat}'. Please use 'channelsLast'.`);const N=a.makeOutput(h.outShape,"float32"),R=a.dataIdMap.get(N.dataId).id;return dn(i,s.shape[0],s.shape[1],s.shape[2],o,b,y,_,g,w,k,F,I,M,S,A,v,x,R),N}};let ln;const cn={kernelName:A,backendName:"wasm",setupFunc:function(e){ln=e.wasm.cwrap(A,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{dy:u,filter:i}=a,{strides:o,pad:d,dataFormat:p,dimRoundingMode:l,inputShape:c}=s,m=r.convertConv2DDataFormat(p),f=r.computeConv2DInfo(c,i.shape,o,1,d,l,!1,m),{batchSize:h,filterHeight:b,filterWidth:y,inChannels:_,inHeight:g,inWidth:w,outChannels:k,outHeight:I,outWidth:M,strideHeight:S,strideWidth:A}=f,v=b-1-f.padInfo.top,x=y-1-f.padInfo.left,F="channelsLast"===f.dataFormat,N=n.computeStrides(f.inShape),R=n.computeStrides(u.shape),[E,D,O]=n.computeStrides(i.shape),T=N[0],C=F?N[1]:N[2],P=F?N[2]:1,W=F?1:N[1],z=R[0],j=F?R[1]:R[2],U=F?R[2]:1,L=F?1:R[1],H=t.makeOutput(f.inShape,"float32"),B=t.dataIdMap.get(H.dataId).id,q=t.dataIdMap.get(u.dataId).id,V=t.dataIdMap.get(i.dataId).id;return ln(q,V,h,b,y,g,w,_,I,M,k,S,A,v,x,E,D,O,T,C,P,W,z,j,U,L,B),H}},mn=At(v),fn=At(x);var hn;let bn;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(hn||(hn={}));const yn={kernelName:F,backendName:"wasm",setupFunc:function(e){bn=e.wasm.cwrap(F,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{method:r,extrapolationValue:s,cropSize:u}=a,{image:i,boxes:o,boxInd:d}=n,p=o.shape[0],[l,c]=u,m=[p,l,c,i.shape[3]];let f,h=t.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(f=tn({backend:t,inputs:{x:i},attrs:{dtype:"float32"}}),h=t.dataIdMap.get(f.dataId));const b=h.id,y=t.dataIdMap.get(o.dataId).id,_=t.dataIdMap.get(d.dataId).id,g=t.makeOutput(m,"float32"),w=t.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(i.shape).buffer);return bn(b,y,_,p,k,l,c,hn[r],s,w),null!=f&&t.disposeData(f.dataId),g}};let _n;const gn={kernelName:N,backendName:"wasm",setupFunc:function(e){_n=e.wasm.cwrap(N,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:s}=e,{x:u}=t,{axis:i,exclusive:o,reverse:d}=s,p=u.shape.length;n.assert("float32"===u.dtype||"int32"===u.dtype,(()=>`cumprod does not support ${u.dtype} tensors in the WASM backend`));const l=r.getAxesPermutation([i],p);let c=u;null!==l&&(c=Tt({inputs:{x:u},attrs:{perm:l},backend:a}));const m=r.getInnerMostAxes(1,p)[0];r.assertAxesAreInnerMostDims("cumprod",[m],p);const f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,y=a.dataIdMap.get(f.dataId).id;_n(b,o?1:0,d?1:0,h,y,kt[u.dtype]);let _=f;if(null!==l){_=Tt({inputs:{x:f},attrs:{perm:r.getUndoAxesPermutation(l)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)}return _}};let wn;const kn={kernelName:R,backendName:"wasm",setupFunc:function(e){wn=e.wasm.cwrap(R,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:s}=e,{x:u}=t,{axis:i,exclusive:o,reverse:d}=s,p=u.shape.length;n.assert("float32"===u.dtype||"int32"===u.dtype,(()=>`cumsum does not support ${u.dtype} tensors in the WASM backend`));const l=r.getAxesPermutation([i],p);let c=u;null!==l&&(c=Tt({inputs:{x:u},attrs:{perm:l},backend:a}));const m=r.getInnerMostAxes(1,p)[0];r.assertAxesAreInnerMostDims("cumsum",[m],p);const f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,y=a.dataIdMap.get(f.dataId).id;wn(b,o?1:0,d?1:0,h,y,kt[u.dtype]);let _=f;if(null!==l){_=Tt({inputs:{x:f},attrs:{perm:r.getUndoAxesPermutation(l)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)}return _}};let In;const Mn={kernelName:E,backendName:"wasm",setupFunc:function(e){In=e.wasm.cwrap(E,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s}=a,{blockSize:u,dataFormat:i}=r,o=s.shape[0],d=("NHWC"===i?s.shape[1]:s.shape[2])*u,p=("NHWC"===i?s.shape[2]:s.shape[3])*u,l=("NHWC"===i?s.shape[3]:s.shape[1])/(u*u),c="NHWC"===i?[o,d,p,l]:[o,l,d,p],m=t.makeOutput(c,"float32"),f=t.dataIdMap.get(s.dataId).id,h=new Uint8Array(new Int32Array(n.computeStrides(s.shape)).buffer),b=new Uint8Array(new Int32Array(c).buffer),y=new Uint8Array(new Int32Array(n.computeStrides(c)).buffer),_=t.dataIdMap.get(m.dataId).id;return In(f,u,"NHWC"===i?1:0,h,s.shape.length-1,b,y,c.length,_),m}};let Sn;const An={kernelName:D,backendName:"wasm",setupFunc:function(e){Sn=e.wasm.cwrap(D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:n,backend:a}=e,{x:s,filter:u}=t,i=a.dataIdMap.get(s.dataId).id,o=a.dataIdMap.get(u.dataId).id,{strides:d,dilations:p,pad:l,dimRoundingMode:c}=n,m=null==p?[1,1]:p,f=r.computeConv2DInfo(s.shape,u.shape,d,m,l,c,!0),h=f.filterHeight,b=f.filterWidth,y=f.padInfo.top,_=f.padInfo.right,g=f.padInfo.bottom,w=f.padInfo.left,k=f.dilationHeight,I=f.dilationWidth,M=f.strideHeight,S=f.strideWidth,A=f.inChannels,v=f.outChannels,x="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error(`wasm backend DepthwiseConv2dNative does not support dataFormat:'${f.dataFormat}'. Please use 'channelsLast'.`);const F=a.makeOutput(f.outShape,"float32"),N=a.dataIdMap.get(F.dataId).id;return Sn(i,s.shape[0],s.shape[1],s.shape[2],o,h,b,y,_,g,w,x,k,I,M,S,A,v,N),F}},vn=At(O),xn=xt(T,0,"bool"),Fn=At(C,"float32");function Nn(e){const{inputs:t,attrs:a,backend:r}=e,{input:s}=t,{dim:u}=a,i=s.shape.length,o=s.shape.slice();let d=u;return u<0&&(n.assert(-(i+1)<=u,(()=>`Axis must be in the interval [${-(i+1)}, ${i}]`)),d=i+u+1),o.splice(d,0,1),Vt({inputs:{x:s},backend:r,attrs:{shape:o}})}const Rn={kernelName:P,backendName:"wasm",kernelFunc:Nn};function En(e){const{attrs:{shape:t,value:n,dtype:a},backend:r}=e,s=r.makeOutput(t,a);return r.typedArrayFromHeap(s).fill(n),s}const Dn={kernelName:W,backendName:"wasm",kernelFunc:En};let On;const Tn={kernelName:z,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n}=e,{image:a}=t,r=n.makeOutput(a.shape,a.dtype),s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id,[i,o,d,p]=a.shape;return On(s,i,o,d,p,u),r},setupFunc:function(e){On=e.wasm.cwrap(z,null,["number","number","number","number","number","number"])}},Cn=At(j),Pn=xt(U);let Wn;const zn={kernelName:L,backendName:"wasm",setupFunc:function(e){Wn=e.wasm.cwrap(L,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:s}=r,{x:u,mean:i,variance:o,offset:d,scale:p}=a,l=t.dataIdMap.get(u.dataId).id,c=t.dataIdMap.get(i.dataId).id,m=t.dataIdMap.get(o.dataId).id,f=null!=d?t.dataIdMap.get(d.dataId).id:0,h=null!=p?t.dataIdMap.get(p.dataId).id:0,b=t.makeOutput(u.shape,u.dtype);if(0===n.sizeFromShape(u.shape))return b;const y=t.dataIdMap.get(b.dataId).id;return Wn(l,c,m,f,h,s,y),b}};let jn;const Un={kernelName:H,backendName:"wasm",setupFunc:function(e){jn=e.wasm.cwrap(H,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:n,backend:a}=e,{x:s,filter:u,bias:i,preluActivationWeights:o}=t,{strides:d,pad:p,dilations:l,dataFormat:c,dimRoundingMode:m,activation:f,leakyreluAlpha:h}=n,b=r.computeConv2DInfo(s.shape,u.shape,d,l,p,m),y=It[f];if(null==y)throw new Error(`${f} activation not yet supported for FusedConv2D in the wasm backend.`);const _=a.dataIdMap.get(s.dataId).id,g=a.dataIdMap.get(u.dataId).id,w=b.outChannels;let k=0;if(null!=i){const e=a.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);k=e.id}const I=b.filterHeight,M=b.filterWidth,S=b.padInfo.top,A=b.padInfo.right,v=b.padInfo.bottom,x=b.padInfo.left,F=b.dilationHeight,N=b.dilationWidth,R=b.strideHeight,E=b.strideWidth,D=b.inChannels,O="SAME"===b.padInfo.type?1:0,T=b.batchSize,C=b.inHeight,P=b.inWidth;if("NHWC"!==c)throw new Error(`wasm backend FusedConv2D does not support dataFormat:'${c}'. Please use 'NHWC'.`);const W=a.makeOutput(b.outShape,"float32"),z=a.dataIdMap.get(W.dataId).id,j=null==o?0:a.dataIdMap.get(o.dataId).id;return jn(_,T,C,P,g,I,M,k,S,A,v,x,O,F,N,R,E,D,w,y,j,h||0,z),W}};let Ln;const Hn={kernelName:B,backendName:"wasm",setupFunc:function(e){Ln=e.wasm.cwrap(B,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:n,backend:a}=e,{x:s,filter:u,bias:i,preluActivationWeights:o}=t,{strides:d,pad:p,dilations:l,dataFormat:c,dimRoundingMode:m,activation:f,leakyreluAlpha:h}=n,b=r.computeConv2DInfo(s.shape,u.shape,d,l,p,m,!0),y=It[f];if(null==y)throw new Error(`${f} activation not yet supported for FusedDepthwiseConv2D in the wasm backend.`);const _=a.dataIdMap.get(s.dataId).id,g=a.dataIdMap.get(u.dataId).id,w=b.outChannels;let k=0;if(null!=i){const e=a.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);k=e.id}const I=b.filterHeight,M=b.filterWidth,S=b.padInfo.top,A=b.padInfo.right,v=b.padInfo.bottom,x=b.padInfo.left,F=b.dilationHeight,N=b.dilationWidth,R=b.strideHeight,E=b.strideWidth,D=b.inChannels,O="SAME"===b.padInfo.type?1:0,T=b.batchSize,C=b.inHeight,P=b.inWidth;if("NHWC"!==c)throw new Error(`wasm backend FusedDepthwiseConv2D does not support dataFormat:'${c}'. Please use 'NHWC'.`);const W=a.makeOutput(b.outShape,"float32"),z=a.dataIdMap.get(W.dataId).id,j=null==o?0:a.dataIdMap.get(o.dataId).id;return Ln(_,T,C,P,g,I,M,k,S,A,v,x,O,F,N,R,E,D,w,y,j,h||0,z),W}};let Bn;const qn={kernelName:q,backendName:"wasm",setupFunc:function(e){Bn=e.wasm.cwrap(q,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:n}=e,{params:a,indices:r}=n,[s,u,i,o]=V.prepareAndValidate(a,r),d=t.makeOutput(s,a.dtype);if(0===u)return d;const p=r.shape,l=p[p.length-1],c=t.dataIdMap.get(a.dataId).id,m=t.dataIdMap.get(r.dataId).id,f=new Uint8Array(new Int32Array(o).buffer),h=t.dataIdMap.get(d.dataId).id;return Bn(c,kt[a.dtype],m,u,l,i,f,h),d}};let Vn;const Gn={kernelName:G,backendName:"wasm",setupFunc:function(e){Vn=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{x:u,indices:i}=a,{axis:o,batchDims:d}=s,p=n.parseAxisParam(o,u.shape)[0],l=t.readSync(i.dataId),c=u.shape[p];for(let e=0;e<l.length;++e){const t=l[e];n.assert(t<=c-1&&t>=0,(()=>`GatherV2: the index value ${t} is not in [0, ${c-1}]`))}const m=r.segment_util.collectGatherOpShapeInfo(u,i,p,d),f=Vt({inputs:{x:u},attrs:{shape:[m.batchSize,m.outerSize,m.dimSize,m.sliceSize]},backend:t}),h=n.sizeFromShape(i.shape),b=Vt({inputs:{x:i},attrs:{shape:[m.batchSize,h/m.batchSize]},backend:t}),y=[m.batchSize,m.outerSize,h/m.batchSize,m.sliceSize],_=t.makeOutput(y,u.dtype);if(0===n.sizeFromShape(u.shape))return _;const g=f.shape.length-1,w=t.dataIdMap.get(f.dataId).id,k=t.dataIdMap.get(b.dataId).id,I=t.dataIdMap.get(_.dataId).id,M=new Uint8Array(new Int32Array(n.computeStrides(f.shape)).buffer),S=new Uint8Array(new Int32Array(n.computeStrides(y)).buffer);return Vn(w,kt[u.dtype],M,g,k,m.batchSize,S,I),t.disposeData(f.dataId),t.disposeData(b.dataId),_.shape=m.outputShape,_}},$n=xt($,0,"bool"),Kn=xt(K,0,"bool");let Xn;const Qn={kernelName:X,backendName:"wasm",setupFunc:function(e){Xn=e.wasm.cwrap(X,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:{x:t},attrs:{alpha:a},backend:r}=e,s=r.dataIdMap.get(t.dataId).id,u=r.makeOutput(t.shape,"float32");if(0!==n.sizeFromShape(t.shape)){const e=r.dataIdMap.get(u.dataId).id;Xn(s,kt[t.dtype],a,e)}return u}},Jn=xt(Q,0,"bool"),Zn=xt(J,0,"bool"),Yn=At(Z),ea=xt(Y,0,"bool"),ta=At(ee),na=xt(te,0,"bool"),aa=xt(ne,0,"bool");let ra;const sa={kernelName:ae,backendName:"wasm",setupFunc:function(e){ra=e.wasm.cwrap(ae,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{reductionIndices:u,keepDims:i}=s,{x:o}=a;let d=t.dataIdMap.get(o.dataId).id,p=o;const{transposed:l,axes:c,originalAxes:m,inputWasTransposed:f}=Pt(o,u,t);if(f){p=l,d=t.dataIdMap.get(l.dataId).id}const h=p.shape.length;r.assertAxesAreInnerMostDims("max",c,h);const[b,y]=r.computeOutAndReduceShapes(p.shape,c),_=n.sizeFromShape(y),g=t.makeOutput(b,o.dtype);if(0!==n.sizeFromShape(p.shape)){const e=t.dataIdMap.get(g.dataId).id;ra(d,kt[o.dtype],_,e)}if(f&&t.disposeData(l.dataId),i){const e=r.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},ua=xt(re);let ia;const oa={kernelName:se,backendName:"wasm",setupFunc:function(e){ia=e.wasm.cwrap(se,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:s}=e,u=t.x,i=s.dataIdMap.get(u.dataId).id;n.assert("float32"===u.dtype,(()=>`Error in MaxPool: only float32 input is supported. Got ${u.dtype}.`));const{filterSize:o,strides:d,pad:p,dimRoundingMode:l}=a,c=r.computePool2DInfo(u.shape,o,d,1,p,l),m=c.filterHeight,f=c.filterWidth,h=c.padInfo.top,b=c.padInfo.right,y=c.padInfo.bottom,_=c.padInfo.left,g=c.dilationHeight,w=c.dilationWidth,k=c.strideHeight,I=c.strideWidth,M=c.inChannels,S=c.outChannels;if("channelsLast"!==c.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${c.dataFormat}'. Please use 'channelsLast'.`);const A=s.makeOutput(c.outShape,"float32"),v=s.dataIdMap.get(A.dataId).id;return ia(i,u.shape[0],u.shape[1],u.shape[2],m,f,h,b,y,_,g,w,k,I,M,S,v),A}};let da;const pa={kernelName:ue,backendName:"wasm",setupFunc:function(e){da=e.wasm.cwrap(ue,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a,d=t.dataIdMap.get(o.dataId).id;let p=d,l=o;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=Pt(o,u,t);let b=m;if(h){const e=t.dataIdMap.get(c.dataId).id;e!==d&&(l=c,p=e,b=r.getInnerMostAxes(b.length,l.shape.length))}r.assertAxesAreInnerMostDims("mean",b,l.shape.length);const[y,_]=r.computeOutAndReduceShapes(l.shape,b),g=n.sizeFromShape(_);let w=l;"float32"!==l.dtype&&(w=tn({backend:t,inputs:{x:l},attrs:{dtype:"float32"}}),p=t.dataIdMap.get(w.dataId).id);const k=t.makeOutput(y,"float32");if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(k.dataId).id;da(p,g,e)}if(h&&t.disposeData(c.dataId),i){const e=r.expandShapeToKeepDim(k.shape,f);k.shape=e}return"float32"!==l.dtype&&t.disposeData(w.dataId),k}};let la;const ca={kernelName:ie,backendName:"wasm",setupFunc:function(e){la=e.wasm.cwrap(ie,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a,d=t.dataIdMap.get(o.dataId).id;let p=d,l=o;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=Pt(o,u,t);if(h){const e=t.dataIdMap.get(c.dataId).id;e!==d&&(l=c,p=e)}const b=l.shape.length;r.assertAxesAreInnerMostDims("min",m,b);const[y,_]=r.computeOutAndReduceShapes(l.shape,m),g=n.sizeFromShape(_),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;la(p,kt[o.dtype],g,e)}if(h&&t.disposeData(c.dataId),i){const e=r.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},ma=xt(oe);var fa;let ha;!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(fa||(fa={}));const ba={kernelName:de,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n,attrs:{paddings:a,mode:r}}=e,s=a.map(((e,n)=>e[0]+t.shape[n]+e[1])),u=n.dataIdMap.get(t.dataId).id,i=n.makeOutput(s,t.dtype),o=n.dataIdMap.get(i.dataId).id,d=new Uint8Array(new Int32Array(t.shape).buffer),p=a.map((e=>e[0])),l=a.map((e=>e[1])),c=new Uint8Array(new Int32Array(p).buffer),m=new Uint8Array(new Int32Array(l).buffer);return ha(u,d,t.shape.length,kt[t.dtype],c,m,fa[r],o),i},setupFunc:function(e){ha=e.wasm.cwrap(de,null,["number","array","number","number","array","array","number","number"])}},ya=xt(pe),_a=At(le);function ga(e,t){const n=new Int32Array(e.wasm.HEAPU8.buffer,t,4),a=n[0],r=n[1],s=n[2],u=n[3];return e.wasm._free(t),{pSelectedIndices:a,selectedSize:r,pSelectedScores:s,pValidOutputs:u}}let wa;const ka={kernelName:ce,backendName:"wasm",setupFunc:function(e){wa=e.wasm.cwrap(ce,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u}=a,{boxes:i,scores:o}=n,d=t.dataIdMap.get(i.dataId).id,p=t.dataIdMap.get(o.dataId).id,l=wa(d,p,s,r,u),{pSelectedIndices:c,selectedSize:m,pSelectedScores:f,pValidOutputs:h}=ga(t,l);return t.wasm._free(f),t.wasm._free(h),t.makeOutput([m],"int32",c)}};let Ia;const Ma={kernelName:me,backendName:"wasm",setupFunc:function(e){Ia=e.wasm.cwrap(me,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,padToMaxOutputSize:i}=a,{boxes:o,scores:d}=n,p=t.dataIdMap.get(o.dataId).id,l=t.dataIdMap.get(d.dataId).id,c=Ia(p,l,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=ga(t,c);return t.wasm._free(h),[t.makeOutput([f],"int32",m),t.makeOutput([],"int32",b)]}};let Sa;const Aa={kernelName:fe,backendName:"wasm",setupFunc:function(e){Sa=e.wasm.cwrap(fe,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,softNmsSigma:i}=a,{boxes:o,scores:d}=n,p=t.dataIdMap.get(o.dataId).id,l=t.dataIdMap.get(d.dataId).id,c=Sa(p,l,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=ga(t,c);return t.wasm._free(b),[t.makeOutput([f],"int32",m),t.makeOutput([f],"float32",h)]}},va=xt(he,0,"bool");let xa;const Fa={kernelName:be,backendName:"wasm",setupFunc:function(e){xa=e.wasm.cwrap(be,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{indices:r}=t,{dtype:s,depth:u,onValue:i,offValue:o}=a,d=n.makeOutput([...r.shape,u],s),p=n.dataIdMap.get(d.dataId).id,l=n.dataIdMap.get(r.dataId).id;return xa(l,u,i,o,p),d}};const Na={kernelName:ye,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(1),a}};const Ra={kernelName:_e,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{axis:s}=r;if(1===t.length)return Nn({inputs:{input:t[0]},backend:a,attrs:{dim:s}});const u=t[0].shape,i=t[0].dtype;t.forEach((e=>{n.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),n.assert(i===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const o=[],d=un({inputs:t.map((e=>{const t=Nn({inputs:{input:e},backend:a,attrs:{dim:s}});return o.push(t),t})),backend:a,attrs:{axis:s}});return o.forEach((e=>a.disposeData(e.dataId))),d}};let Ea;const Da={kernelName:ge,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:a,attrs:{paddings:r,constantValue:s}}=e,u=r.map(((e,n)=>e[0]+t.shape[n]+e[1]));if(0===n.sizeFromShape(t.shape))return En({backend:a,attrs:{shape:u,value:s,dtype:t.dtype}});const i=a.dataIdMap.get(t.dataId).id,o=a.makeOutput(u,t.dtype),d=a.dataIdMap.get(o.dataId).id,p=new Uint8Array(new Int32Array(t.shape).buffer),l=r.map((e=>e[0])),c=r.map((e=>e[1])),m=new Uint8Array(new Int32Array(l).buffer),f=new Uint8Array(new Int32Array(c).buffer);return Ea(i,p,t.shape.length,kt[t.dtype],m,f,s,d),o},setupFunc:function(e){Ea=e.wasm.cwrap(ge,null,["number","array","number","number","array","array","number","number"])}},Oa=xt(we);let Ta;const Ca={kernelName:ke,backendName:"wasm",setupFunc:function(e){Ta=e.wasm.cwrap(ke,null,["number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:a,alpha:r}=t,s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id;let i=s;const o=a;let d=o;"float32"!==o.dtype&&(d=tn({backend:n,inputs:{x:a},attrs:{dtype:"float32"}}),i=n.dataIdMap.get(d.dataId).id);const p=n.makeOutput(a.shape,"float32"),l=n.dataIdMap.get(p.dataId).id;return Ta(i,u,l),"float32"!==o.dtype&&n.disposeData(d.dataId),p}};let Pa;const Wa={kernelName:Ie,backendName:"wasm",setupFunc:function(e){Pa=e.wasm.cwrap(Ie,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a,d=t.dataIdMap.get(o.dataId).id;let p=d,l=o;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=Pt(o,u,t);let b=m;if(h){const e=t.dataIdMap.get(c.dataId).id;e!==d&&(l=c,p=e,b=r.getInnerMostAxes(b.length,l.shape.length))}r.assertAxesAreInnerMostDims("prod",b,l.shape.length);const[y,_]=r.computeOutAndReduceShapes(l.shape,b),g=n.sizeFromShape(_),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;Pa(p,g,kt[w.dtype],e)}if(h&&t.disposeData(c.dataId),i){const e=r.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},za={kernelName:Me,backendName:"wasm",kernelFunc:e=>{const{backend:t,attrs:a}=e,{start:r,stop:s,step:u,dtype:i}=a,o=function(e,t,a,r){if(e===t||e<t&&a<0||t<e&&a>1)return n.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((t-e)/a)),u=n.makeZerosTypedArray(s,r);t<e&&1===a&&(a=-1),u[0]=e;for(let e=1;e<u.length;e++)u[e]=u[e-1]+a;return u}(r,s,u,i),d=t.makeOutput([o.length],i);return t.typedArrayFromHeap(d).set(o),d}},ja=xt(Se),Ua=At(Ae),La=At(ve);let Ha;const Ba={kernelName:xe,backendName:"wasm",setupFunc:function(e){Ha=e.wasm.cwrap(xe,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[d,p]=o,[l,c,m,f]=s.shape,h=[l,d,p,f];let b,y=t.dataIdMap.get(s.dataId);"float32"!==y.dtype&&(b=tn({backend:t,inputs:{x:s},attrs:{dtype:"float32"}}),y=t.dataIdMap.get(b.dataId));const _=y.id,g=t.makeOutput(h,"float32");if(0===n.sizeFromShape(s.shape))return g;const w=t.dataIdMap.get(g.dataId).id;return Ha(_,l,c,m,f,d,p,u?1:0,i?1:0,w),null!=b&&t.disposeData(b.dataId),g}};let qa;const Va={kernelName:Fe,backendName:"wasm",setupFunc:function(e){qa=e.wasm.cwrap(Fe,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[d,p]=o,[l,c,m,f]=s.shape,h=[l,d,p,f],b=t.makeOutput(h,"float32");if(0===n.sizeFromShape(s.shape))return b;let y,_=t.dataIdMap.get(s.dataId);"float32"!==_.dtype&&(y=tn({backend:t,inputs:{x:s},attrs:{dtype:"float32"}}),_=t.dataIdMap.get(y.dataId));const g=_.id,w=t.dataIdMap.get(b.dataId).id;return qa(g,l,c,m,f,d,p,u?1:0,i?1:0,w),null!=y&&t.disposeData(y.dataId),b}};let Ga;const $a={kernelName:Ne,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:s}=t,{dims:u}=r,i=n.parseAxisParam(u,s.shape);if(0===s.shape.length)return Et({inputs:{x:s},backend:a});const o=a.makeOutput(s.shape,s.dtype),d=a.dataIdMap.get(s.dataId).id,p=a.dataIdMap.get(o.dataId).id,l=new Uint8Array(new Int32Array(i).buffer),c=new Uint8Array(new Int32Array(s.shape).buffer);Ga(d,l,i.length,c,s.shape.length,p);const m=Vt({inputs:{x:o},attrs:{shape:s.shape},backend:a});return a.disposeData(o.dataId),m},setupFunc:function(e){Ga=e.wasm.cwrap(Ne,null,["number","array","number","array","number","number"])}};let Ka;const Xa={kernelName:Re,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{image:s}=t,{radians:u,fillValue:i,center:o}=a,d=n.makeOutput(s.shape,s.dtype),p=n.dataIdMap.get(s.dataId).id,l=n.dataIdMap.get(d.dataId).id,[c,m,f,h]=s.shape,[b,y]=r.getImageCenter(o,m,f),_="number"==typeof i?[i,i,i,0===i?0:255]:[...i,255],g=new Uint8Array(new Int32Array(_).buffer);return Ka(p,c,m,f,h,u,b,y,g,_.length,l),d},setupFunc:function(e){Ka=e.wasm.cwrap(Re,null,["number","number","number","number","number","number","number","number","array","number","number"])}},Qa=At(Ee),Ja=At(De);let Za;const Ya={kernelName:Oe,backendName:"wasm",setupFunc:function(e){Za=e.wasm.cwrap(Oe,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{indices:s,updates:u}=a,{shape:i}=r,o=t.makeOutput(i,u.dtype);if(0===n.sizeFromShape(i))return o;const{sliceRank:d,numUpdates:p,sliceSize:l,strides:c,outputSize:m}=Te.calculateShapes(u,s,i),f=t.dataIdMap.get(s.dataId).id,h=t.dataIdMap.get(u.dataId).id,b=new Uint8Array(new Int32Array(c).buffer),y=t.dataIdMap.get(o.dataId).id;return Za(f,h,kt[u.dtype],d,p,l,b,m,y),o}};let er;const tr={kernelName:Ce,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a}=e,{condition:r,t:s,e:u}=t,i=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(s.dataId).id,d=a.dataIdMap.get(u.dataId).id,p=a.makeOutput(s.shape,s.dtype),l=a.dataIdMap.get(p.dataId).id,c=r.shape.length,m=s.shape.length,f=0===c||c>1||1===m?1:n.sizeFromShape(s.shape.slice(1));return er(i,o,d,f,l),p},setupFunc:function(e){er=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}};let nr;const ar={kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){nr=e.wasm.cwrap(Pe,null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),u=t.dataIdMap.get(s.dataId).id;return 0===n.sizeFromShape(s.shape)||nr(r,u),s}},rr=At(We);let sr;const ur={kernelName:ze,backendName:"wasm",setupFunc:function(e){sr=e.wasm.cwrap(ze,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,s=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),i=t.dataIdMap.get(u.dataId).id,o=a.shape[r],d=n.sizeFromShape(a.shape)/o;return 0===n.sizeFromShape(u.shape)||sr(s,i,o,d),u}};const ir={kernelName:je,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:s}=e,{x:u}=t,{blockShape:i,paddings:o}=s,d=n.sizeFromShape(i),p=[[0,0]];p.push(...o);for(let e=1+i.length;e<u.shape.length;++e)p.push([0,0]);const l=Da.kernelFunc({inputs:{x:u},backend:a,attrs:{paddings:p,constantValue:0}}),c=r.getReshaped(l.shape,i,d,!1),m=r.getPermuted(c.length,i.length,!1),f=r.getReshapedPermuted(l.shape,i,d,!1),h=Vt({inputs:{x:l},backend:a,attrs:{shape:c}}),b=Tt({inputs:{x:h},backend:a,attrs:{perm:m}}),y=Vt({inputs:{x:b},backend:a,attrs:{shape:f}});return a.disposeData(l.dataId),a.disposeData(h.dataId),a.disposeData(b.dataId),y}};let or;const dr={kernelName:Ue,backendName:"wasm",setupFunc:function(e){or=e.wasm.cwrap("SparseFillEmptyRows","number",["number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n}=e,{indices:a,values:s,denseShape:u,defaultValue:i}=n,o=a.shape[0],d=a.shape[1],p=t.readSync(u.dataId)[0],l=[o+p,d],c=t.dataIdMap.get(a.dataId).id,m=t.dataIdMap.get(s.dataId).id,f=t.dataIdMap.get(i.dataId).id,h=t.makeOutput(l,a.dtype),b=t.dataIdMap.get(h.dataId).id,y=t.makeOutput(l.slice(0,1),s.dtype),_=t.dataIdMap.get(y.dataId).id,g=t.makeOutput([p],"bool"),w=t.dataIdMap.get(g.dataId).id,k=t.makeOutput([o],a.dtype),I=t.dataIdMap.get(k.dataId).id,M=t.makeOutput([4],"int32"),S=t.dataIdMap.get(M.dataId).id,A=or(c,m,kt[s.dtype],o,p,d,f,b,_,w,I,S),v=t.readSync(M.dataId);let x;switch(v[0]){case 1:x=r.getSparseFillEmptyRowsIndicesDenseShapeMismatch(v[1]);break;case 2:x=r.getSparseFillEmptyRowsNegativeIndexErrorMessage(v[1],v[2]);break;case 3:x=r.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(v[1],v[2],v[3]);break;default:x=""}if(t.disposeData(M.dataId),x)throw t.disposeData(h.dataId),t.disposeData(y.dataId),t.disposeData(g.dataId),t.disposeData(k.dataId),new Error(x);let F=h,N=y;return A!==l[0]&&(F=Zt({inputs:{x:h},attrs:{begin:0,size:[A,d]},backend:t}),N=Zt({inputs:{x:y},attrs:{begin:0,size:A},backend:t}),t.disposeData(h.dataId),t.disposeData(y.dataId)),[F,N,g,k]}};let pr;const lr={kernelName:Le,backendName:"wasm",setupFunc:function(e){pr=e.wasm.cwrap(Le,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a}=e,{inputIndices:s,inputShape:u,newShape:i}=a;if(2!==s.shape.length)throw new Error(`Input indices should be a matrix but received shape\n        ${s.shape}`);if(1!==u.shape.length)throw new Error(`Input shape should be a vector but received shape\n        ${u.shape}`);if(1!==i.shape.length)throw new Error(`Target shape should be a vector but received shape ${i.shape}`);const o=t.dataIdMap.get(s.dataId).id,d=t.dataIdMap.get(u.dataId).id,p=t.dataIdMap.get(i.dataId).id,l=s.shape[0],c=n.sizeFromShape(i.shape),m=t.makeOutput([l,c],s.dtype),f=t.dataIdMap.get(m.dataId).id,h=t.makeOutput([c],i.dtype),b=t.dataIdMap.get(h.dataId).id,y=t.makeOutput([3],"int32"),_=t.dataIdMap.get(y.dataId).id;pr(o,d,p,l,f,b,_);const g=t.readSync(y.dataId);let w;switch(g[0]){case 0:w=r.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(g[1],g[2]);break;case 1:w=r.getSparseReshapeNegativeOutputDimErrorMessage(g[1],g[2]);break;case 2:w=r.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage();break;case 3:{const e=Array.from(t.readSync(u.dataId)),n=Array.from(t.readSync(h.dataId));w=r.getSparseReshapeInputOutputMultipleErrorMessage(e,n);break}case 4:{const e=Array.from(t.readSync(u.dataId)),n=Array.from(t.readSync(h.dataId));w=r.getSparseReshapeInputOutputMismatchErrorMessage(e,n);break}default:w=""}if(t.disposeData(y.dataId),w)throw t.disposeData(m.dataId),t.disposeData(h.dataId),new Error(w);return[m,h]}};let cr;function mr(e){cr=e.wasm.cwrap("SparseSegmentReduction",null,["number","number","number","number","number","number","number","number","number"])}function fr(e,t){const{backend:n,inputs:a}=e,{data:s,indices:u,segmentIds:i}=a,o=u.shape[0],d=n.readSync(i.dataId,o-1,o)[0],p=o>0?d+1:0;if(p<0)throw new Error(r.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const l=s.shape.slice();l[0]=p;const c=n.dataIdMap.get(s.dataId).id,m=n.dataIdMap.get(u.dataId).id,f=n.dataIdMap.get(i.dataId).id,h=n.makeOutput(l,s.dtype),b=n.dataIdMap.get(h.dataId).id,y=n.makeOutput([4],"int32"),_=n.dataIdMap.get(y.dataId).id;cr(c,kt[s.dtype],s.shape[0],m,f,b,_,t,0);const g=n.readSync(y.dataId);let w;switch(g[0]){case 0:w=r.getSparseSegmentReductionNegativeSegmentIdsErrorMessage();break;case 1:w=r.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage();break;case 2:w=r.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(g[1],g[2]);break;case 3:w=r.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(g[1],g[2],g[3]);break;default:w=""}if(n.disposeData(y.dataId),w)throw n.disposeData(h.dataId),new Error(w);return h}const hr={kernelName:He,backendName:"wasm",setupFunc:mr,kernelFunc:function(e){return fr(e,!0)}};const br={kernelName:Be,backendName:"wasm",setupFunc:mr,kernelFunc:function(e){return fr(e,!1)}};const yr={kernelName:qe,backendName:"wasm",kernelFunc:function(e){const{inputs:t,attrs:a,backend:s}=e,{x:u}=t,{numOrSizeSplits:i,axis:o}=a,d=n.parseAxisParam(o,u.shape)[0],p=r.prepareSplitSize(u,i,d),l=new Array(u.shape.length).fill(0),c=u.shape.slice();return p.map((e=>{const t=[...c];t[d]=e;const n=Zt({inputs:{x:u},attrs:{begin:l,size:t},backend:s});return l[d]+=e,n}))}},_r=At(Ve),gr=At(Ge),wr=xt($e);let kr;const Ir={kernelName:Ke,backendName:"wasm",setupFunc:function(e){kr=e.wasm.cwrap(Ke,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{alpha:r}=a,{x:s}=n,u=t.dataIdMap.get(s.dataId).id,i=t.makeOutput(s.shape,s.dtype),o=t.dataIdMap.get(i.dataId).id;return kr(u,r,kt[s.dtype],o),i}};let Mr;const Sr={kernelName:Xe,backendName:"wasm",setupFunc:function(e){Mr=e.wasm.cwrap(Xe,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s}=a,{begin:u,end:i,strides:o,beginMask:d,endMask:p,ellipsisMask:l,newAxisMask:c,shrinkAxisMask:m}=r,{finalShapeSparse:f,finalShape:h,isIdentity:y,sliceDim0:_,isSimpleSlice:g,begin:w,end:k,strides:I}=b.sliceInfo(s.shape,u,i,o,d,p,l,c,m);let M;if(y)M=Vt({inputs:{x:s},backend:t,attrs:{shape:h}});else if(_||g){n.assert(s.shape.length>=1,(()=>`Input must have rank at least 1, got: ${s.shape.length}`));const e=b.computeOutShape(w,k,I),a=Zt({inputs:{x:s},backend:t,attrs:{begin:w,size:e}});M=Vt({inputs:{x:a},backend:t,attrs:{shape:h}}),t.disposeData(a.dataId)}else{const e=t.makeOutput(f,"float32"),a=t.dataIdMap.get(s.dataId).id,r=new Uint8Array(new Int32Array(n.computeStrides(s.shape)).buffer),u=new Uint8Array(new Int32Array(w).buffer),i=new Uint8Array(new Int32Array(k).buffer),o=new Uint8Array(new Int32Array(I).buffer),d=new Uint8Array(new Int32Array(f).buffer),p=new Uint8Array(new Int32Array(n.computeStrides(f)).buffer),l=t.dataIdMap.get(e.dataId).id;Mr(a,r,s.shape.length,u,i,o,d,p,f.length,l),M=Vt({inputs:{x:e},backend:t,attrs:{shape:h}}),t.disposeData(e.dataId)}return M}};const Ar={kernelName:Qe,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{data:r,dataSplits:s}=n,{separator:u,nGramWidths:i,leftPad:o,rightPad:d,padWidth:p,preserveShortSequences:l}=a,c=t.readSync(r.dataId),m=t.readSync(s.dataId),[f,h]=function(e,t,n,a,r,s,u,i){return new Qt(n,a,r,s,u,i).compute(e,t)}(c,m,u,i,o,d,p,l),b=t.makeOutput([f.length],"string");t.dataIdMap.get(b.dataId).stringBytes=f;const y=t.makeOutput(s.shape,"int32");return t.typedArrayFromHeap(y).set(h),[b,y]}};const vr={kernelName:Je,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{input:s,delimiter:u}=a,{skipEmpty:i}=r,o=t.readSync(s.dataId),d=t.readSync(u.dataId),[p,l,c]=function(e,t,a){const r=e.length,s=[];let u=0,i=0;const o=new Array(r);for(let n=0;n<r;++n){const r=s.length;Jt(e[n],t,a,s);const d=s.length-r;o[n]=d,u+=d,i=Math.max(i,d)}const d=n.getArrayFromDType("int32",2*u),p=new Array(u),l=[r,i];let c=0;for(let e=0;e<r;++e)for(let t=0;t<o[e];++t)d[2*c]=e,d[2*c+1]=t,p[c]=s[c],++c;return[d,p,l]}(o,d[0],i),m=l.length,f=t.makeOutput([m,2],"int32");t.typedArrayFromHeap(f).set(p);const h=t.makeOutput([m],"string");t.dataIdMap.get(h.dataId).stringBytes=l;const b=t.makeOutput([2],"int32");return t.typedArrayFromHeap(b).set(c),[f,h,b]}};const xr={kernelName:Ze,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{input:s}=a,{numBuckets:u}=r,i=function(e,t){const a=n.getArrayFromDType("int32",e.length);for(let r=0;r<e.length;++r)a[r]=n.fingerPrint64(e[r]).modulo(t).getLowBitsUnsigned();return a}(t.readSync(s.dataId),u),o=t.makeOutput(s.shape,"int32");return t.typedArrayFromHeap(o).set(i),o}},Fr=xt(Ye);let Nr;const Rr={kernelName:et,backendName:"wasm",setupFunc:function(e){Nr=e.wasm.cwrap(et,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:s}=e,{axis:u,keepDims:i}=s,{x:o}=a,d=t.dataIdMap.get(o.dataId).id;let p=d,l=o;const{transposed:c,axes:m,originalAxes:f,inputWasTransposed:h}=Pt(o,u,t);let b=m;if(h){const e=t.dataIdMap.get(c.dataId).id;e!==d&&(l=c,p=e,b=r.getInnerMostAxes(b.length,l.shape.length))}r.assertAxesAreInnerMostDims("sum",b,l.shape.length);const[y,_]=r.computeOutAndReduceShapes(l.shape,b),g=n.sizeFromShape(_),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;Nr(p,g,kt[w.dtype],e)}if(h&&t.disposeData(c.dataId),i){const e=r.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},Er=At(tt),Dr=At(nt);let Or;let Tr;let Cr;const Pr=[St,vt,Ft,Rt,zt,Ut,Ht,qt,Kt,en,nn,an,sn,on,pn,cn,mn,fn,yn,gn,kn,Mn,An,vn,xn,Fn,Rn,Dn,Tn,Cn,Pn,zn,Un,Hn,qn,Gn,$n,Kn,Dt,Qn,Jn,Zn,Yn,ea,ta,na,aa,sa,ua,oa,pa,ca,ma,ba,ya,_a,ka,Ma,Aa,va,Fa,Na,Ra,Da,Oa,Ca,Wa,za,ja,Ua,La,Gt,Ba,Va,$a,Xa,Qa,Ja,Ya,tr,ar,rr,Yt,ur,ir,dr,lr,hr,br,yr,_r,gr,wr,Ir,Sr,Ar,vr,xr,Fr,Rr,Er,Dr,{kernelName:at,backendName:"wasm",setupFunc:function(e){Or=e.wasm.cwrap(at,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,s=n.dataIdMap.get(r.dataId).id,{reps:u}=a,i=new Array(r.shape.length);for(let e=0;e<i.length;e++)i[e]=r.shape[e]*u[e];const o=new Uint8Array(new Int32Array(r.shape).buffer),d=new Uint8Array(new Int32Array(i).buffer),p=n.makeOutput(i,r.dtype),l=n.dataIdMap.get(p.dataId).id;return Or(s,o,r.shape.length,d,i.length,kt[p.dtype],l),p}},{kernelName:rt,backendName:"wasm",setupFunc:function(e){Tr=e.wasm.cwrap(rt,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:t,attrs:n})=>{const{x:a}=e,{k:r,sorted:s}=n,u=t.dataIdMap.get(a.dataId).id,i=new Uint8Array(new Int32Array(a.shape).buffer),o=a.shape.slice();o[o.length-1]=r;const d=t.makeOutput(o,a.dtype),p=t.dataIdMap.get(d.dataId).id,l=t.makeOutput(o,"int32"),c=t.dataIdMap.get(l.dataId).id;return Tr(u,i,a.shape.length,kt[a.dtype],r,s,p,c),[d,l]}},{kernelName:st,backendName:"wasm",setupFunc:function(e){Cr=e.wasm.cwrap(st,null,["number","number","bool","number","number","number","number","number","number","array","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{image:s,transforms:u}=a,{interpolation:i,fillMode:o,fillValue:d,outputShape:p}=r,[l,c,m,f]=s.shape,[h,b]=null!=p?p:[c,m],y=[l,h,b,f],_=new Uint8Array(new Int32Array(n.computeStrides(s.shape)).buffer),g=new Uint8Array(new Int32Array(n.computeStrides(y)).buffer),w=t.makeOutput(y,s.dtype),k=t.dataIdMap.get(w.dataId).id,I=t.dataIdMap.get(s.dataId).id,M=t.dataIdMap.get(u.dataId).id,S="nearest"===i?1:2;let A;switch(o){case"constant":default:A=1;break;case"reflect":A=2;break;case"wrap":A=3;break;case"nearest":A=4}return Cr(I,M,u.shape[0]>1,l,h,b,f,m,c,_,s.shape.length-1,g,y.length-1,S,A,d,k),w}},Ct,{kernelName:ut,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{value:r}=t;let{axis:s}=a;s<0&&(s+=r.shape.length);const u=r.shape[s],i=r.shape.length,o=new Array(i-1);let d=0;for(let e=0;e<i;e++)e!==s&&(o[d++]=r.shape[e]);const p=new Array(u),l=new Array(i).fill(0),c=r.shape.slice();c[s]=1;for(let e=0;e<p.length;e++)l[s]=e,p[e]=Zt({inputs:{x:r},attrs:{begin:l,size:c},backend:n});return p.map((({dataId:e,dtype:t})=>({dataId:e,dtype:t,shape:o})))}},{kernelName:it,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(0),a}}];for(const e of Pr)ot(e);const Wr=dt();Wr.registerFlag("WASM_HAS_SIMD_SUPPORT",(async()=>{try{return WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))}catch(e){return!1}})),Wr.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(async()=>{if(Wr.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}}));var zr="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function jr(e){var t={exports:{}};return e(t,t.exports),t.exports}function Ur(e){throw new Error('Could not dynamically require "'+e+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var Lr=jr((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){function t(){return N.buffer!=O&&H(N.buffer),T}function a(){return N.buffer!=O&&H(N.buffer),C}function r(){return N.buffer!=O&&H(N.buffer),P}function s(){return N.buffer!=O&&H(N.buffer),W}function u(){return N.buffer!=O&&H(N.buffer),z}var i,o,d,p="undefined"!=typeof(e=e||{})?e:{};p.ready=new Promise((function(e,t){i=e,o=t})),"undefined"!=typeof process&&process.listeners&&(d={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var l,c,m,f=Object.assign({},p),h=(e,t)=>{throw t},b="object"==typeof window,y="function"==typeof importScripts,_="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,g=p.ENVIRONMENT_IS_PTHREAD||!1,w="";function k(e){return p.locateFile?p.locateFile(e,w):w+e}if(_){var I,M;let e;w=y?ht.dirname(w)+"/":__dirname+"/","function"==typeof Ur&&(I=bt,M=ht),l=(e,t)=>(e=M.normalize(e),I.readFileSync(e,t?void 0:"utf8")),m=e=>{var t=l(e,!0);return t.buffer||(t=new Uint8Array(t)),t},c=(e,t,n)=>{e=M.normalize(e),I.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof re))throw e})),process.on("unhandledRejection",(function(e){throw e})),h=(e,t)=>{if(K())throw process.exitCode=e,t;var n;(n=t)instanceof re||F("exiting due to exception: "+n),process.exit(e)},p.inspect=function(){return"[Emscripten Module object]"};try{e=yt}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}zr.Worker=e.Worker}else(b||y)&&(y?w=self.location.href:"undefined"!=typeof document&&document.currentScript&&(w=document.currentScript.src),"undefined"!=typeof n&&n&&(w=n),w=0!==w.indexOf("blob:")?w.substr(0,w.replace(/[?#].*/,"").lastIndexOf("/")+1):"",_||(l=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},y&&(m=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),c=(e,t,n)=>{var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=()=>{200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)}));_&&"undefined"==typeof performance&&(zr.performance=_t.performance);var S=console.log.bind(console),A=console.warn.bind(console);_&&(S=e=>I.writeSync(1,e+"\n"),A=e=>I.writeSync(2,e+"\n"));var v,x=p.print||S,F=p.printErr||A;Object.assign(p,f),f=null,p.arguments,p.thisProgram,p.quit&&(h=p.quit),p.wasmBinary&&(v=p.wasmBinary);var N,R,E=p.noExitRuntime||!0;"object"!=typeof WebAssembly&&Y("no native wasm support detected");var D,O,T,C,P,W,z,j=!1,U="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function L(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&U)return U.decode(e.buffer instanceof SharedArrayBuffer?e.slice(t,r):e.subarray(t,r));for(var s="";t<r;){var u=e[t++];if(128&u){var i=63&e[t++];if(192!=(224&u)){var o=63&e[t++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[t++])<65536)s+=String.fromCharCode(u);else{var d=u-65536;s+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function H(e){O=e,p.HEAP8=T=new Int8Array(e),p.HEAP16=new Int16Array(e),p.HEAP32=P=new Int32Array(e),p.HEAPU8=C=new Uint8Array(e),p.HEAPU16=new Uint16Array(e),p.HEAPU32=W=new Uint32Array(e),p.HEAPF32=new Float32Array(e),p.HEAPF64=z=new Float64Array(e)}g&&(O=p.buffer);var B,q=p.INITIAL_MEMORY||16777216;if(g)N=p.wasmMemory,O=p.buffer;else if(p.wasmMemory)N=p.wasmMemory;else if(!((N=new WebAssembly.Memory({initial:q/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw F("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),_&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");N&&(O=N.buffer),q=O.byteLength,H(O);var V=[],G=[],$=[];function K(){return E}function X(){g||pe(G)}var Q,J=0,Z=null;function Y(e){g?postMessage({cmd:"onAbort",arg:e}):p.onAbort&&p.onAbort(e),F(e="Aborted("+e+")"),j=!0,D=1,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw o(t),t}function ee(e){return e.startsWith("data:application/octet-stream;base64,")}function te(e){return e.startsWith("file://")}function ne(e){try{if(e==Q&&v)return new Uint8Array(v);if(m)return m(e);throw"both async and sync fetching of the wasm failed"}catch(e){Y(e)}}ee(Q="tfjs-backend-wasm-threaded-simd.wasm")||(Q=k(Q));var ae={};function re(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function se(e){var t,n=de.pthreads[e];n||Y(t),de.returnWorkerToPool(n)}function ue(e){var t=de.getNewWorker();if(!t)return 6;de.runningWorkers.push(t),de.pthreads[e.pthread_ptr]=t,t.pthread_ptr=e.pthread_ptr;var n={cmd:"run",start_routine:e.startRoutine,arg:e.arg,pthread_ptr:e.pthread_ptr};return t.runPthread=()=>{n.time=performance.now(),t.postMessage(n,e.transferList)},t.loaded&&(t.runPthread(),delete t.runPthread),0}function ie(e){if(g)return ge(1,1,e);D=e,K()||(de.terminateAllThreads(),p.onExit&&p.onExit(e),j=!0),h(e,new re(e))}var oe=function(e,t){if(D=e,!t&&g)throw ce(e),"unwind";ie(e)},de={unusedWorkers:[],runningWorkers:[],tlsInitFunctions:[],pthreads:{},init:function(){g?de.initWorker():de.initMainThread()},initMainThread:function(){for(var e=8;e--;)de.allocateUnusedWorker()},initWorker:function(){E=!1},setExitStatus:function(e){D=e},terminateAllThreads:function(){for(var e of Object.values(de.pthreads))de.returnWorkerToPool(e);for(var e of de.unusedWorkers)e.terminate();de.unusedWorkers=[]},returnWorkerToPool:function(e){var t=e.pthread_ptr;delete de.pthreads[t],de.unusedWorkers.push(e),de.runningWorkers.splice(de.runningWorkers.indexOf(e),1),e.pthread_ptr=0,ze(t)},receiveObjectTransfer:function(e){},threadInitTLS:function(){de.tlsInitFunctions.forEach((e=>e()))},loadWasmModuleToWorker:function(e,t){e.onmessage=n=>{var a,r=n.data,s=r.cmd;if(e.pthread_ptr&&(de.currentProxiedOperationCallerThread=e.pthread_ptr),r.targetThread&&r.targetThread!=Ee()){var u=de.pthreads[r.targetThread];return u?u.postMessage(r,r.transferList):F('Internal error! Worker sent a message "'+s+'" to target pthread '+r.targetThread+", but that thread no longer exists!"),void(de.currentProxiedOperationCallerThread=void 0)}"processProxyingQueue"===s?ye(r.queue):"spawnThread"===s?ue(r):"cleanupThread"===s?se(r.thread):"killThread"===s?function(e){var t=de.pthreads[e];delete de.pthreads[e],t.terminate(),ze(e),de.runningWorkers.splice(de.runningWorkers.indexOf(t),1),t.pthread_ptr=0}(r.thread):"cancelThread"===s?(a=r.thread,de.pthreads[a].postMessage({cmd:"cancel"})):"loaded"===s?(e.loaded=!0,t&&t(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===s?x("Thread "+r.threadId+": "+r.text):"printErr"===s?F("Thread "+r.threadId+": "+r.text):"alert"===s?alert("Thread "+r.threadId+": "+r.text):"setimmediate"===r.target?e.postMessage(r):"onAbort"===s?p.onAbort&&p.onAbort(r.arg):s&&F("worker sent an unknown command "+s),de.currentProxiedOperationCallerThread=void 0},e.onerror=e=>{throw F("worker sent an error! "+e.filename+":"+e.lineno+": "+e.message),e},_&&(e.on("message",(function(t){e.onmessage({data:t})})),e.on("error",(function(t){e.onerror(t)})),e.on("detachedExit",(function(){}))),e.postMessage({cmd:"load",urlOrBlob:p.mainScriptUrlOrBlob||n,wasmMemory:N,wasmModule:R})},allocateUnusedWorker:function(){var e=k("tfjs-backend-wasm-threaded-simd.worker.js");de.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==de.unusedWorkers.length&&(de.allocateUnusedWorker(),de.loadWasmModuleToWorker(de.unusedWorkers[0])),de.unusedWorkers.pop()}};function pe(e){for(;e.length>0;)e.shift()(p)}function le(e){var t=Le(),n=e();return He(t),n}function ce(e){if(g)return ge(2,0,e);try{oe(e)}catch(e){!function(e){if(e instanceof re||"unwind"==e)return D;h(1,e)}(e)}}p.PThread=de,p.establishStackSpace=function(){var e=Ee(),t=r()[e+44>>2],n=r()[e+48>>2];Ue(t,t-n),He(t)};var me,fe=[];function he(e,t,n,a){return g?ge(3,1,e,t,n,a):be(e,t,n,a)}function be(e,t,n,a){if("undefined"==typeof SharedArrayBuffer)return F("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;var r=[];if(g&&0===r.length)return he(e,t,n,a);var s={startRoutine:n,pthread_ptr:e,arg:a,transferList:r};return g?(s.cmd="spawnThread",postMessage(s,r),0):ue(s)}function ye(e){Atomics.store(r(),e>>2,1),Ee()&&We(e),Atomics.compareExchange(r(),e>>2,1,0)}function _e(e){_e.shown||(_e.shown={}),_e.shown[e]||(_e.shown[e]=1,_&&(e="warning: "+e),F(e))}function ge(e,t){var n=arguments.length-2,a=arguments;return le((()=>{for(var r=n,s=Be(8*r),i=s>>3,o=0;o<n;o++){var d=a[2+o];u()[i+o]=d}return Oe(e,r,s,t)}))}p.invokeEntryPoint=function(e,t){var n,a,r=((a=fe[n=e])||(n>=fe.length&&(fe.length=n+1),fe[n]=a=B.get(n)),a)(t);K()?de.setExitStatus(r):je(r)},p.executeNotifiedProxyingQueue=ye,me=_?()=>{var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:g?()=>performance.now()-p.__performance_now_clock_drift:()=>performance.now();var we=[];function ke(e){try{return N.grow(e-O.byteLength+65535>>>16),H(N.buffer),1}catch(e){}}function Ie(e){return g?ge(4,1,e):52}function Me(e,t,n,a,r){return g?ge(5,1,e,t,n,a,r):70}var Se=[null,[],[]];function Ae(e,t){var n=Se[e];0===t||10===t?((1===e?x:F)(L(n,0)),n.length=0):n.push(t)}function ve(e,t,n,r){if(g)return ge(6,1,e,t,n,r);for(var u=0,i=0;i<n;i++){var o=s()[t>>2],d=s()[t+4>>2];t+=8;for(var p=0;p<d;p++)Ae(e,a()[o+p]);u+=d}return s()[r>>2]=u,0}function xe(e){return p["_"+e]}function Fe(e,n,r,s,u){var i={string:e=>{var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,s=0;s<e.length;++s){var u=e.charCodeAt(s);if(u>=55296&&u<=57343&&(u=65536+((1023&u)<<10)|1023&e.charCodeAt(++s)),u<=127){if(n>=r)break;t[n++]=u}else if(u<=2047){if(n+1>=r)break;t[n++]=192|u>>6,t[n++]=128|63&u}else if(u<=65535){if(n+2>=r)break;t[n++]=224|u>>12,t[n++]=128|u>>6&63,t[n++]=128|63&u}else{if(n+3>=r)break;t[n++]=240|u>>18,t[n++]=128|u>>12&63,t[n++]=128|u>>6&63,t[n++]=128|63&u}}t[n]=0}(e,a(),t,n)}(e,t=Be(n),n)}return t},array:e=>{var n=Be(e.length);return function(e,n){t().set(e,n)}(e,n),n}};function o(e){return"string"===n?(t=e)?L(a(),t,r):"":"boolean"===n?Boolean(e):e;var t,r}var d=xe(e),p=[],l=0;if(s)for(var c=0;c<s.length;c++){var m=i[r[c]];m?(0===l&&(l=Le()),p[c]=m(s[c])):p[c]=s[c]}var f=d.apply(null,p);return f=function(e){return 0!==l&&He(l),o(e)}(f)}de.init();var Ne=[null,ie,ce,he,Ie,Me,ve],Re={__emscripten_init_main_thread_js:function(e){De(e,!y,1,!b),de.threadInitTLS()},__emscripten_thread_cleanup:function(e){g?postMessage({cmd:"cleanupThread",thread:e}):se(e)},__pthread_create_js:be,_emscripten_default_pthread_stack_size:function(){return 2097152},_emscripten_get_now_is_monotonic:function(){return!0},_emscripten_notify_task_queue:function(e,t,n,a){if(e==t)setTimeout((()=>ye(a)));else if(g)postMessage({targetThread:e,cmd:"processProxyingQueue",queue:a});else{var r=de.pthreads[e];if(!r)return;r.postMessage({cmd:"processProxyingQueue",queue:a})}return 1},_emscripten_set_offscreencanvas_size:function(e,t,n){return-1},abort:function(){Y("")},emscripten_check_blocking_allowed:function(){_||y||_e("Blocking on the main thread is very dangerous, see https://emscripten.org/docs/porting/pthreads.html#blocking-on-the-main-browser-thread")},emscripten_date_now:function(){return Date.now()},emscripten_get_heap_max:function(){return 2147483648},emscripten_get_now:me,emscripten_memcpy_big:function(e,t,n){a().copyWithin(e,t,t+n)},emscripten_num_logical_cores:function(){return _?gt.cpus().length:navigator.hardwareConcurrency},emscripten_receive_on_main_thread_js:function(e,t,n){we.length=t;for(var a=n>>3,r=0;r<t;r++)we[r]=u()[a+r];return(e<0?ae[-e-1]:Ne[e]).apply(null,we)},emscripten_resize_heap:function(e){var t=a().length;if((e>>>=0)<=t)return!1;var n,r,s=2147483648;if(e>s)return!1;for(var u=1;u<=4;u*=2){var i=t*(1+.2/u);if(i=Math.min(i,e+100663296),ke(Math.min(s,(n=Math.max(e,i))+((r=65536)-n%r)%r)))return!0}return!1},emscripten_unwind_to_js_event_loop:function(){throw"unwind"},exit:oe,fd_close:Ie,fd_seek:Me,fd_write:ve,memory:N||p.wasmMemory};!function(){var e={env:Re,wasi_snapshot_preview1:Re};function t(e,t){var n,a,r=e.exports;if(p.asm=r,n=p.asm._emscripten_tls_init,de.tlsInitFunctions.push(n),B=p.asm.__indirect_function_table,a=p.asm.__wasm_call_ctors,G.unshift(a),R=t,!g){var s=de.unusedWorkers.length;de.unusedWorkers.forEach((function(e){de.loadWasmModuleToWorker(e,(function(){--s||function(e){if(J--,p.monitorRunDependencies&&p.monitorRunDependencies(J),0==J&&Z){var t=Z;Z=null,t()}}()}))}))}}function n(e){t(e.instance,e.module)}function a(t){return function(){if(!v&&(b||y)){if("function"==typeof fetch&&!te(Q))return fetch(Q,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Q+"'";return e.arrayBuffer()})).catch((function(){return ne(Q)}));if(c)return new Promise((function(e,t){c(Q,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return ne(Q)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){F("failed to asynchronously prepare wasm: "+e),Y(e)}))}if(g||(J++,p.monitorRunDependencies&&p.monitorRunDependencies(J)),p.instantiateWasm)try{return p.instantiateWasm(e,t)}catch(e){F("Module.instantiateWasm callback failed with error: "+e),o(e)}(v||"function"!=typeof WebAssembly.instantiateStreaming||ee(Q)||te(Q)||_||"function"!=typeof fetch?a(n):fetch(Q,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return F("wasm streaming compile failed: "+e),F("falling back to ArrayBuffer instantiation"),a(n)}))}))).catch(o)}(),p.___wasm_call_ctors=function(){return(p.___wasm_call_ctors=p.asm.__wasm_call_ctors).apply(null,arguments)},p._init=function(){return(p._init=p.asm.init).apply(null,arguments)},p._init_with_threads_count=function(){return(p._init_with_threads_count=p.asm.init_with_threads_count).apply(null,arguments)},p._get_threads_count=function(){return(p._get_threads_count=p.asm.get_threads_count).apply(null,arguments)},p._register_tensor=function(){return(p._register_tensor=p.asm.register_tensor).apply(null,arguments)},p._dispose_data=function(){return(p._dispose_data=p.asm.dispose_data).apply(null,arguments)},p._dispose=function(){return(p._dispose=p.asm.dispose).apply(null,arguments)},p._Abs=function(){return(p._Abs=p.asm.Abs).apply(null,arguments)},p._Add=function(){return(p._Add=p.asm.Add).apply(null,arguments)},p._AddN=function(){return(p._AddN=p.asm.AddN).apply(null,arguments)},p._All=function(){return(p._All=p.asm.All).apply(null,arguments)},p._Any=function(){return(p._Any=p.asm.Any).apply(null,arguments)},p._ArgMax=function(){return(p._ArgMax=p.asm.ArgMax).apply(null,arguments)},p._AvgPool=function(){return(p._AvgPool=p.asm.AvgPool).apply(null,arguments)},p._BatchMatMul=function(){return(p._BatchMatMul=p.asm.BatchMatMul).apply(null,arguments)},p._Ceil=function(){return(p._Ceil=p.asm.Ceil).apply(null,arguments)},p._ClipByValue=function(){return(p._ClipByValue=p.asm.ClipByValue).apply(null,arguments)},p._Conv2D=function(){return(p._Conv2D=p.asm.Conv2D).apply(null,arguments)},p._Conv2DBackpropInput=function(){return(p._Conv2DBackpropInput=p.asm.Conv2DBackpropInput).apply(null,arguments)},p._Cos=function(){return(p._Cos=p.asm.Cos).apply(null,arguments)},p._Cosh=function(){return(p._Cosh=p.asm.Cosh).apply(null,arguments)},p._CropAndResize=function(){return(p._CropAndResize=p.asm.CropAndResize).apply(null,arguments)},p._Cumprod=function(){return(p._Cumprod=p.asm.Cumprod).apply(null,arguments)},p._Cumsum=function(){return(p._Cumsum=p.asm.Cumsum).apply(null,arguments)},p._DepthToSpace=function(){return(p._DepthToSpace=p.asm.DepthToSpace).apply(null,arguments)},p._DepthwiseConv2dNative=function(){return(p._DepthwiseConv2dNative=p.asm.DepthwiseConv2dNative).apply(null,arguments)},p._Elu=function(){return(p._Elu=p.asm.Elu).apply(null,arguments)},p._Equal=function(){return(p._Equal=p.asm.Equal).apply(null,arguments)},p._Exp=function(){return(p._Exp=p.asm.Exp).apply(null,arguments)},p._FlipLeftRight=function(){return(p._FlipLeftRight=p.asm.FlipLeftRight).apply(null,arguments)},p._Floor=function(){return(p._Floor=p.asm.Floor).apply(null,arguments)},p._FloorDiv=function(){return(p._FloorDiv=p.asm.FloorDiv).apply(null,arguments)},p._FusedBatchNorm=function(){return(p._FusedBatchNorm=p.asm.FusedBatchNorm).apply(null,arguments)},p._FusedConv2D=function(){return(p._FusedConv2D=p.asm.FusedConv2D).apply(null,arguments)},p._FusedDepthwiseConv2D=function(){return(p._FusedDepthwiseConv2D=p.asm.FusedDepthwiseConv2D).apply(null,arguments)},p._Gather=function(){return(p._Gather=p.asm.Gather).apply(null,arguments)},p._GatherNd=function(){return(p._GatherNd=p.asm.GatherNd).apply(null,arguments)},p._Greater=function(){return(p._Greater=p.asm.Greater).apply(null,arguments)},p._GreaterEqual=function(){return(p._GreaterEqual=p.asm.GreaterEqual).apply(null,arguments)},p._LeakyRelu=function(){return(p._LeakyRelu=p.asm.LeakyRelu).apply(null,arguments)},p._Less=function(){return(p._Less=p.asm.Less).apply(null,arguments)},p._LessEqual=function(){return(p._LessEqual=p.asm.LessEqual).apply(null,arguments)},p._Log=function(){return(p._Log=p.asm.Log).apply(null,arguments)},p._LogicalAnd=function(){return(p._LogicalAnd=p.asm.LogicalAnd).apply(null,arguments)},p._LogicalNot=function(){return(p._LogicalNot=p.asm.LogicalNot).apply(null,arguments)},p._LogicalOr=function(){return(p._LogicalOr=p.asm.LogicalOr).apply(null,arguments)},p._LogicalXor=function(){return(p._LogicalXor=p.asm.LogicalXor).apply(null,arguments)},p._Max=function(){return(p._Max=p.asm.Max).apply(null,arguments)},p._MaxPool=function(){return(p._MaxPool=p.asm.MaxPool).apply(null,arguments)},p._Maximum=function(){return(p._Maximum=p.asm.Maximum).apply(null,arguments)},p._Mean=function(){return(p._Mean=p.asm.Mean).apply(null,arguments)},p._Min=function(){return(p._Min=p.asm.Min).apply(null,arguments)},p._Minimum=function(){return(p._Minimum=p.asm.Minimum).apply(null,arguments)},p._MirrorPad=function(){return(p._MirrorPad=p.asm.MirrorPad).apply(null,arguments)},p._Multiply=function(){return(p._Multiply=p.asm.Multiply).apply(null,arguments)},p._Neg=function(){return(p._Neg=p.asm.Neg).apply(null,arguments)},p._NonMaxSuppressionV3=function(){return(p._NonMaxSuppressionV3=p.asm.NonMaxSuppressionV3).apply(null,arguments)},p._NonMaxSuppressionV4=function(){return(p._NonMaxSuppressionV4=p.asm.NonMaxSuppressionV4).apply(null,arguments)},p._NonMaxSuppressionV5=function(){return(p._NonMaxSuppressionV5=p.asm.NonMaxSuppressionV5).apply(null,arguments)},p._NotEqual=function(){return(p._NotEqual=p.asm.NotEqual).apply(null,arguments)},p._OneHot=function(){return(p._OneHot=p.asm.OneHot).apply(null,arguments)},p._PadV2=function(){return(p._PadV2=p.asm.PadV2).apply(null,arguments)},p._Pow=function(){return(p._Pow=p.asm.Pow).apply(null,arguments)},p._Prelu=function(){return(p._Prelu=p.asm.Prelu).apply(null,arguments)},p._Prod=function(){return(p._Prod=p.asm.Prod).apply(null,arguments)},p._RealDiv=function(){return(p._RealDiv=p.asm.RealDiv).apply(null,arguments)},p._Relu=function(){return(p._Relu=p.asm.Relu).apply(null,arguments)},p._Relu6=function(){return(p._Relu6=p.asm.Relu6).apply(null,arguments)},p._ResizeBilinear=function(){return(p._ResizeBilinear=p.asm.ResizeBilinear).apply(null,arguments)},p._ResizeNearestNeighbor=function(){return(p._ResizeNearestNeighbor=p.asm.ResizeNearestNeighbor).apply(null,arguments)},p._Reverse=function(){return(p._Reverse=p.asm.Reverse).apply(null,arguments)},p._RotateWithOffset=function(){return(p._RotateWithOffset=p.asm.RotateWithOffset).apply(null,arguments)},p._Round=function(){return(p._Round=p.asm.Round).apply(null,arguments)},p._Rsqrt=function(){return(p._Rsqrt=p.asm.Rsqrt).apply(null,arguments)},p._ScatterNd=function(){return(p._ScatterNd=p.asm.ScatterNd).apply(null,arguments)},p._SelectV2=function(){return(p._SelectV2=p.asm.SelectV2).apply(null,arguments)},p._Sigmoid=function(){return(p._Sigmoid=p.asm.Sigmoid).apply(null,arguments)},p._Sin=function(){return(p._Sin=p.asm.Sin).apply(null,arguments)},p._Softmax=function(){return(p._Softmax=p.asm.Softmax).apply(null,arguments)},p._SparseFillEmptyRows=function(){return(p._SparseFillEmptyRows=p.asm.SparseFillEmptyRows).apply(null,arguments)},p._SparseReshape=function(){return(p._SparseReshape=p.asm.SparseReshape).apply(null,arguments)},p._SparseSegmentReduction=function(){return(p._SparseSegmentReduction=p.asm.SparseSegmentReduction).apply(null,arguments)},p._Sqrt=function(){return(p._Sqrt=p.asm.Sqrt).apply(null,arguments)},p._Square=function(){return(p._Square=p.asm.Square).apply(null,arguments)},p._SquaredDifference=function(){return(p._SquaredDifference=p.asm.SquaredDifference).apply(null,arguments)},p._Step=function(){return(p._Step=p.asm.Step).apply(null,arguments)},p._StridedSlice=function(){return(p._StridedSlice=p.asm.StridedSlice).apply(null,arguments)},p._Sub=function(){return(p._Sub=p.asm.Sub).apply(null,arguments)},p._Sum=function(){return(p._Sum=p.asm.Sum).apply(null,arguments)},p._Tan=function(){return(p._Tan=p.asm.Tan).apply(null,arguments)},p._Tanh=function(){return(p._Tanh=p.asm.Tanh).apply(null,arguments)},p._Tile=function(){return(p._Tile=p.asm.Tile).apply(null,arguments)},p._TopK=function(){return(p._TopK=p.asm.TopK).apply(null,arguments)},p._Transform=function(){return(p._Transform=p.asm.Transform).apply(null,arguments)},p._Transpose=function(){return(p._Transpose=p.asm.Transpose).apply(null,arguments)},p.__FusedMatMul=function(){return(p.__FusedMatMul=p.asm._FusedMatMul).apply(null,arguments)},p._malloc=function(){return(p._malloc=p.asm.malloc).apply(null,arguments)},p._free=function(){return(p._free=p.asm.free).apply(null,arguments)},p.__emscripten_tls_init=function(){return(p.__emscripten_tls_init=p.asm._emscripten_tls_init).apply(null,arguments)};var Ee=p._pthread_self=function(){return(Ee=p._pthread_self=p.asm.pthread_self).apply(null,arguments)};p.___errno_location=function(){return(p.___errno_location=p.asm.__errno_location).apply(null,arguments)};var De=p.__emscripten_thread_init=function(){return(De=p.__emscripten_thread_init=p.asm._emscripten_thread_init).apply(null,arguments)};p.__emscripten_thread_crashed=function(){return(p.__emscripten_thread_crashed=p.asm._emscripten_thread_crashed).apply(null,arguments)},p._emscripten_main_thread_process_queued_calls=function(){return(p._emscripten_main_thread_process_queued_calls=p.asm.emscripten_main_thread_process_queued_calls).apply(null,arguments)},p._emscripten_main_browser_thread_id=function(){return(p._emscripten_main_browser_thread_id=p.asm.emscripten_main_browser_thread_id).apply(null,arguments)};var Oe=p._emscripten_run_in_main_runtime_thread_js=function(){return(Oe=p._emscripten_run_in_main_runtime_thread_js=p.asm.emscripten_run_in_main_runtime_thread_js).apply(null,arguments)};p._emscripten_dispatch_to_thread_=function(){return(p._emscripten_dispatch_to_thread_=p.asm.emscripten_dispatch_to_thread_).apply(null,arguments)};var Te,Ce,Pe,We=p.__emscripten_proxy_execute_task_queue=function(){return(We=p.__emscripten_proxy_execute_task_queue=p.asm._emscripten_proxy_execute_task_queue).apply(null,arguments)},ze=p.__emscripten_thread_free_data=function(){return(ze=p.__emscripten_thread_free_data=p.asm._emscripten_thread_free_data).apply(null,arguments)},je=p.__emscripten_thread_exit=function(){return(je=p.__emscripten_thread_exit=p.asm._emscripten_thread_exit).apply(null,arguments)},Ue=p._emscripten_stack_set_limits=function(){return(Ue=p._emscripten_stack_set_limits=p.asm.emscripten_stack_set_limits).apply(null,arguments)},Le=p.stackSave=function(){return(Le=p.stackSave=p.asm.stackSave).apply(null,arguments)},He=p.stackRestore=function(){return(He=p.stackRestore=p.asm.stackRestore).apply(null,arguments)},Be=p.stackAlloc=function(){return(Be=p.stackAlloc=p.asm.stackAlloc).apply(null,arguments)};function qe(e){if(!(J>0)){if(g)return i(p),X(),void postMessage({cmd:"loaded"});!function(){if(p.preRun)for("function"==typeof p.preRun&&(p.preRun=[p.preRun]);p.preRun.length;)e=p.preRun.shift(),V.unshift(e);var e;pe(V)}(),J>0||(p.setStatus?(p.setStatus("Running..."),setTimeout((function(){setTimeout((function(){p.setStatus("")}),1),t()}),1)):t())}function t(){Te||(Te=!0,p.calledRun=!0,j||(X(),i(p),p.onRuntimeInitialized&&p.onRuntimeInitialized(),function(){if(!g){if(p.postRun)for("function"==typeof p.postRun&&(p.postRun=[p.postRun]);p.postRun.length;)e=p.postRun.shift(),$.unshift(e);var e;pe($)}}()))}}if(p.dynCall_iijjiiii=function(){return(p.dynCall_iijjiiii=p.asm.dynCall_iijjiiii).apply(null,arguments)},p.dynCall_jiji=function(){return(p.dynCall_jiji=p.asm.dynCall_jiji).apply(null,arguments)},p.keepRuntimeAlive=K,p.wasmMemory=N,p.cwrap=function(e,t,n,a){var r=(n=n||[]).every((e=>"number"===e||"boolean"===e));return"string"!==t&&r&&!a?xe(e):function(){return Fe(e,t,n,arguments)}},p.ExitStatus=re,p.PThread=de,Z=function e(){Te||qe(),Te||(Z=e)},p.preInit)for("function"==typeof p.preInit&&(p.preInit=[p.preInit]);p.preInit.length>0;)p.preInit.pop()();if(qe(),d&&(Ce={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!d.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!d.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof WasmBackendModule)Pe=WasmBackendModule;else{if("undefined"==typeof e)throw new Error("Could not find wasm module in post.js");Pe=e}if(Ce){var Ve=Pe._dispose;Pe._dispose=function(){Ve(),Ce.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),Ce.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a})),Hr=wt({__proto__:null,default:Lr},[Lr]),Br='"use strict";var Module={};var ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string";if(ENVIRONMENT_IS_NODE){var nodeWorkerThreads=require("worker_threads");var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",data=>onmessage({data:data}));var fs=require("fs");Object.assign(global,{self:global,require:require,Module:Module,location:{href:__filename},Worker:nodeWorkerThreads.Worker,importScripts:function(f){(0,eval)(fs.readFileSync(f,"utf8"))},postMessage:function(msg){parentPort.postMessage(msg)},performance:global.performance||{now:function(){return Date.now()}}})}var initializedJS=false;var pendingNotifiedProxyingQueues=[];function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");if(ENVIRONMENT_IS_NODE){fs.writeSync(2,text+"\n");return}console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;self.alert=threadAlert;Module["instantiateWasm"]=(info,receiveInstance)=>{var instance=new WebAssembly.Instance(Module["wasmModule"],info);receiveInstance(instance);Module["wasmModule"]=null;return instance.exports};self.onunhandledrejection=e=>{throw e.reason??e};self.onmessage=e=>{try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob=="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance})}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.pthread_ptr,0,0,1);Module["establishStackSpace"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].threadInitTLS();if(!initializedJS){pendingNotifiedProxyingQueues.forEach(queue=>{Module["executeNotifiedProxyingQueue"](queue)});pendingNotifiedProxyingQueues=[];initializedJS=true}try{Module["invokeEntryPoint"](e.data.start_routine,e.data.arg)}catch(ex){if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["keepRuntimeAlive"]()){}else{Module["__emscripten_thread_exit"](ex.status)}}else{throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["__emscripten_thread_exit"](-1)}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processProxyingQueue"){if(initializedJS){Module["executeNotifiedProxyingQueue"](e.data.queue)}else{pendingNotifiedProxyingQueues.push(e.data.queue)}}else if(e.data.cmd){err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){if(Module["__emscripten_thread_crashed"]){Module["__emscripten_thread_crashed"]()}throw ex}};',qr=jr((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){var t,a,r,s="undefined"!=typeof(e=e||{})?e:{};s.ready=new Promise((function(e,n){t=e,a=n})),"undefined"!=typeof process&&process.listeners&&(r={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var u,i,o,d,p,l=Object.assign({},s),c="object"==typeof window,m="function"==typeof importScripts,f="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,h="";f?(h=m?ht.dirname(h)+"/":__dirname+"/","function"==typeof Ur&&(d=bt,p=ht),u=(e,t)=>(e=p.normalize(e),d.readFileSync(e,t?void 0:"utf8")),o=e=>{var t=u(e,!0);return t.buffer||(t=new Uint8Array(t)),t},i=(e,t,n)=>{e=p.normalize(e),d.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof j))throw e})),process.on("unhandledRejection",(function(e){throw e})),s.inspect=function(){return"[Emscripten Module object]"}):(c||m)&&(m?h=self.location.href:"undefined"!=typeof document&&document.currentScript&&(h=document.currentScript.src),n&&(h=n),h=0!==h.indexOf("blob:")?h.substr(0,h.replace(/[?#].*/,"").lastIndexOf("/")+1):"",u=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},m&&(o=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),i=(e,t,n)=>{var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=()=>{200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)});var b,y,_=s.print||console.log.bind(console),g=s.printErr||console.warn.bind(console);Object.assign(s,l),l=null,s.arguments,s.thisProgram,s.quit,s.wasmBinary&&(b=s.wasmBinary),s.noExitRuntime,"object"!=typeof WebAssembly&&C("no native wasm support detected");var w,k,I,M,S=!1,A="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function v(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&A)return A.decode(e.subarray(t,r));for(var s="";t<r;){var u=e[t++];if(128&u){var i=63&e[t++];if(192!=(224&u)){var o=63&e[t++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[t++])<65536)s+=String.fromCharCode(u);else{var d=u-65536;s+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function x(e){w=e,s.HEAP8=k=new Int8Array(e),s.HEAP16=new Int16Array(e),s.HEAP32=new Int32Array(e),s.HEAPU8=I=new Uint8Array(e),s.HEAPU16=new Uint16Array(e),s.HEAPU32=M=new Uint32Array(e),s.HEAPF32=new Float32Array(e),s.HEAPF64=new Float64Array(e)}s.INITIAL_MEMORY;var F,N,R=[],E=[],D=[],O=0,T=null;function C(e){s.onAbort&&s.onAbort(e),g(e="Aborted("+e+")"),S=!0,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw a(t),t}function P(e){return e.startsWith("data:application/octet-stream;base64,")}function W(e){return e.startsWith("file://")}function z(e){try{if(e==F&&b)return new Uint8Array(b);if(o)return o(e);throw"both async and sync fetching of the wasm failed"}catch(e){C(e)}}function j(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function U(e){for(;e.length>0;)e.shift()(s)}function L(e){try{return y.grow(e-w.byteLength+65535>>>16),x(y.buffer),1}catch(e){}}P(F="tfjs-backend-wasm.wasm")||(N=F,F=s.locateFile?s.locateFile(N,h):h+N);var H=[null,[],[]];function B(e,t){var n=H[e];0===t||10===t?((1===e?_:g)(v(n,0)),n.length=0):n.push(t)}function q(e){return s["_"+e]}function V(e,t,n,a,r){var s={string:e=>{var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,s=0;s<e.length;++s){var u=e.charCodeAt(s);if(u>=55296&&u<=57343&&(u=65536+((1023&u)<<10)|1023&e.charCodeAt(++s)),u<=127){if(n>=r)break;t[n++]=u}else if(u<=2047){if(n+1>=r)break;t[n++]=192|u>>6,t[n++]=128|63&u}else if(u<=65535){if(n+2>=r)break;t[n++]=224|u>>12,t[n++]=128|u>>6&63,t[n++]=128|63&u}else{if(n+3>=r)break;t[n++]=240|u>>18,t[n++]=128|u>>12&63,t[n++]=128|u>>6&63,t[n++]=128|63&u}}t[n]=0}(e,I,t,n)}(e,t=Z(n),n)}return t},array:e=>{var t=Z(e.length);return function(e,t){k.set(e,t)}(e,t),t}};function u(e){return"string"===t?(n=e)?v(I,n,a):"":"boolean"===t?Boolean(e):e;var n,a}var i=q(e),o=[],d=0;if(a)for(var p=0;p<a.length;p++){var l=s[n[p]];l?(0===d&&(d=Q()),o[p]=l(a[p])):o[p]=a[p]}var c=i.apply(null,o);return c=function(e){return 0!==d&&J(d),u(e)}(c)}var G={abort:function(){C("")},emscripten_get_heap_max:function(){return 2147483648},emscripten_memcpy_big:function(e,t,n){I.copyWithin(e,t,t+n)},emscripten_resize_heap:function(e){var t,n,a=I.length,r=2147483648;if((e>>>=0)>r)return!1;for(var s=1;s<=4;s*=2){var u=a*(1+.2/s);if(u=Math.min(u,e+100663296),L(Math.min(r,(t=Math.max(e,u))+((n=65536)-t%n)%n)))return!0}return!1},fd_close:function(e){return 52},fd_seek:function(e,t,n,a,r){return 70},fd_write:function(e,t,n,a){for(var r=0,s=0;s<n;s++){var u=M[t>>2],i=M[t+4>>2];t+=8;for(var o=0;o<i;o++)B(e,I[u+o]);r+=i}return M[a>>2]=r,0}};!function(){var e={env:G,wasi_snapshot_preview1:G};function t(e,t){var n,a=e.exports;s.asm=a,x((y=s.asm.memory).buffer),s.asm.__indirect_function_table,n=s.asm.__wasm_call_ctors,E.unshift(n),function(e){if(O--,s.monitorRunDependencies&&s.monitorRunDependencies(O),0==O&&T){var t=T;T=null,t()}}()}function n(e){t(e.instance)}function r(t){return function(){if(!b&&(c||m)){if("function"==typeof fetch&&!W(F))return fetch(F,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+F+"'";return e.arrayBuffer()})).catch((function(){return z(F)}));if(i)return new Promise((function(e,t){i(F,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return z(F)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){g("failed to asynchronously prepare wasm: "+e),C(e)}))}if(O++,s.monitorRunDependencies&&s.monitorRunDependencies(O),s.instantiateWasm)try{return s.instantiateWasm(e,t)}catch(e){g("Module.instantiateWasm callback failed with error: "+e),a(e)}(b||"function"!=typeof WebAssembly.instantiateStreaming||P(F)||W(F)||f||"function"!=typeof fetch?r(n):fetch(F,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return g("wasm streaming compile failed: "+e),g("falling back to ArrayBuffer instantiation"),r(n)}))}))).catch(a)}(),s.___wasm_call_ctors=function(){return(s.___wasm_call_ctors=s.asm.__wasm_call_ctors).apply(null,arguments)},s._init=function(){return(s._init=s.asm.init).apply(null,arguments)},s._init_with_threads_count=function(){return(s._init_with_threads_count=s.asm.init_with_threads_count).apply(null,arguments)},s._get_threads_count=function(){return(s._get_threads_count=s.asm.get_threads_count).apply(null,arguments)},s._register_tensor=function(){return(s._register_tensor=s.asm.register_tensor).apply(null,arguments)},s._dispose_data=function(){return(s._dispose_data=s.asm.dispose_data).apply(null,arguments)},s._dispose=function(){return(s._dispose=s.asm.dispose).apply(null,arguments)},s._Abs=function(){return(s._Abs=s.asm.Abs).apply(null,arguments)},s._Add=function(){return(s._Add=s.asm.Add).apply(null,arguments)},s._AddN=function(){return(s._AddN=s.asm.AddN).apply(null,arguments)},s._All=function(){return(s._All=s.asm.All).apply(null,arguments)},s._Any=function(){return(s._Any=s.asm.Any).apply(null,arguments)},s._ArgMax=function(){return(s._ArgMax=s.asm.ArgMax).apply(null,arguments)},s._AvgPool=function(){return(s._AvgPool=s.asm.AvgPool).apply(null,arguments)},s._BatchMatMul=function(){return(s._BatchMatMul=s.asm.BatchMatMul).apply(null,arguments)},s._Ceil=function(){return(s._Ceil=s.asm.Ceil).apply(null,arguments)},s._ClipByValue=function(){return(s._ClipByValue=s.asm.ClipByValue).apply(null,arguments)},s._Conv2D=function(){return(s._Conv2D=s.asm.Conv2D).apply(null,arguments)},s._Conv2DBackpropInput=function(){return(s._Conv2DBackpropInput=s.asm.Conv2DBackpropInput).apply(null,arguments)},s._Cos=function(){return(s._Cos=s.asm.Cos).apply(null,arguments)},s._Cosh=function(){return(s._Cosh=s.asm.Cosh).apply(null,arguments)},s._CropAndResize=function(){return(s._CropAndResize=s.asm.CropAndResize).apply(null,arguments)},s._Cumprod=function(){return(s._Cumprod=s.asm.Cumprod).apply(null,arguments)},s._Cumsum=function(){return(s._Cumsum=s.asm.Cumsum).apply(null,arguments)},s._DepthToSpace=function(){return(s._DepthToSpace=s.asm.DepthToSpace).apply(null,arguments)},s._DepthwiseConv2dNative=function(){return(s._DepthwiseConv2dNative=s.asm.DepthwiseConv2dNative).apply(null,arguments)},s._Elu=function(){return(s._Elu=s.asm.Elu).apply(null,arguments)},s._Equal=function(){return(s._Equal=s.asm.Equal).apply(null,arguments)},s._Exp=function(){return(s._Exp=s.asm.Exp).apply(null,arguments)},s._FlipLeftRight=function(){return(s._FlipLeftRight=s.asm.FlipLeftRight).apply(null,arguments)},s._Floor=function(){return(s._Floor=s.asm.Floor).apply(null,arguments)},s._FloorDiv=function(){return(s._FloorDiv=s.asm.FloorDiv).apply(null,arguments)},s._FusedBatchNorm=function(){return(s._FusedBatchNorm=s.asm.FusedBatchNorm).apply(null,arguments)},s._FusedConv2D=function(){return(s._FusedConv2D=s.asm.FusedConv2D).apply(null,arguments)},s._FusedDepthwiseConv2D=function(){return(s._FusedDepthwiseConv2D=s.asm.FusedDepthwiseConv2D).apply(null,arguments)},s._Gather=function(){return(s._Gather=s.asm.Gather).apply(null,arguments)},s._GatherNd=function(){return(s._GatherNd=s.asm.GatherNd).apply(null,arguments)},s._Greater=function(){return(s._Greater=s.asm.Greater).apply(null,arguments)},s._GreaterEqual=function(){return(s._GreaterEqual=s.asm.GreaterEqual).apply(null,arguments)},s._LeakyRelu=function(){return(s._LeakyRelu=s.asm.LeakyRelu).apply(null,arguments)},s._Less=function(){return(s._Less=s.asm.Less).apply(null,arguments)},s._LessEqual=function(){return(s._LessEqual=s.asm.LessEqual).apply(null,arguments)},s._Log=function(){return(s._Log=s.asm.Log).apply(null,arguments)},s._LogicalAnd=function(){return(s._LogicalAnd=s.asm.LogicalAnd).apply(null,arguments)},s._LogicalNot=function(){return(s._LogicalNot=s.asm.LogicalNot).apply(null,arguments)},s._LogicalOr=function(){return(s._LogicalOr=s.asm.LogicalOr).apply(null,arguments)},s._LogicalXor=function(){return(s._LogicalXor=s.asm.LogicalXor).apply(null,arguments)},s._Max=function(){return(s._Max=s.asm.Max).apply(null,arguments)},s._MaxPool=function(){return(s._MaxPool=s.asm.MaxPool).apply(null,arguments)},s._Maximum=function(){return(s._Maximum=s.asm.Maximum).apply(null,arguments)},s._Mean=function(){return(s._Mean=s.asm.Mean).apply(null,arguments)},s._Min=function(){return(s._Min=s.asm.Min).apply(null,arguments)},s._Minimum=function(){return(s._Minimum=s.asm.Minimum).apply(null,arguments)},s._MirrorPad=function(){return(s._MirrorPad=s.asm.MirrorPad).apply(null,arguments)},s._Multiply=function(){return(s._Multiply=s.asm.Multiply).apply(null,arguments)},s._Neg=function(){return(s._Neg=s.asm.Neg).apply(null,arguments)},s._NonMaxSuppressionV3=function(){return(s._NonMaxSuppressionV3=s.asm.NonMaxSuppressionV3).apply(null,arguments)},s._NonMaxSuppressionV4=function(){return(s._NonMaxSuppressionV4=s.asm.NonMaxSuppressionV4).apply(null,arguments)},s._NonMaxSuppressionV5=function(){return(s._NonMaxSuppressionV5=s.asm.NonMaxSuppressionV5).apply(null,arguments)},s._NotEqual=function(){return(s._NotEqual=s.asm.NotEqual).apply(null,arguments)},s._OneHot=function(){return(s._OneHot=s.asm.OneHot).apply(null,arguments)},s._PadV2=function(){return(s._PadV2=s.asm.PadV2).apply(null,arguments)},s._Pow=function(){return(s._Pow=s.asm.Pow).apply(null,arguments)},s._Prelu=function(){return(s._Prelu=s.asm.Prelu).apply(null,arguments)},s._Prod=function(){return(s._Prod=s.asm.Prod).apply(null,arguments)},s._RealDiv=function(){return(s._RealDiv=s.asm.RealDiv).apply(null,arguments)},s._Relu=function(){return(s._Relu=s.asm.Relu).apply(null,arguments)},s._Relu6=function(){return(s._Relu6=s.asm.Relu6).apply(null,arguments)},s._ResizeBilinear=function(){return(s._ResizeBilinear=s.asm.ResizeBilinear).apply(null,arguments)},s._ResizeNearestNeighbor=function(){return(s._ResizeNearestNeighbor=s.asm.ResizeNearestNeighbor).apply(null,arguments)},s._Reverse=function(){return(s._Reverse=s.asm.Reverse).apply(null,arguments)},s._RotateWithOffset=function(){return(s._RotateWithOffset=s.asm.RotateWithOffset).apply(null,arguments)},s._Round=function(){return(s._Round=s.asm.Round).apply(null,arguments)},s._Rsqrt=function(){return(s._Rsqrt=s.asm.Rsqrt).apply(null,arguments)},s._ScatterNd=function(){return(s._ScatterNd=s.asm.ScatterNd).apply(null,arguments)},s._SelectV2=function(){return(s._SelectV2=s.asm.SelectV2).apply(null,arguments)},s._Sigmoid=function(){return(s._Sigmoid=s.asm.Sigmoid).apply(null,arguments)},s._Sin=function(){return(s._Sin=s.asm.Sin).apply(null,arguments)},s._Softmax=function(){return(s._Softmax=s.asm.Softmax).apply(null,arguments)},s._SparseFillEmptyRows=function(){return(s._SparseFillEmptyRows=s.asm.SparseFillEmptyRows).apply(null,arguments)},s._SparseReshape=function(){return(s._SparseReshape=s.asm.SparseReshape).apply(null,arguments)},s._SparseSegmentReduction=function(){return(s._SparseSegmentReduction=s.asm.SparseSegmentReduction).apply(null,arguments)},s._Sqrt=function(){return(s._Sqrt=s.asm.Sqrt).apply(null,arguments)},s._Square=function(){return(s._Square=s.asm.Square).apply(null,arguments)},s._SquaredDifference=function(){return(s._SquaredDifference=s.asm.SquaredDifference).apply(null,arguments)},s._Step=function(){return(s._Step=s.asm.Step).apply(null,arguments)},s._StridedSlice=function(){return(s._StridedSlice=s.asm.StridedSlice).apply(null,arguments)},s._Sub=function(){return(s._Sub=s.asm.Sub).apply(null,arguments)},s._Sum=function(){return(s._Sum=s.asm.Sum).apply(null,arguments)},s._Tan=function(){return(s._Tan=s.asm.Tan).apply(null,arguments)},s._Tanh=function(){return(s._Tanh=s.asm.Tanh).apply(null,arguments)},s._Tile=function(){return(s._Tile=s.asm.Tile).apply(null,arguments)},s._TopK=function(){return(s._TopK=s.asm.TopK).apply(null,arguments)},s._Transform=function(){return(s._Transform=s.asm.Transform).apply(null,arguments)},s._Transpose=function(){return(s._Transpose=s.asm.Transpose).apply(null,arguments)},s.__FusedMatMul=function(){return(s.__FusedMatMul=s.asm._FusedMatMul).apply(null,arguments)},s._malloc=function(){return(s._malloc=s.asm.malloc).apply(null,arguments)},s._free=function(){return(s._free=s.asm.free).apply(null,arguments)},s.___errno_location=function(){return(s.___errno_location=s.asm.__errno_location).apply(null,arguments)};var $,K,X,Q=s.stackSave=function(){return(Q=s.stackSave=s.asm.stackSave).apply(null,arguments)},J=s.stackRestore=function(){return(J=s.stackRestore=s.asm.stackRestore).apply(null,arguments)},Z=s.stackAlloc=function(){return(Z=s.stackAlloc=s.asm.stackAlloc).apply(null,arguments)};function Y(e){function n(){$||($=!0,s.calledRun=!0,S||(U(E),t(s),s.onRuntimeInitialized&&s.onRuntimeInitialized(),function(){if(s.postRun)for("function"==typeof s.postRun&&(s.postRun=[s.postRun]);s.postRun.length;)e=s.postRun.shift(),D.unshift(e);var e;U(D)}()))}O>0||(function(){if(s.preRun)for("function"==typeof s.preRun&&(s.preRun=[s.preRun]);s.preRun.length;)e=s.preRun.shift(),R.unshift(e);var e;U(R)}(),O>0||(s.setStatus?(s.setStatus("Running..."),setTimeout((function(){setTimeout((function(){s.setStatus("")}),1),n()}),1)):n()))}if(s.dynCall_iijjiiii=function(){return(s.dynCall_iijjiiii=s.asm.dynCall_iijjiiii).apply(null,arguments)},s.dynCall_jiji=function(){return(s.dynCall_jiji=s.asm.dynCall_jiji).apply(null,arguments)},s.cwrap=function(e,t,n,a){var r=(n=n||[]).every((e=>"number"===e||"boolean"===e));return"string"!==t&&r&&!a?q(e):function(){return V(e,t,n,arguments)}},T=function e(){$||Y(),$||(T=e)},s.preInit)for("function"==typeof s.preInit&&(s.preInit=[s.preInit]);s.preInit.length>0;)s.preInit.pop()();if(Y(),r&&(K={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!r.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!r.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof e)X=e;else{if("undefined"==typeof WasmBackendModuleThreadedSimd)throw new Error("Could not find wasm module in post.js");X=WasmBackendModuleThreadedSimd}if(K){var ee=X._dispose;X._dispose=function(){ee(),K.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),K.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a}));const Vr=Lr||Hr,Gr=qr||wt({__proto__:null,default:qr},[qr]);class $r extends pt{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.initWithThreadsCount(rs),ss=this.wasm.tfjs.getThreadsCount(),this.dataIdMap=new lt(this,ct())}write(e,t,n){const a={id:this.dataIdNextNumber++};return this.move(a,e,t,n,1),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.now();e();return{kernelMs:n.now()-t}}move(e,t,a,r,s){const u=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:u,stringBytes:n,shape:a,dtype:r,memoryOffset:null,refCount:s})}const i=n.sizeFromShape(a),o=i*n.bytesPerElement(r),d=this.wasm._malloc(o);this.dataIdMap.set(e,{id:u,memoryOffset:d,shape:a,dtype:r,refCount:s}),this.wasm.tfjs.registerTensor(u,i,d),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,t.byteOffset,o),d)}async read(e){return this.readSync(e)}readSync(e,t,a){const{memoryOffset:r,dtype:s,shape:u,stringBytes:i}=this.dataIdMap.get(e);if("string"===s)return null!=t&&0!==t||!(null==a||a>=i.length)?i.slice(t,a):i;t=t||0,a=a||n.sizeFromShape(u);const o=n.bytesPerElement(s);return function(e,t){switch(t){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${t}`)}}(this.wasm.HEAPU8.slice(r+t*o,r+a*o).buffer,s)}disposeData(e,t=!1){if(this.dataIdMap.has(e)){const n=this.dataIdMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}return!0}refCount(e){if(this.dataIdMap.has(e)){return this.dataIdMap.get(e).refCount}return 0}incRef(e){const t=this.dataIdMap.get(e);null!=t&&t.refCount++}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{const s=this.dataIdNextNumber++;r={id:s},this.dataIdMap.set(r,{id:s,memoryOffset:a,shape:e,dtype:t,refCount:1});const u=n.sizeFromShape(e);this.wasm.tfjs.registerTensor(s,u,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:s}=this.dataIdMap.get(a),u=n.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,s,u);case"int32":return new Int32Array(r,s,u);case"bool":return new Uint8Array(r,s,u);default:throw new Error(`Unknown dtype ${t}`)}}}function Kr(e,t,n){if(null!=Jr)return Jr;let a="tfjs-backend-wasm.wasm";return e&&t?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=Yr&&null!=Yr[a]?Yr[a]:n+a}async function Xr(){const[e,t]=await Promise.all([dt().getAsync("WASM_HAS_SIMD_SUPPORT"),dt().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise(((a,r)=>{const s={};var u;s.locateFile=(n,a)=>{if(n.endsWith(".worker.js")){const e=Br.replace(/\n/g,"\\n"),t=new Blob([e],{type:"application/javascript"});return URL.createObjectURL(t)}return n.endsWith(".wasm")?Kr(e,t,null!=Zr?Zr:a):a+n},ts&&(s.instantiateWasm=(u=Kr(e,t,null!=Zr?Zr:""),(e,t)=>(n.fetch(u,{credentials:"same-origin"}).then((n=>{n.ok||e.env.a(`failed to load wasm binary file at '${u}'`),n.arrayBuffer().then((n=>{WebAssembly.instantiate(n,e).then((e=>{t(e.instance,e.module)}))}))})),{})));let i,o=!1;s.onAbort=()=>{if(o)return;if(es)return;es=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})},t&&e&&null==Jr?(s.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+Vr.toString()],{type:"text/javascript"}),i=Vr(s)):i=Gr(s),i.then((e=>{o=!0,es=!1;e.tfjs={init:e.cwrap("init",null,[]),initWithThreadsCount:e.cwrap("init_with_threads_count",null,["number"]),getThreadsCount:e.cwrap("get_threads_count","number",[]),registerTensor:e.cwrap("register_tensor",null,["number","number","number"]),disposeData:e.cwrap("dispose_data",null,["number"]),dispose:e.cwrap("dispose",null,[])},a({wasm:e})})).catch(r)}))}const Qr=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let Jr=null,Zr=null,Yr={},es=!1,ts=!1;function ns(e,t=!1){if(mt("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),es)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Jr=e,ts=t}function as(e,t=!1){if(es)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)Zr=e;else{Yr=e;const t=Qr.filter((e=>null==Yr[e]));if(t.length>0)throw new Error(`There were no entries found for the following binaries: ${t.join(",")}. Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.`)}ts=t}let rs=-1,ss=-1;function us(e){rs=e}function is(){if(-1===ss)throw new Error("WASM backend not initialized.");return ss}const os="4.0.0";ft("wasm",(async()=>{const{wasm:e}=await Xr();return new $r(e)}),2);export{$r as BackendWasm,is as getThreadsCount,us as setThreadsCount,ns as setWasmPath,as as setWasmPaths,os as version_wasm};
//# sourceMappingURL=tf-backend-wasm.fesm.min.js.map
