/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks"),require("os")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks","os"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks,e.require$$4)}(this,(function(e,t,n,a,r,u,i){"use strict";function s(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function o(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var a=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,a.get?a:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var d,p,l,c=s(n),m=s(a),f=s(r),h=s(u),b=s(i),_=function(e,t){return _=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])},_(e,t)};function y(e,t,n,a){return new(n||(n=Promise))((function(r,u){function i(e){try{o(a.next(e))}catch(e){u(e)}}function s(e){try{o(a.throw(e))}catch(e){u(e)}}function o(e){var t;e.done?r(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(i,s)}o((a=a.apply(e,t||[])).next())}))}function g(e,t){var n,a,r,u,i={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return u={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function s(u){return function(s){return function(u){if(n)throw new TypeError("Generator is already executing.");for(;i;)try{if(n=1,a&&(r=2&u[0]?a.return:u[0]?a.throw||((r=a.return)&&r.call(a),0):a.next)&&!(r=r.call(a,u[1])).done)return r;switch(a=0,r&&(u=[2&u[0],r.value]),u[0]){case 0:case 1:r=u;break;case 4:return i.label++,{value:u[1],done:!1};case 5:i.label++,a=u[1],u=[0];continue;case 7:u=i.ops.pop(),i.trys.pop();continue;default:if(!(r=i.trys,(r=r.length>0&&r[r.length-1])||6!==u[0]&&2!==u[0])){i=0;continue}if(3===u[0]&&(!r||u[1]>r[0]&&u[1]<r[3])){i.label=u[1];break}if(6===u[0]&&i.label<r[1]){i.label=r[1],r=u;break}if(r&&i.label<r[2]){i.label=r[2],i.ops.push(u);break}r[2]&&i.ops.pop(),i.trys.pop();continue}u=t.call(e,i)}catch(e){u=[6,e],a=0}finally{n=r=0}if(5&u[0])throw u[1];return{value:u[0]?u[1]:void 0,done:!0}}([u,s])}}}function v(e){var t="function"==typeof Symbol&&Symbol.iterator,n=t&&e[t],a=0;if(n)return n.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&a>=e.length&&(e=void 0),{value:e&&e[a++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function k(e,t){var n="function"==typeof Symbol&&e[Symbol.iterator];if(!n)return e;var a,r,u=n.call(e),i=[];try{for(;(void 0===t||t-- >0)&&!(a=u.next()).done;)i.push(a.value)}catch(e){r={error:e}}finally{try{a&&!a.done&&(n=u.return)&&n.call(u)}finally{if(r)throw r.error}}return i}function w(e,t,n){if(n||2===arguments.length)for(var a,r=0,u=t.length;r<u;r++)!a&&r in t||(a||(a=Array.prototype.slice.call(t,0,r)),a[r]=t[r]);return e.concat(a||Array.prototype.slice.call(t))}!function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(d||(d={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid",e[e.elu=6]="elu"}(p||(p={}));var I={kernelName:t._FusedMatMul,backendName:"wasm",setupFunc:function(e){l=e.wasm.cwrap(t._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.a,i=n.b,s=n.bias,o=n.preluActivationWeights;if("float32"!==u.dtype||"float32"!==i.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");var d=r.transposeA,c=r.transposeB,m=r.activation,f=r.leakyreluAlpha,h=a.dataIdMap.get(u.dataId).id,b=a.dataIdMap.get(i.dataId).id,_=0;if(null!=s){var y=a.dataIdMap.get(s.dataId);if(1!==y.shape.length)throw new Error("_FusedMatMul only supports rank-1 bias but got "+"rank ".concat(y.shape.length,"."));_=y.id}var g=null==o?0:a.dataIdMap.get(o.dataId).id,v=p[m];if(null==v)throw new Error("".concat(m," activation not yet supported for FusedConv2D ")+"in the wasm backend.");var I=d?u.shape[2]:u.shape[1],S=c?i.shape[1]:i.shape[2],M=t.broadcast_util.assertAndGetBroadcastShape(u.shape.slice(0,-2),i.shape.slice(0,-2)),A=a.makeOutput(w(w([],k(M),!1),[I,S],!1),u.dtype),x=a.dataIdMap.get(A.dataId).id,F=new Uint8Array(new Int32Array(u.shape).buffer),N=new Uint8Array(new Int32Array(i.shape).buffer);return l(h,F,u.shape.length,b,N,i.shape.length,d,c,v,_,g,f||0,x),A}};function S(e,n){var a;return{kernelName:e,backendName:"wasm",setupFunc:function(t){a=t.wasm.cwrap(e,null,["number","number","number"])},kernelFunc:function(e){var r=e.backend,u=e.inputs.x,i=r.dataIdMap.get(u.dataId).id,s=r.makeOutput(u.shape,n||u.dtype),o=r.dataIdMap.get(s.dataId).id;return 0===t.util.sizeFromShape(s.shape)||a(i,d[u.dtype],o),s}}}var M=S(t.Abs);function A(e,n,a){var r;return{kernelName:e,backendName:"wasm",setupFunc:function(t){r=t.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(e){var n=e.backend,u=e.inputs,i=u.a,s=u.b,o=n.dataIdMap.get(i.dataId).id,p=n.dataIdMap.get(s.dataId).id,l=null!=a?a:i.dtype,c=t.backend_util.assertAndGetBroadcastShape(i.shape,s.shape),m=n.makeOutput(c,l);if(0===t.util.sizeFromShape(c))return m;var f=new Uint8Array(new Int32Array(i.shape).buffer),h=new Uint8Array(new Int32Array(s.shape).buffer),b=n.dataIdMap.get(m.dataId).id;return r(o,f,i.shape.length,p,h,s.shape.length,d[i.dtype],b),m}}}var x,F=A(t.Add);var N={kernelName:t.AddN,backendName:"wasm",setupFunc:function(e){x=e.wasm.cwrap(t.AddN,null,["array","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,r=a.makeOutput(n[0].shape,n[0].dtype);if(0===t.util.sizeFromShape(r.shape))return r;var u=n.map((function(e){return a.dataIdMap.get(e.dataId).id})),i=new Uint8Array(new Int32Array(u).buffer),s=a.dataIdMap.get(r.dataId).id;return x(i,u.length,d[r.dtype],s),r}};function R(e){var n=e.inputs.x,a=e.backend;if("string"===n.dtype)return t.tensor(a.readSync(n.dataId),n.shape,n.dtype);var r=a.makeOutput(n.shape,n.dtype),u=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(u),r}var E,D={kernelName:t.Identity,backendName:"wasm",kernelFunc:R};function O(e){for(var t=e.inputs,n=e.backend,a=e.attrs,r=k(function(e,t){for(var n=[],a=[],r=0;r<e.length;++r)1!==e[r]&&n.push(e[r]),1!==e[t[r]]&&a.push(t[r]);for(r=0;r<a.length;++r){for(var u=-1,i=0;i<a.length;++i)a[i]>=r&&(-1===u||a[u]>a[i])&&(u=i);a[u]=r}return[n,a]}(t.x.shape,a.perm),2),u=r[0],i=r[1],s=!0,o=0;o<i.length;o++)i[o]!==o&&(s=!1);var p=function(e,t){for(var n=new Array(e.length),a=0;a<n.length;a++)n[a]=e[t[a]];return n}(t.x.shape,a.perm),l={dataId:t.x.dataId,shape:u,dtype:t.x.dtype};if(s){var c=R({inputs:t,backend:n});return c.shape=p,c}var m=n.makeOutput(p,l.dtype),f=n.dataIdMap.get(l.dataId).id,h=n.dataIdMap.get(m.dataId).id,b=new Uint8Array(new Int32Array(i).buffer),_=new Uint8Array(new Int32Array(l.shape).buffer);return E(f,_,l.shape.length,d[l.dtype],h,b,i.length),m}var T,C={kernelName:t.Transpose,backendName:"wasm",kernelFunc:O,setupFunc:function(e){E=e.wasm.cwrap(t.Transpose,null,["number","array","number","number","number","array","number"])}};function P(e,n,a){var r=e.shape,u=e.shape.length,i=t.util.parseAxisParam(n,r),s=i,o=t.backend_util.getAxesPermutation(s,u),d=null,p=!1;if(null!=o){for(var l=new Array(u),c=0;c<l.length;c++)l[c]=r[o[c]];s=t.backend_util.getInnerMostAxes(s.length,u),d=O({inputs:{x:e},attrs:{perm:o},backend:a});var m=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(d.dataId).id!==m&&(p=!0)}return{transposed:d,originalAxes:i,axes:s,inputWasTransposed:p}}var W,z={kernelName:t.All,backendName:"wasm",setupFunc:function(e){T=e.wasm.cwrap(t.All,null,["number, number, number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,d=s,p=P(s,u,n),l=p.transposed,c=p.axes,m=p.originalAxes,f=p.inputWasTransposed;f&&(d=l,o=n.dataIdMap.get(l.dataId).id);var h=d.shape.length;t.backend_util.assertAxesAreInnerMostDims("all",c,h);var b=k(t.backend_util.computeOutAndReduceShapes(d.shape,c),2),_=b[0],y=b[1],g=t.util.sizeFromShape(y),v=n.makeOutput(_,s.dtype);if(0!==t.util.sizeFromShape(d.shape)){var w=n.dataIdMap.get(v.dataId).id;T(o,g,w)}if(f&&n.disposeData(l.dataId),i){var I=t.backend_util.expandShapeToKeepDim(v.shape,m);v.shape=I}return v}};var j,L={kernelName:t.Any,backendName:"wasm",setupFunc:function(e){W=e.wasm.cwrap(t.Any,null,["number, number, number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,d=s,p=P(s,u,n),l=p.transposed,c=p.axes,m=p.originalAxes,f=p.inputWasTransposed;f&&(d=l,o=n.dataIdMap.get(l.dataId).id);var h=d.shape.length;t.backend_util.assertAxesAreInnerMostDims("any",c,h);var b=k(t.backend_util.computeOutAndReduceShapes(d.shape,c),2),_=b[0],y=b[1],g=t.util.sizeFromShape(y),v=n.makeOutput(_,s.dtype);if(0!==t.util.sizeFromShape(d.shape)){var w=n.dataIdMap.get(v.dataId).id;W(o,g,w)}if(f&&n.disposeData(l.dataId),i){var I=t.backend_util.expandShapeToKeepDim(v.shape,m);v.shape=I}return v}};var B,U={kernelName:t.ArgMax,backendName:"wasm",kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs.axis,u=a.x,i=n.dataIdMap.get(u.dataId).id,s=i,o=u,p=P(u,r,n),l=p.transposed,c=p.axes,m=p.inputWasTransposed;if(m){var f=n.dataIdMap.get(l.dataId).id;f!==i&&(o=l,s=f)}var h=o.shape.slice(0,-1),b=n.makeOutput(h,"int32"),_=n.dataIdMap.get(b.dataId).id,y=t.util.sizeFromShape(b.shape),g=o.shape[c[0]];return j(s,d[o.dtype],y,g,_),m&&n.disposeData(l.dataId),b},setupFunc:function(e){j=e.wasm.cwrap(t.ArgMax,null,["number","number","number","number","number"])}};var q={kernelName:t.AvgPool,backendName:"wasm",setupFunc:function(e){B=e.wasm.cwrap(t.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=r.dataIdMap.get(u.dataId).id,s=a.filterSize,o=a.strides,d=a.pad,p=a.dimRoundingMode,l=t.backend_util.computePool2DInfo(u.shape,s,o,1,d,p),c=l.filterHeight,m=l.filterWidth,f=l.padInfo.top,h=l.padInfo.right,b=l.padInfo.bottom,_=l.padInfo.left,y=l.strideHeight,g=l.strideWidth,v=l.inChannels;if("channelsLast"!==l.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+"".concat(l.dataFormat,"'. Please use 'channelsLast'."));if(1!==l.dilationWidth||1!==l.dilationHeight)throw new Error("was backend only supports average pooling with dilation = [1, 1], "+"got [".concat(l.dilationHeight,", ").concat(l.dilationWidth,"]."));var k=r.makeOutput(l.outShape,"float32"),w=r.dataIdMap.get(k.dataId).id;return B(i,u.shape[0],u.shape[1],u.shape[2],c,m,f,h,b,_,y,g,v,w),k}};function H(e){var n=e.inputs,a=e.attrs,r=n.x,u=a.shape,i=t.util.sizeFromShape(r.shape),s=t.util.inferFromImplicitShape(u,i);return t.util.assert(i===t.util.sizeFromShape(s),(function(){return"new shape: ".concat(s,", old shape: ").concat(r.shape,". New shape and old ")+"shape must have the same number of elements."})),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:s,dtype:r.dtype}}var V,G={kernelName:t.Reshape,backendName:"wasm",kernelFunc:H};var K={kernelName:t.BatchMatMul,backendName:"wasm",setupFunc:function(e){V=e.wasm.cwrap(t.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.a,i=n.b,s=r.transposeA,o=r.transposeB;if("float32"!==u.dtype||"float32"!==i.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");var d=u.shape.length,p=i.shape.length,l=s?u.shape[d-2]:u.shape[d-1],c=o?i.shape[p-1]:i.shape[p-2],m=s?u.shape[d-1]:u.shape[d-2],f=o?i.shape[p-2]:i.shape[p-1],h=u.shape.slice(0,-2),b=i.shape.slice(0,-2),_=t.util.sizeFromShape(h),y=t.util.sizeFromShape(b),g=t.broadcast_util.assertAndGetBroadcastShape(u.shape.slice(0,-2),i.shape.slice(0,-2)).concat([m,f]);t.util.assert(l===c,(function(){return"Error in matMul: inner shapes (".concat(l,") and (")+"".concat(c,") of Tensors with shapes ").concat(u.shape," and ")+"".concat(i.shape," and transposeA=").concat(s)+" and transposeB=".concat(o," must match.")}));var v=o?[y,f,c]:[y,c,f],k=H({inputs:{x:u},backend:a,attrs:{shape:s?[_,l,m]:[_,m,l]}}),w=H({inputs:{x:i},backend:a,attrs:{shape:v}}),I=a.dataIdMap.get(k.dataId).id,S=a.dataIdMap.get(w.dataId).id,M=s?k.shape[2]:k.shape[1],A=o?w.shape[1]:w.shape[2],x=Math.max(_,y),F=a.makeOutput([x,M,A],k.dtype),N=a.dataIdMap.get(F.dataId).id,R=new Uint8Array(new Int32Array(k.shape).buffer),E=new Uint8Array(new Int32Array(w.shape).buffer);return V(I,R,k.shape.length,S,E,w.shape.length,s,o,N),a.disposeData(k.dataId),a.disposeData(w.dataId),F.shape=g,F}};function X(e,n,a,r,u){var i=t.slice_util.isSliceContinous(r,n,a),s=t.util.sizeFromShape(a),o=t.util.computeStrides(r);if(i){var d=t.slice_util.computeFlatOffset(n,o);return"string"===u?e.slice(d,d+s):e.subarray(d,d+s)}for(var p="string"===u?t.backend_util.fromUint8ToStringArray(e):e,l=t.buffer(r,u,p),c=t.buffer(a,u),m=0;m<c.size;++m){var f=c.indexToLoc(m),h=f.map((function(e,t){return e+n[t]}));c.set.apply(c,w([l.get.apply(l,w([],k(h),!1))],k(f),!1))}return"string"===u?t.backend_util.fromStringArrayToUint8(c.values):c.values}t.backend_util.RowPartitionType;var Q=function(){function e(e,n,a,r,u,i){this.separator=t.util.encodeString(e),this.nGramWidths=n,this.leftPad=t.util.encodeString(a),this.rightPad=t.util.encodeString(r),this.padWidth=u,this.preserveShort=i}return e.prototype.getPadWidth=function(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)},e.prototype.getNumNGrams=function(e,t){var n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)},e.prototype.createNGrams=function(e,t,n,a,r,u){for(var i=function(i){var o=s.getPadWidth(u),d=Math.max(0,o-i),p=Math.max(0,o-(r-(i+1))),l=u-(d+p),c=t+(d>0?0:i-o),m=0;m+=d*s.leftPad.length;for(var f=0;f<l;++f)m+=e[c+f].length;m+=p*s.rightPad.length,m+=(d+p+l-1)*s.separator.length,n[a+i]=new Uint8Array(m);var h=n[a+i],b=0,_=function(e){return e.forEach((function(e){return h[b++]=e}))};for(f=0;f<d;++f)_(s.leftPad),_(s.separator);for(f=0;f<l-1;++f)_(e[c+f]),_(s.separator);if(l>0){_(e[c+l-1]);for(f=0;f<p;++f)_(s.separator),_(s.rightPad)}else{for(f=0;f<p-1;++f)_(s.rightPad),_(s.separator);_(s.rightPad)}},s=this,o=0;o<r;++o)i(o)},e.prototype.compute=function(e,n){var a=this,r=e.length,u=n.length;if(u>0){var i=n[0];if(0!==i)throw new Error("First split value must be 0, got ".concat(i));for(var s=1;s<u;++s){var o=n[s]>=i;if(!(o=o&&n[s]<=r))throw new Error("Invalid split value ".concat(n[s],", must be in [").concat(i,", ").concat(r,"]"));i=n[s]}if(i!==r)throw new Error("Last split value must be data size. Expected ".concat(r,", got ").concat(i))}var d=u-1,p=t.util.getArrayFromDType("int32",u);if(0===r||0===u){var l=new Array(r);for(s=0;s<=d;++s)p[s]=0;return[l,p]}p[0]=0;var c=function(e){var t=n[e]-n[e-1],r=0;m.nGramWidths.forEach((function(e){r+=a.getNumNGrams(t,e)})),m.preserveShort&&t>0&&0===r&&(r=1),p[e]=p[e-1]+r},m=this;for(s=1;s<=d;++s)c(s);var f=new Array(p[d]),h=function(t){var r=n[t],u=p[t];if(b.nGramWidths.forEach((function(i){var s=n[t+1]-n[t],o=a.getNumNGrams(s,i);a.createNGrams(e,r,f,u,o,i),u+=o})),b.preserveShort&&u===p[t]){var i=n[t+1]-n[t];if(0===i)return"continue";var s=i+2*b.padWidth;b.createNGrams(e,r,f,u,1,s)}},b=this;for(s=0;s<d;++s)h(s);return[f,p]},e}();function J(e,t,n,a){if(e.length)if(0!==t.length)if(1!==t.length){var r=0;for(o=0;o<e.length+1;o++)if(o===e.length||-1!==t.indexOf(e[o])){s=e.subarray(r,o);n&&0===s.length||a.push(s),r=o+1}}else{for(var u=t[0],i=e.indexOf(u);-1!==i;){var s=e.subarray(0,i);n&&0===s.length||a.push(s),i=(e=e.subarray(i+1)).indexOf(u)}n&&0===e.length||a.push(e)}else for(var o=0;o<e.length;++o)a.push(e.subarray(o,o+1))}function Z(e){var n=e.inputs.x,a=e.attrs,r=a.begin,u=a.size,i=e.backend,s=k(t.slice_util.parseSliceParams(n,r,u),2),o=s[0],d=s[1],p=t.slice_util.isSliceContinous(n.shape,o,d),l=i.readSync(n.dataId),c=i.makeOutput(d,n.dtype),m=t.util.computeStrides(n.shape),f=i.dataIdMap.get(c.dataId);if(p){var h=t.slice_util.computeFlatOffset(o,m);if("string"===n.dtype)f.stringBytes=l.slice(h,h+t.util.sizeFromShape(d));else i.typedArrayFromHeap(c).set(l.subarray(h,h+t.util.sizeFromShape(d)));return c}if("string"===n.dtype){var b=X(l,o,d,n.shape,n.dtype);return f.stringBytes=b,c}var _=i.typedArrayFromHeap(c),y=n.shape.length;if(2===y)!function(e,t,n,a,r){for(var u=0,i=a[0],s=a[1],o=i+r[0],d=i;d<o;d++){var p=d*t+s;n.set(e.subarray(p,p+r[1]),u),u+=r[1]}}(l,m[0],_,o,d);else if(3===y)!function(e,t,n,a,r,u){for(var i=0,s=r[0],o=r[1],d=r[2],p=s+u[0],l=o+u[1],c=s;c<p;c++)for(var m=o;m<l;m++){var f=c*t+m*n+d;a.set(e.subarray(f,f+u[2]),i),i+=u[2]}}(l,m[0],m[1],_,o,d);else if(4===y)!function(e,t,n,a,r,u,i){for(var s=0,o=u[0],d=u[1],p=u[2],l=o+i[0],c=d+i[1],m=p+i[2],f=u[3],h=o;h<l;h++)for(var b=d;b<c;b++)for(var _=p;_<m;_++){var y=h*t+b*n+_*a+f;r.set(e.subarray(y,y+i[3]),s),s+=i[3]}}(l,m[0],m[1],m[2],_,o,d);else{b=X(l,o,d,n.shape,n.dtype);_.set(b)}return c}var Y={kernelName:t.Slice,backendName:"wasm",kernelFunc:Z};var $={kernelName:t.BatchToSpaceND,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.x,i=r.blockShape,s=r.crops,o=i.reduce((function(e,t){return e*t})),d=t.backend_util.getReshaped(u.shape,i,o),p=t.backend_util.getPermuted(d.length,i.length),l=t.backend_util.getReshapedPermuted(u.shape,i,o),c=t.backend_util.getSliceBeginCoords(s,i.length),m=t.backend_util.getSliceSize(l,s,i.length),f=H({inputs:{x:u},backend:a,attrs:{shape:d}}),h=O({inputs:{x:f},backend:a,attrs:{perm:p}}),b=Z({inputs:{x:H({inputs:{x:h},backend:a,attrs:{shape:l}})},backend:a,attrs:{begin:c,size:m}});return a.disposeData(f.dataId),a.disposeData(h.dataId),a.disposeData(f.dataId),b}};function ee(e){var t=e.inputs.x,n=e.attrs.dtype,a=e.backend,r=a.makeOutput(t.shape,n),u=a.typedArrayFromHeap(t);return a.typedArrayFromHeap(r).set(u),r}var te,ne={kernelName:t.Cast,backendName:"wasm",kernelFunc:ee},ae=S(t.Ceil);var re={kernelName:t.ClipByValue,backendName:"wasm",setupFunc:function(e){te=e.wasm.cwrap(t.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,n=e.backend,a=e.attrs,r=t.x,u=a.clipValueMin,i=a.clipValueMax,s=n.dataIdMap.get(r.dataId).id,o=n.makeOutput(r.shape,r.dtype),d=n.dataIdMap.get(o.dataId).id;return te(s,u,i,d),o}};function ue(e){var n=e.inputs,a=e.backend,r=t.util.parseAxisParam(e.attrs.axis,n[0].shape)[0],u=n.map((function(e){return e.shape}));t.backend_util.assertParamsConsistent(u,r);var i=t.backend_util.computeOutShape(n.map((function(e){return e.shape})),r),s=n.filter((function(e){return t.util.sizeFromShape(e.shape)>0}));if(1===s.length)return R({inputs:{x:s[0]},backend:a});var o=a.makeOutput(i,n[0].dtype);if(0===t.util.sizeFromShape(i))return o;if("string"===s[0].dtype){var d=s.map((function(e){var n=t.util.sizeFromShape(e.shape.slice(r));return H({inputs:{x:e},backend:a,attrs:{shape:[-1,n]}})})),p=d.map((function(e){return{vals:a.readSync(e.dataId),shape:e.shape}}));i=t.backend_util.computeOutShape(d.map((function(e){return e.shape})),1);var l=1===d[0].shape[0],c=function(e,n,a,r){var u=t.util.getArrayFromDType(a,t.util.sizeFromShape(n));if(r&&"string"!==a){var i=0;e.forEach((function(e){var n=t.util.sizeFromShape(e.shape);u.set(e.vals,i),i+=n}))}else{var s=0;e.forEach((function(e){for(var r="string"===a?t.backend_util.fromUint8ToStringArray(e.vals):e.vals,i=0,o=0;o<e.shape[0];++o)for(var d=o*n[1]+s,p=0;p<e.shape[1];++p)u[d+p]=r[i++];s+=e.shape[1]}))}return u}(p,i,n[0].dtype,l),m=t.backend_util.computeOutShape(s.map((function(e){return e.shape})),r);return o.shape=m,a.dataIdMap.get(o.dataId).stringBytes=t.backend_util.fromStringArrayToUint8(c),d.forEach((function(e){return a.disposeData(e.dataId)})),o}for(var f=t.util.sizeFromShape(s[0].shape.slice(0,r)),h=0,b=s.map((function(e){var n=t.util.sizeFromShape(e.shape.slice(r));return h+=n,n})),_=s.map((function(e){return a.typedArrayFromHeap(e)})),y=a.typedArrayFromHeap(o),g=0;g<f;g++)for(var v=g*h,k=0;k<_.length;k++){var w=b[k],I=g*w,S=_[k].subarray(I,I+w);y.set(S,v),v+=w}return o}var ie,se={kernelName:t.Concat,backendName:"wasm",kernelFunc:ue};var oe,de={kernelName:t.Conv2D,backendName:"wasm",setupFunc:function(e){ie=e.wasm.cwrap(t.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=n.filter,s=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(i.dataId).id,d=a.strides,p=a.dilations,l=a.pad,c=a.dimRoundingMode,m=a.dataFormat,f=t.backend_util.convertConv2DDataFormat(m),h=t.backend_util.computeConv2DInfo(u.shape,i.shape,d,p,l,c,!1,f),b=h.filterHeight,_=h.filterWidth,y=h.padInfo.top,g=h.padInfo.right,v=h.padInfo.bottom,k=h.padInfo.left,w=h.dilationHeight,I=h.dilationWidth,S=h.strideHeight,M=h.strideWidth,A=h.inChannels,x=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+"".concat(h.dataFormat,"'. Please use 'channelsLast'."));var N=r.makeOutput(h.outShape,"float32"),R=r.dataIdMap.get(N.dataId).id;return ie(s,u.shape[0],u.shape[1],u.shape[2],o,b,_,y,g,v,k,F,w,I,S,M,A,x,R),N}};var pe,le,ce={kernelName:t.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){oe=e.wasm.cwrap(t.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.dy,i=a.filter,s=r.strides,o=r.pad,d=r.dataFormat,p=r.dimRoundingMode,l=r.inputShape,c=t.backend_util.convertConv2DDataFormat(d),m=t.backend_util.computeConv2DInfo(l,i.shape,s,1,o,p,!1,c),f=m.batchSize,h=m.filterHeight,b=m.filterWidth,_=m.inChannels,y=m.inHeight,g=m.inWidth,v=m.outChannels,w=m.outHeight,I=m.outWidth,S=m.strideHeight,M=m.strideWidth,A=h-1-m.padInfo.top,x=b-1-m.padInfo.left,F="channelsLast"===m.dataFormat,N=t.util.computeStrides(m.inShape),R=t.util.computeStrides(u.shape),E=k(t.util.computeStrides(i.shape),3),D=E[0],O=E[1],T=E[2],C=N[0],P=F?N[1]:N[2],W=F?N[2]:1,z=F?1:N[1],j=R[0],L=F?R[1]:R[2],B=F?R[2]:1,U=F?1:R[1],q=n.makeOutput(m.inShape,"float32"),H=n.dataIdMap.get(q.dataId).id,V=n.dataIdMap.get(u.dataId).id,G=n.dataIdMap.get(i.dataId).id;return oe(V,G,f,h,b,y,g,_,w,I,v,S,M,A,x,D,O,T,C,P,W,z,j,L,B,U,H),q}},me=S(t.Cos),fe=S(t.Cosh);!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(pe||(pe={}));var he,be={kernelName:t.CropAndResize,backendName:"wasm",setupFunc:function(e){le=e.wasm.cwrap(t.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){var t,n=e.backend,a=e.inputs,r=e.attrs,u=r.method,i=r.extrapolationValue,s=r.cropSize,o=a.image,d=a.boxes,p=a.boxInd,l=d.shape[0],c=k(s,2),m=c[0],f=c[1],h=[l,m,f,o.shape[3]],b=n.dataIdMap.get(o.dataId);"float32"!==o.dtype&&(t=ee({backend:n,inputs:{x:o},attrs:{dtype:"float32"}}),b=n.dataIdMap.get(t.dataId));var _=b.id,y=n.dataIdMap.get(d.dataId).id,g=n.dataIdMap.get(p.dataId).id,v=n.makeOutput(h,"float32"),w=n.dataIdMap.get(v.dataId).id,I=new Uint8Array(new Int32Array(o.shape).buffer);return le(_,y,g,l,I,m,f,pe[u],i,w),null!=t&&n.disposeData(t.dataId),v}};var _e,ye={kernelName:t.Cumprod,backendName:"wasm",setupFunc:function(e){he=e.wasm.cwrap(t.Cumprod,null,["number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.x,i=r.axis,s=r.exclusive,o=r.reverse,p=u.shape.length;t.util.assert("float32"===u.dtype||"int32"===u.dtype,(function(){return"cumprod does not support ".concat(u.dtype," tensors in the WASM backend")}));var l=t.backend_util.getAxesPermutation([i],p),c=u;null!==l&&(c=O({inputs:{x:u},attrs:{perm:l},backend:a}));var m=t.backend_util.getInnerMostAxes(1,p)[0];t.backend_util.assertAxesAreInnerMostDims("cumprod",[m],p);var f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,_=a.dataIdMap.get(f.dataId).id;he(b,s?1:0,o?1:0,h,_,d[u.dtype]);var y=f;return null!==l&&(y=O({inputs:{x:f},attrs:{perm:t.backend_util.getUndoAxesPermutation(l)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)),y}};var ge,ve={kernelName:t.Cumsum,backendName:"wasm",setupFunc:function(e){_e=e.wasm.cwrap(t.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.x,i=r.axis,s=r.exclusive,o=r.reverse,p=u.shape.length;t.util.assert("float32"===u.dtype||"int32"===u.dtype,(function(){return"cumsum does not support ".concat(u.dtype," tensors in the WASM backend")}));var l=t.backend_util.getAxesPermutation([i],p),c=u;null!==l&&(c=O({inputs:{x:u},attrs:{perm:l},backend:a}));var m=t.backend_util.getInnerMostAxes(1,p)[0];t.backend_util.assertAxesAreInnerMostDims("cumsum",[m],p);var f=a.makeOutput(c.shape,c.dtype),h=c.shape[m],b=a.dataIdMap.get(c.dataId).id,_=a.dataIdMap.get(f.dataId).id;_e(b,s?1:0,o?1:0,h,_,d[u.dtype]);var y=f;return null!==l&&(y=O({inputs:{x:f},attrs:{perm:t.backend_util.getUndoAxesPermutation(l)},backend:a}),a.disposeData(c.dataId),a.disposeData(f.dataId)),y}};var ke,we={kernelName:t.DepthToSpace,backendName:"wasm",setupFunc:function(e){ge=e.wasm.cwrap(t.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.x,i=r.blockSize,s=r.dataFormat,o=u.shape[0],d=("NHWC"===s?u.shape[1]:u.shape[2])*i,p=("NHWC"===s?u.shape[2]:u.shape[3])*i,l=("NHWC"===s?u.shape[3]:u.shape[1])/(i*i),c="NHWC"===s?[o,d,p,l]:[o,l,d,p],m=n.makeOutput(c,"float32"),f=n.dataIdMap.get(u.dataId).id,h=new Uint8Array(new Int32Array(t.util.computeStrides(u.shape)).buffer),b=new Uint8Array(new Int32Array(c).buffer),_=new Uint8Array(new Int32Array(t.util.computeStrides(c)).buffer),y=n.dataIdMap.get(m.dataId).id;return ge(f,i,"NHWC"===s?1:0,h,u.shape.length-1,b,_,c.length,y),m}};var Ie={kernelName:t.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){ke=e.wasm.cwrap(t.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=n.filter,s=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(i.dataId).id,d=a.strides,p=a.dilations,l=a.pad,c=a.dimRoundingMode,m=null==p?[1,1]:p,f=t.backend_util.computeConv2DInfo(u.shape,i.shape,d,m,l,c,!0),h=f.filterHeight,b=f.filterWidth,_=f.padInfo.top,y=f.padInfo.right,g=f.padInfo.bottom,v=f.padInfo.left,k=f.dilationHeight,w=f.dilationWidth,I=f.strideHeight,S=f.strideWidth,M=f.inChannels,A=f.outChannels,x="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+"".concat(f.dataFormat,"'. Please use 'channelsLast'."));var F=r.makeOutput(f.outShape,"float32"),N=r.dataIdMap.get(F.dataId).id;return ke(s,u.shape[0],u.shape[1],u.shape[2],o,h,b,_,y,g,v,x,k,w,I,S,M,A,N),F}},Se=S(t.Elu),Me=A(t.Equal,0,"bool"),Ae=S(t.Exp,"float32");function xe(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.input,i=a.dim,s=u.shape.length,o=u.shape.slice(),d=i;return i<0&&(t.util.assert(-(s+1)<=i,(function(){return"Axis must be in the interval [".concat(-(s+1),", ").concat(s,"]")})),d=s+i+1),o.splice(d,0,1),H({inputs:{x:u},backend:r,attrs:{shape:o}})}var Fe={kernelName:t.ExpandDims,backendName:"wasm",kernelFunc:xe};function Ne(e){var t=e.attrs,n=t.shape,a=t.value,r=t.dtype,u=e.backend,i=u.makeOutput(n,r);return u.typedArrayFromHeap(i).fill(a),i}var Re,Ee={kernelName:t.Fill,backendName:"wasm",kernelFunc:Ne};var De,Oe={kernelName:t.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,n=e.backend,a=t.image,r=n.makeOutput(a.shape,a.dtype),u=n.dataIdMap.get(a.dataId).id,i=n.dataIdMap.get(r.dataId).id,s=k(a.shape,4),o=s[0],d=s[1],p=s[2],l=s[3];return Re(u,o,d,p,l,i),r},setupFunc:function(e){Re=e.wasm.cwrap(t.FlipLeftRight,null,["number","number","number","number","number","number"])}},Te=S(t.Floor),Ce=A(t.FloorDiv);var Pe,We={kernelName:t.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){De=e.wasm.cwrap(t.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs.varianceEpsilon,u=a.x,i=a.mean,s=a.variance,o=a.offset,d=a.scale,p=n.dataIdMap.get(u.dataId).id,l=n.dataIdMap.get(i.dataId).id,c=n.dataIdMap.get(s.dataId).id,m=null!=o?n.dataIdMap.get(o.dataId).id:0,f=null!=d?n.dataIdMap.get(d.dataId).id:0,h=n.makeOutput(u.shape,u.dtype);if(0===t.util.sizeFromShape(u.shape))return h;var b=n.dataIdMap.get(h.dataId).id;return De(p,l,c,m,f,r,b),h}};var ze,je={kernelName:t.FusedConv2D,backendName:"wasm",setupFunc:function(e){Pe=e.wasm.cwrap(t.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=n.filter,s=n.bias,o=n.preluActivationWeights,d=a.strides,l=a.pad,c=a.dilations,m=a.dataFormat,f=a.dimRoundingMode,h=a.activation,b=a.leakyreluAlpha,_=t.backend_util.computeConv2DInfo(u.shape,i.shape,d,c,l,f),y=p[h];if(null==y)throw new Error("".concat(h," activation not yet supported for FusedConv2D ")+"in the wasm backend.");var g=r.dataIdMap.get(u.dataId).id,v=r.dataIdMap.get(i.dataId).id,k=_.outChannels,w=0;if(null!=s){var I=r.dataIdMap.get(s.dataId);if(1!==I.shape.length)throw new Error("FusedConv2D only supports rank-1 bias but got "+"rank ".concat(I.shape.length,"."));if(I.shape[0]!==k)throw new Error("FusedConv2D bias shape (".concat(I.shape,") does not ")+"match the number of output channels (".concat(k,")"));w=I.id}var S=_.filterHeight,M=_.filterWidth,A=_.padInfo.top,x=_.padInfo.right,F=_.padInfo.bottom,N=_.padInfo.left,R=_.dilationHeight,E=_.dilationWidth,D=_.strideHeight,O=_.strideWidth,T=_.inChannels,C="SAME"===_.padInfo.type?1:0,P=_.batchSize,W=_.inHeight,z=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+"".concat(m,"'. Please use 'NHWC'."));var j=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(j.dataId).id,B=null==o?0:r.dataIdMap.get(o.dataId).id;return Pe(g,P,W,z,v,S,M,w,A,x,F,N,C,R,E,D,O,T,k,y,B,b||0,L),j}};var Le,Be={kernelName:t.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){ze=e.wasm.cwrap(t.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=n.filter,s=n.bias,o=n.preluActivationWeights,d=a.strides,l=a.pad,c=a.dilations,m=a.dataFormat,f=a.dimRoundingMode,h=a.activation,b=a.leakyreluAlpha,_=t.backend_util.computeConv2DInfo(u.shape,i.shape,d,c,l,f,!0),y=p[h];if(null==y)throw new Error("".concat(h," activation not yet supported for FusedDepthwiseConv2D ")+"in the wasm backend.");var g=r.dataIdMap.get(u.dataId).id,v=r.dataIdMap.get(i.dataId).id,k=_.outChannels,w=0;if(null!=s){var I=r.dataIdMap.get(s.dataId);if(1!==I.shape.length)throw new Error("FusedDepthwiseConv2D only supports rank-1 bias but got "+"rank ".concat(I.shape.length,"."));if(I.shape[0]!==k)throw new Error("FusedDepthwiseConv2D bias shape (".concat(I.shape,") does not ")+"match the number of output channels (".concat(k,")"));w=I.id}var S=_.filterHeight,M=_.filterWidth,A=_.padInfo.top,x=_.padInfo.right,F=_.padInfo.bottom,N=_.padInfo.left,R=_.dilationHeight,E=_.dilationWidth,D=_.strideHeight,O=_.strideWidth,T=_.inChannels,C="SAME"===_.padInfo.type?1:0,P=_.batchSize,W=_.inHeight,z=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+"".concat(m,"'. Please use 'NHWC'."));var j=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(j.dataId).id,B=null==o?0:r.dataIdMap.get(o.dataId).id;return ze(g,P,W,z,v,S,M,w,A,x,F,N,C,R,E,D,O,T,k,y,B,b||0,L),j}};var Ue,qe={kernelName:t.GatherNd,backendName:"wasm",setupFunc:function(e){Le=e.wasm.cwrap(t.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=a.params,u=a.indices,i=k(t.gather_util.prepareAndValidate(r,u),4),s=i[0],o=i[1],p=i[2],l=i[3],c=n.makeOutput(s,r.dtype);if(0===o)return c;var m=u.shape,f=m[m.length-1],h=n.dataIdMap.get(r.dataId).id,b=n.dataIdMap.get(u.dataId).id,_=new Uint8Array(new Int32Array(l).buffer),y=n.dataIdMap.get(c.dataId).id;return Le(h,d[r.dtype],b,o,f,p,_,y),c}};var He,Ve={kernelName:t.GatherV2,backendName:"wasm",setupFunc:function(e){Ue=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){for(var n=e.backend,a=e.inputs,r=e.attrs,u=a.x,i=a.indices,s=r.axis,o=r.batchDims,p=t.util.parseAxisParam(s,u.shape)[0],l=n.readSync(i.dataId),c=u.shape[p],m=function(e){var n=l[e];t.util.assert(n<=c-1&&n>=0,(function(){return"GatherV2: the index value ".concat(n," is not in [0, ").concat(c-1,"]")}))},f=0;f<l.length;++f)m(f);var h=t.backend_util.segment_util.collectGatherOpShapeInfo(u,i,p,o),b=H({inputs:{x:u},attrs:{shape:[h.batchSize,h.outerSize,h.dimSize,h.sliceSize]},backend:n}),_=t.util.sizeFromShape(i.shape),y=H({inputs:{x:i},attrs:{shape:[h.batchSize,_/h.batchSize]},backend:n}),g=[h.batchSize,h.outerSize,_/h.batchSize,h.sliceSize],v=n.makeOutput(g,u.dtype);if(0===t.util.sizeFromShape(u.shape))return v;var k=b.shape.length-1,w=n.dataIdMap.get(b.dataId).id,I=n.dataIdMap.get(y.dataId).id,S=n.dataIdMap.get(v.dataId).id,M=new Uint8Array(new Int32Array(t.util.computeStrides(b.shape)).buffer),A=new Uint8Array(new Int32Array(t.util.computeStrides(g)).buffer);return Ue(w,d[u.dtype],M,k,I,h.batchSize,A,S),n.disposeData(b.dataId),n.disposeData(y.dataId),v.shape=h.outputShape,v}},Ge=A(t.Greater,0,"bool"),Ke=A(t.GreaterEqual,0,"bool");var Xe,Qe={kernelName:t.LeakyRelu,backendName:"wasm",setupFunc:function(e){He=e.wasm.cwrap(t.LeakyRelu,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.inputs.x,a=e.attrs.alpha,r=e.backend,u=r.dataIdMap.get(n.dataId).id,i=r.makeOutput(n.shape,"float32");if(0!==t.util.sizeFromShape(n.shape)){var s=r.dataIdMap.get(i.dataId).id;He(u,d[n.dtype],a,s)}return i}},Je=A(t.Less,0,"bool"),Ze=A(t.LessEqual,0,"bool"),Ye=S(t.Log),$e=A(t.LogicalAnd,0,"bool"),et=S(t.LogicalNot),tt=A(t.LogicalOr,0,"bool"),nt=A(t.LogicalXor,0,"bool");var at,rt={kernelName:t.Max,backendName:"wasm",setupFunc:function(e){Xe=e.wasm.cwrap(t.Max,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.reductionIndices,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,p=s,l=P(s,u,n),c=l.transposed,m=l.axes,f=l.originalAxes,h=l.inputWasTransposed;h&&(p=c,o=n.dataIdMap.get(c.dataId).id);var b=p.shape.length;t.backend_util.assertAxesAreInnerMostDims("max",m,b);var _=k(t.backend_util.computeOutAndReduceShapes(p.shape,m),2),y=_[0],g=_[1],v=t.util.sizeFromShape(g),w=n.makeOutput(y,s.dtype);if(0!==t.util.sizeFromShape(p.shape)){var I=n.dataIdMap.get(w.dataId).id;Xe(o,d[s.dtype],v,I)}if(h&&n.disposeData(c.dataId),i){var S=t.backend_util.expandShapeToKeepDim(w.shape,f);w.shape=S}return w}},ut=A(t.Maximum);var it,st={kernelName:t.MaxPool,backendName:"wasm",setupFunc:function(e){at=e.wasm.cwrap(t.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=r.dataIdMap.get(u.dataId).id;t.util.assert("float32"===u.dtype,(function(){return"Error in MaxPool: only float32 input is supported. Got ".concat(u.dtype,".")}));var s=a.filterSize,o=a.strides,d=a.pad,p=a.dimRoundingMode,l=t.backend_util.computePool2DInfo(u.shape,s,o,1,d,p),c=l.filterHeight,m=l.filterWidth,f=l.padInfo.top,h=l.padInfo.right,b=l.padInfo.bottom,_=l.padInfo.left,y=l.dilationHeight,g=l.dilationWidth,v=l.strideHeight,k=l.strideWidth,w=l.inChannels,I=l.outChannels;if("channelsLast"!==l.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+"".concat(l.dataFormat,"'. Please use 'channelsLast'."));var S=r.makeOutput(l.outShape,"float32"),M=r.dataIdMap.get(S.dataId).id;return at(i,u.shape[0],u.shape[1],u.shape[2],c,m,f,h,b,_,y,g,v,k,w,I,M),S}};var ot,dt={kernelName:t.Mean,backendName:"wasm",setupFunc:function(e){it=e.wasm.cwrap(t.Mean,null,["number, number, number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,d=o,p=s,l=P(s,u,n),c=l.transposed,m=l.axes,f=l.originalAxes,h=l.inputWasTransposed,b=m;if(h){var _=n.dataIdMap.get(c.dataId).id;_!==o&&(p=c,d=_,b=t.backend_util.getInnerMostAxes(b.length,p.shape.length))}t.backend_util.assertAxesAreInnerMostDims("mean",b,p.shape.length);var y=k(t.backend_util.computeOutAndReduceShapes(p.shape,b),2),g=y[0],v=y[1],w=t.util.sizeFromShape(v),I=p;"float32"!==p.dtype&&(I=ee({backend:n,inputs:{x:p},attrs:{dtype:"float32"}}),d=n.dataIdMap.get(I.dataId).id);var S=n.makeOutput(g,"float32");if(0!==t.util.sizeFromShape(p.shape)){var M=n.dataIdMap.get(S.dataId).id;it(d,w,M)}if(h&&n.disposeData(c.dataId),i){var A=t.backend_util.expandShapeToKeepDim(S.shape,f);S.shape=A}return"float32"!==p.dtype&&n.disposeData(I.dataId),S}};var pt,lt,ct={kernelName:t.Min,backendName:"wasm",setupFunc:function(e){ot=e.wasm.cwrap(t.Min,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,p=o,l=s,c=P(s,u,n),m=c.transposed,f=c.axes,h=c.originalAxes,b=c.inputWasTransposed;if(b){var _=n.dataIdMap.get(m.dataId).id;_!==o&&(l=m,p=_)}var y=l.shape.length;t.backend_util.assertAxesAreInnerMostDims("min",f,y);var g=k(t.backend_util.computeOutAndReduceShapes(l.shape,f),2),v=g[0],w=g[1],I=t.util.sizeFromShape(w),S=n.makeOutput(v,l.dtype);if(0!==t.util.sizeFromShape(l.shape)){var M=n.dataIdMap.get(S.dataId).id;ot(p,d[s.dtype],I,M)}if(b&&n.disposeData(m.dataId),i){var A=t.backend_util.expandShapeToKeepDim(S.shape,h);S.shape=A}return S}},mt=A(t.Minimum);!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(pt||(pt={}));var ft,ht={kernelName:t.MirrorPad,backendName:"wasm",kernelFunc:function(e){var t=e.inputs.x,n=e.backend,a=e.attrs,r=a.paddings,u=a.mode,i=r.map((function(e,n){return e[0]+t.shape[n]+e[1]})),s=n.dataIdMap.get(t.dataId).id,o=n.makeOutput(i,t.dtype),p=n.dataIdMap.get(o.dataId).id,l=new Uint8Array(new Int32Array(t.shape).buffer),c=r.map((function(e){return e[0]})),m=r.map((function(e){return e[1]})),f=new Uint8Array(new Int32Array(c).buffer),h=new Uint8Array(new Int32Array(m).buffer);return lt(s,l,t.shape.length,d[t.dtype],f,h,pt[u],p),o},setupFunc:function(e){lt=e.wasm.cwrap(t.MirrorPad,null,["number","array","number","number","array","array","number","number"])}},bt=A(t.Multiply),_t=S(t.Neg);function yt(e,t){var n=new Int32Array(e.wasm.HEAPU8.buffer,t,4),a=n[0],r=n[1],u=n[2],i=n[3];return e.wasm._free(t),{pSelectedIndices:a,selectedSize:r,pSelectedScores:u,pValidOutputs:i}}var gt,vt={kernelName:t.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){ft=e.wasm.cwrap(t.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){var t=e.backend,n=e.inputs,a=e.attrs,r=a.iouThreshold,u=a.maxOutputSize,i=a.scoreThreshold,s=n.boxes,o=n.scores,d=t.dataIdMap.get(s.dataId).id,p=t.dataIdMap.get(o.dataId).id,l=yt(t,ft(d,p,u,r,i)),c=l.pSelectedIndices,m=l.selectedSize,f=l.pSelectedScores,h=l.pValidOutputs;return t.wasm._free(f),t.wasm._free(h),t.makeOutput([m],"int32",c)}};var kt,wt={kernelName:t.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){gt=e.wasm.cwrap(t.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){var t=e.backend,n=e.inputs,a=e.attrs,r=a.iouThreshold,u=a.maxOutputSize,i=a.scoreThreshold,s=a.padToMaxOutputSize,o=n.boxes,d=n.scores,p=t.dataIdMap.get(o.dataId).id,l=t.dataIdMap.get(d.dataId).id,c=yt(t,gt(p,l,u,r,i,s)),m=c.pSelectedIndices,f=c.selectedSize,h=c.pSelectedScores,b=c.pValidOutputs;return t.wasm._free(h),[t.makeOutput([f],"int32",m),t.makeOutput([],"int32",b)]}};var It,St={kernelName:t.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){kt=e.wasm.cwrap(t.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.backend,n=e.inputs,a=e.attrs,r=a.iouThreshold,u=a.maxOutputSize,i=a.scoreThreshold,s=a.softNmsSigma,o=n.boxes,d=n.scores,p=t.dataIdMap.get(o.dataId).id,l=t.dataIdMap.get(d.dataId).id,c=yt(t,kt(p,l,u,r,i,s)),m=c.pSelectedIndices,f=c.selectedSize,h=c.pSelectedScores,b=c.pValidOutputs;return t.wasm._free(b),[t.makeOutput([f],"int32",m),t.makeOutput([f],"float32",h)]}},Mt=A(t.NotEqual,0,"bool");var At={kernelName:t.OneHot,backendName:"wasm",setupFunc:function(e){It=e.wasm.cwrap(t.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,n=e.backend,a=e.attrs,r=t.indices,u=a.dtype,i=a.depth,s=a.onValue,o=a.offValue,d=n.makeOutput(w(w([],k(r.shape),!1),[i],!1),u),p=n.dataIdMap.get(d.dataId).id,l=n.dataIdMap.get(r.dataId).id;return It(l,i,s,o,p),d}};var xt={kernelName:t.OnesLike,backendName:"wasm",kernelFunc:function(e){var t=e.inputs.x,n=e.backend,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(1),a}};var Ft,Nt={kernelName:t.Pack,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs.axis;if(1===n.length)return xe({inputs:{input:n[0]},backend:a,attrs:{dim:r}});var u=n[0].shape,i=n[0].dtype;n.forEach((function(e){t.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),t.util.assert(i===e.dtype,(function(){return"All tensors passed to stack must have matching dtypes"}))}));var s=[],o=ue({inputs:n.map((function(e){var t=xe({inputs:{input:e},backend:a,attrs:{dim:r}});return s.push(t),t})),backend:a,attrs:{axis:r}});return s.forEach((function(e){return a.disposeData(e.dataId)})),o}};var Rt,Et={kernelName:t.PadV2,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,a=e.backend,r=e.attrs,u=r.paddings,i=r.constantValue,s=u.map((function(e,t){return e[0]+n.shape[t]+e[1]}));if(0===t.util.sizeFromShape(n.shape))return Ne({backend:a,attrs:{shape:s,value:i,dtype:n.dtype}});var o=a.dataIdMap.get(n.dataId).id,p=a.makeOutput(s,n.dtype),l=a.dataIdMap.get(p.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),m=u.map((function(e){return e[0]})),f=u.map((function(e){return e[1]})),h=new Uint8Array(new Int32Array(m).buffer),b=new Uint8Array(new Int32Array(f).buffer);return Ft(o,c,n.shape.length,d[n.dtype],h,b,i,l),p},setupFunc:function(e){Ft=e.wasm.cwrap(t.PadV2,null,["number","array","number","number","array","array","number","number"])}},Dt=A(t.Pow);var Ot,Tt={kernelName:t.Prelu,backendName:"wasm",setupFunc:function(e){Rt=e.wasm.cwrap(t.Prelu,null,["number","number","number"])},kernelFunc:function(e){var t=e.inputs,n=e.backend,a=t.x,r=t.alpha,u=n.dataIdMap.get(a.dataId).id,i=n.dataIdMap.get(r.dataId).id,s=u,o=a,d=o;"float32"!==o.dtype&&(d=ee({backend:n,inputs:{x:a},attrs:{dtype:"float32"}}),s=n.dataIdMap.get(d.dataId).id);var p=n.makeOutput(a.shape,"float32"),l=n.dataIdMap.get(p.dataId).id;return Rt(s,i,l),"float32"!==o.dtype&&n.disposeData(d.dataId),p}};var Ct,Pt={kernelName:t.Prod,backendName:"wasm",setupFunc:function(e){Ot=e.wasm.cwrap(t.Prod,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,p=o,l=s,c=P(s,u,n),m=c.transposed,f=c.axes,h=c.originalAxes,b=c.inputWasTransposed,_=f;if(b){var y=n.dataIdMap.get(m.dataId).id;y!==o&&(l=m,p=y,_=t.backend_util.getInnerMostAxes(_.length,l.shape.length))}t.backend_util.assertAxesAreInnerMostDims("prod",_,l.shape.length);var g=k(t.backend_util.computeOutAndReduceShapes(l.shape,_),2),v=g[0],w=g[1],I=t.util.sizeFromShape(w),S=n.makeOutput(v,l.dtype);if(0!==t.util.sizeFromShape(l.shape)){var M=n.dataIdMap.get(S.dataId).id;Ot(p,I,d[S.dtype],M)}if(b&&n.disposeData(m.dataId),i){var A=t.backend_util.expandShapeToKeepDim(S.shape,h);S.shape=A}return S}},Wt={kernelName:t.Range,backendName:"wasm",kernelFunc:function(e){var n=e.backend,a=e.attrs,r=a.start,u=a.stop,i=a.step,s=a.dtype,o=function(e,n,a,r){if(e===n||e<n&&a<0||n<e&&a>1)return t.util.makeZerosTypedArray(0,r);var u=Math.abs(Math.ceil((n-e)/a)),i=t.util.makeZerosTypedArray(u,r);n<e&&1===a&&(a=-1),i[0]=e;for(var s=1;s<i.length;s++)i[s]=i[s-1]+a;return i}(r,u,i,s),d=n.makeOutput([o.length],s);return n.typedArrayFromHeap(d).set(o),d}},zt=A(t.RealDiv),jt=S(t.Relu),Lt=S(t.Relu6);var Bt,Ut={kernelName:t.ResizeBilinear,backendName:"wasm",setupFunc:function(e){Ct=e.wasm.cwrap(t.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n,a=e.backend,r=e.inputs,u=e.attrs,i=r.images,s=u.alignCorners,o=u.halfPixelCenters,d=k(u.size,2),p=d[0],l=d[1],c=k(i.shape,4),m=c[0],f=c[1],h=c[2],b=c[3],_=[m,p,l,b],y=a.dataIdMap.get(i.dataId);"float32"!==y.dtype&&(n=ee({backend:a,inputs:{x:i},attrs:{dtype:"float32"}}),y=a.dataIdMap.get(n.dataId));var g=y.id,v=a.makeOutput(_,"float32");if(0===t.util.sizeFromShape(i.shape))return v;var w=a.dataIdMap.get(v.dataId).id;return Ct(g,m,f,h,b,p,l,s?1:0,o?1:0,w),null!=n&&a.disposeData(n.dataId),v}};var qt,Ht={kernelName:t.ResizeNearestNeighbor,backendName:"wasm",setupFunc:function(e){Bt=e.wasm.cwrap(t.ResizeNearestNeighbor,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.images,i=r.alignCorners,s=r.halfPixelCenters,o=k(r.size,2),d=o[0],p=o[1],l=k(u.shape,4),c=l[0],m=l[1],f=l[2],h=l[3],b=[c,d,p,h],_=n.makeOutput(b,"float32");if(0===t.util.sizeFromShape(u.shape))return _;var y,g=n.dataIdMap.get(u.dataId);"float32"!==g.dtype&&(y=ee({backend:n,inputs:{x:u},attrs:{dtype:"float32"}}),g=n.dataIdMap.get(y.dataId));var v=g.id,w=n.dataIdMap.get(_.dataId).id;return Bt(v,c,m,f,h,d,p,i?1:0,s?1:0,w),null!=y&&n.disposeData(y.dataId),_}};var Vt,Gt={kernelName:t.Reverse,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.x,i=r.dims,s=t.util.parseAxisParam(i,u.shape);if(0===u.shape.length)return R({inputs:{x:u},backend:a});var o=a.makeOutput(u.shape,u.dtype),d=a.dataIdMap.get(u.dataId).id,p=a.dataIdMap.get(o.dataId).id,l=new Uint8Array(new Int32Array(s).buffer),c=new Uint8Array(new Int32Array(u.shape).buffer);qt(d,l,s.length,c,u.shape.length,p);var m=H({inputs:{x:o},attrs:{shape:u.shape},backend:a});return a.disposeData(o.dataId),m},setupFunc:function(e){qt=e.wasm.cwrap(t.Reverse,null,["number","array","number","array","number","number"])}};var Kt,Xt={kernelName:t.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.image,i=r.radians,s=r.fillValue,o=r.center,d=a.makeOutput(u.shape,u.dtype),p=a.dataIdMap.get(u.dataId).id,l=a.dataIdMap.get(d.dataId).id,c=k(u.shape,4),m=c[0],f=c[1],h=c[2],b=c[3],_=k(t.backend_util.getImageCenter(o,f,h),2),y=_[0],g=_[1],v="number"==typeof s?[s,s,s,0===s?0:255]:w(w([],k(s),!1),[255],!1),I=new Uint8Array(new Int32Array(v).buffer);return Vt(p,m,f,h,b,i,y,g,I,v.length,l),d},setupFunc:function(e){Vt=e.wasm.cwrap(t.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},Qt=S(t.Round),Jt=S(t.Rsqrt);var Zt,Yt={kernelName:t.ScatterNd,backendName:"wasm",setupFunc:function(e){Kt=e.wasm.cwrap(t.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.indices,i=a.updates,s=r.shape,o=n.makeOutput(s,i.dtype);if(0===t.util.sizeFromShape(s))return o;var p=t.scatter_util.calculateShapes(i,u,s),l=p.sliceRank,c=p.numUpdates,m=p.sliceSize,f=p.strides,h=p.outputSize,b=n.dataIdMap.get(u.dataId).id,_=n.dataIdMap.get(i.dataId).id,y=new Uint8Array(new Int32Array(f).buffer),g=n.dataIdMap.get(o.dataId).id;return Kt(b,_,d[i.dtype],l,c,m,y,h,g),o}};var $t,en={kernelName:t.Select,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=n.condition,u=n.t,i=n.e,s=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(u.dataId).id,d=a.dataIdMap.get(i.dataId).id,p=a.makeOutput(u.shape,u.dtype),l=a.dataIdMap.get(p.dataId).id,c=r.shape.length,m=u.shape.length,f=0===c||c>1||1===m?1:t.util.sizeFromShape(u.shape.slice(1));return Zt(s,o,d,f,l),p},setupFunc:function(e){Zt=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}};var tn,nn={kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){$t=e.wasm.cwrap(t.Sigmoid,null,["number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs.x,r=n.dataIdMap.get(a.dataId).id,u=n.makeOutput(a.shape,a.dtype),i=n.dataIdMap.get(u.dataId).id;return 0===t.util.sizeFromShape(u.shape)||$t(r,i),u}},an=S(t.Sin);var rn={kernelName:t.Softmax,backendName:"wasm",setupFunc:function(e){tn=e.wasm.cwrap(t.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs.logits,r=e.attrs.dim,u=n.dataIdMap.get(a.dataId).id,i=n.makeOutput(a.shape,a.dtype),s=n.dataIdMap.get(i.dataId).id,o=a.shape[r],d=t.util.sizeFromShape(a.shape)/o;return 0===t.util.sizeFromShape(i.shape)||tn(u,s,o,d),i}};var un,sn={kernelName:t.SpaceToBatchND,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,r=e.attrs,u=n.x,i=r.blockShape,s=r.paddings,o=t.util.sizeFromShape(i),d=[[0,0]];d.push.apply(d,w([],k(s),!1));for(var p=1+i.length;p<u.shape.length;++p)d.push([0,0]);var l=Et.kernelFunc({inputs:{x:u},backend:a,attrs:{paddings:d,constantValue:0}}),c=t.backend_util.getReshaped(l.shape,i,o,!1),m=t.backend_util.getPermuted(c.length,i.length,!1),f=t.backend_util.getReshapedPermuted(l.shape,i,o,!1),h=H({inputs:{x:l},backend:a,attrs:{shape:c}}),b=O({inputs:{x:h},backend:a,attrs:{perm:m}}),_=H({inputs:{x:b},backend:a,attrs:{shape:f}});return a.disposeData(l.dataId),a.disposeData(h.dataId),a.disposeData(b.dataId),_}};var on,dn={kernelName:t.SparseFillEmptyRows,backendName:"wasm",setupFunc:function(e){un=e.wasm.cwrap("SparseFillEmptyRows","number",["number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n,a=e.backend,r=e.inputs,u=r.indices,i=r.values,s=r.denseShape,o=r.defaultValue,p=u.shape[0],l=u.shape[1],c=a.readSync(s.dataId)[0],m=[p+c,l],f=a.dataIdMap.get(u.dataId).id,h=a.dataIdMap.get(i.dataId).id,b=a.dataIdMap.get(o.dataId).id,_=a.makeOutput(m,u.dtype),y=a.dataIdMap.get(_.dataId).id,g=a.makeOutput(m.slice(0,1),i.dtype),v=a.dataIdMap.get(g.dataId).id,k=a.makeOutput([c],"bool"),w=a.dataIdMap.get(k.dataId).id,I=a.makeOutput([p],u.dtype),S=a.dataIdMap.get(I.dataId).id,M=a.makeOutput([4],"int32"),A=a.dataIdMap.get(M.dataId).id,x=un(f,h,d[i.dtype],p,c,l,b,y,v,w,S,A),F=a.readSync(M.dataId);switch(F[0]){case 1:n=t.backend_util.getSparseFillEmptyRowsIndicesDenseShapeMismatch(F[1]);break;case 2:n=t.backend_util.getSparseFillEmptyRowsNegativeIndexErrorMessage(F[1],F[2]);break;case 3:n=t.backend_util.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(F[1],F[2],F[3]);break;default:n=""}if(a.disposeData(M.dataId),n)throw a.disposeData(_.dataId),a.disposeData(g.dataId),a.disposeData(k.dataId),a.disposeData(I.dataId),new Error(n);var N=_,R=g;return x!==m[0]&&(N=Z({inputs:{x:_},attrs:{begin:0,size:[x,l]},backend:a}),R=Z({inputs:{x:g},attrs:{begin:0,size:x},backend:a}),a.disposeData(_.dataId),a.disposeData(g.dataId)),[N,R,k,I]}};var pn,ln={kernelName:t.SparseReshape,backendName:"wasm",setupFunc:function(e){on=e.wasm.cwrap(t.SparseReshape,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=a.inputIndices,u=a.inputShape,i=a.newShape;if(2!==r.shape.length)throw new Error("Input indices should be a matrix but received shape\n        ".concat(r.shape));if(1!==u.shape.length)throw new Error("Input shape should be a vector but received shape\n        ".concat(u.shape));if(1!==i.shape.length)throw new Error("Target shape should be a vector but received shape ".concat(i.shape));var s=n.dataIdMap.get(r.dataId).id,o=n.dataIdMap.get(u.dataId).id,d=n.dataIdMap.get(i.dataId).id,p=r.shape[0],l=t.util.sizeFromShape(i.shape),c=n.makeOutput([p,l],r.dtype),m=n.dataIdMap.get(c.dataId).id,f=n.makeOutput([l],i.dtype),h=n.dataIdMap.get(f.dataId).id,b=n.makeOutput([3],"int32"),_=n.dataIdMap.get(b.dataId).id;on(s,o,d,p,m,h,_);var y,g=n.readSync(b.dataId);switch(g[0]){case 0:y=t.backend_util.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(g[1],g[2]);break;case 1:y=t.backend_util.getSparseReshapeNegativeOutputDimErrorMessage(g[1],g[2]);break;case 2:y=t.backend_util.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage();break;case 3:var v=Array.from(n.readSync(u.dataId)),k=Array.from(n.readSync(f.dataId));y=t.backend_util.getSparseReshapeInputOutputMultipleErrorMessage(v,k);break;case 4:v=Array.from(n.readSync(u.dataId)),k=Array.from(n.readSync(f.dataId));y=t.backend_util.getSparseReshapeInputOutputMismatchErrorMessage(v,k);break;default:y=""}if(n.disposeData(b.dataId),y)throw n.disposeData(c.dataId),n.disposeData(f.dataId),new Error(y);return[c,f]}};function cn(e){pn=e.wasm.cwrap("SparseSegmentReduction",null,["number","number","number","number","number","number","number","number","number"])}function mn(e,n){var a=e.backend,r=e.inputs,u=r.data,i=r.indices,s=r.segmentIds,o=i.shape[0],p=a.readSync(s.dataId,o-1,o)[0],l=o>0?p+1:0;if(l<0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());var c=u.shape.slice();c[0]=l;var m=a.dataIdMap.get(u.dataId).id,f=a.dataIdMap.get(i.dataId).id,h=a.dataIdMap.get(s.dataId).id,b=a.makeOutput(c,u.dtype),_=a.dataIdMap.get(b.dataId).id,y=a.makeOutput([4],"int32"),g=a.dataIdMap.get(y.dataId).id;pn(m,d[u.dtype],u.shape[0],f,h,_,g,n,0);var v,k=a.readSync(y.dataId);switch(k[0]){case 0:v=t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage();break;case 1:v=t.backend_util.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage();break;case 2:v=t.backend_util.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(k[1],k[2]);break;case 3:v=t.backend_util.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(k[1],k[2],k[3]);break;default:v=""}if(a.disposeData(y.dataId),v)throw a.disposeData(b.dataId),new Error(v);return b}var fn={kernelName:t.SparseSegmentMean,backendName:"wasm",setupFunc:cn,kernelFunc:function(e){return mn(e,!0)}};var hn={kernelName:t.SparseSegmentSum,backendName:"wasm",setupFunc:cn,kernelFunc:function(e){return mn(e,!1)}};var bn,_n={kernelName:t.SplitV,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.attrs,r=e.backend,u=n.x,i=a.numOrSizeSplits,s=a.axis,o=t.util.parseAxisParam(s,u.shape)[0],d=t.backend_util.prepareSplitSize(u,i,o),p=new Array(u.shape.length).fill(0),l=u.shape.slice();return d.map((function(e){var t=w([],k(l),!1);t[o]=e;var n=Z({inputs:{x:u},attrs:{begin:p,size:t},backend:r});return p[o]+=e,n}))}},yn=S(t.Sqrt),gn=S(t.Square),vn=A(t.SquaredDifference);var kn,wn={kernelName:t.Step,backendName:"wasm",setupFunc:function(e){bn=e.wasm.cwrap(t.Step,null,["number","number","number","number"])},kernelFunc:function(e){var t=e.backend,n=e.inputs,a=e.attrs.alpha,r=n.x,u=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(r.shape,r.dtype),s=t.dataIdMap.get(i.dataId).id;return bn(u,a,d[r.dtype],s),i}};var In={kernelName:t.StridedSlice,backendName:"wasm",setupFunc:function(e){kn=e.wasm.cwrap(t.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){var n,a=e.backend,r=e.inputs,u=e.attrs,i=r.x,s=u.begin,o=u.end,d=u.strides,p=u.beginMask,l=u.endMask,c=u.ellipsisMask,m=u.newAxisMask,f=u.shrinkAxisMask,h=t.slice_util.sliceInfo(i.shape,s,o,d,p,l,c,m,f),b=h.finalShapeSparse,_=h.finalShape,y=h.isIdentity,g=h.sliceDim0,v=h.isSimpleSlice,k=h.begin,w=h.end,I=h.strides;if(y)n=H({inputs:{x:i},backend:a,attrs:{shape:_}});else if(g||v){t.util.assert(i.shape.length>=1,(function(){return"Input must have rank at least 1, got: ".concat(i.shape.length)}));var S=t.slice_util.computeOutShape(k,w,I),M=Z({inputs:{x:i},backend:a,attrs:{begin:k,size:S}});n=H({inputs:{x:M},backend:a,attrs:{shape:_}}),a.disposeData(M.dataId)}else{var A=a.makeOutput(b,"float32"),x=a.dataIdMap.get(i.dataId).id,F=new Uint8Array(new Int32Array(t.util.computeStrides(i.shape)).buffer),N=new Uint8Array(new Int32Array(k).buffer),R=new Uint8Array(new Int32Array(w).buffer),E=new Uint8Array(new Int32Array(I).buffer),D=new Uint8Array(new Int32Array(b).buffer),O=new Uint8Array(new Int32Array(t.util.computeStrides(b)).buffer),T=a.dataIdMap.get(A.dataId).id;kn(x,F,i.shape.length,N,R,E,D,O,b.length,T),n=H({inputs:{x:A},backend:a,attrs:{shape:_}}),a.disposeData(A.dataId)}return n}};var Sn={kernelName:t.StringNGrams,backendName:"wasm",kernelFunc:function(e){var t=e.backend,n=e.inputs,a=e.attrs,r=n.data,u=n.dataSplits,i=a.separator,s=a.nGramWidths,o=a.leftPad,d=a.rightPad,p=a.padWidth,l=a.preserveShortSequences,c=k(function(e,t,n,a,r,u,i,s){return new Q(n,a,r,u,i,s).compute(e,t)}(t.readSync(r.dataId),t.readSync(u.dataId),i,s,o,d,p,l),2),m=c[0],f=c[1],h=t.makeOutput([m.length],"string");t.dataIdMap.get(h.dataId).stringBytes=m;var b=t.makeOutput(u.shape,"int32");return t.typedArrayFromHeap(b).set(f),[h,b]}};var Mn={kernelName:t.StringSplit,backendName:"wasm",kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.input,i=a.delimiter,s=r.skipEmpty,o=k(function(e,n,a){for(var r=e.length,u=[],i=0,s=0,o=new Array(r),d=0;d<r;++d){var p=u.length;J(e[d],n,a,u);var l=u.length-p;o[d]=l,i+=l,s=Math.max(s,l)}var c=t.util.getArrayFromDType("int32",2*i),m=new Array(i),f=[r,s],h=0;for(d=0;d<r;++d)for(var b=0;b<o[d];++b)c[2*h]=d,c[2*h+1]=b,m[h]=u[h],++h;return[c,m,f]}(n.readSync(u.dataId),n.readSync(i.dataId)[0],s),3),d=o[0],p=o[1],l=o[2],c=p.length,m=n.makeOutput([c,2],"int32");n.typedArrayFromHeap(m).set(d);var f=n.makeOutput([c],"string");n.dataIdMap.get(f.dataId).stringBytes=p;var h=n.makeOutput([2],"int32");return n.typedArrayFromHeap(h).set(l),[m,f,h]}};var An,xn={kernelName:t.StringToHashBucketFast,backendName:"wasm",kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=a.input,i=r.numBuckets,s=function(e,n){for(var a=t.util.getArrayFromDType("int32",e.length),r=0;r<e.length;++r)a[r]=t.util.fingerPrint64(e[r]).modulo(n).getLowBitsUnsigned();return a}(n.readSync(u.dataId),i),o=n.makeOutput(u.shape,"int32");return n.typedArrayFromHeap(o).set(s),o}},Fn=A(t.Sub);var Nn,Rn={kernelName:t.Sum,backendName:"wasm",setupFunc:function(e){An=e.wasm.cwrap(t.Sum,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,r=e.attrs,u=r.axis,i=r.keepDims,s=a.x,o=n.dataIdMap.get(s.dataId).id,p=o,l=s,c=P(s,u,n),m=c.transposed,f=c.axes,h=c.originalAxes,b=c.inputWasTransposed,_=f;if(b){var y=n.dataIdMap.get(m.dataId).id;y!==o&&(l=m,p=y,_=t.backend_util.getInnerMostAxes(_.length,l.shape.length))}t.backend_util.assertAxesAreInnerMostDims("sum",_,l.shape.length);var g=k(t.backend_util.computeOutAndReduceShapes(l.shape,_),2),v=g[0],w=g[1],I=t.util.sizeFromShape(w),S=n.makeOutput(v,l.dtype);if(0!==t.util.sizeFromShape(l.shape)){var M=n.dataIdMap.get(S.dataId).id;An(p,I,d[S.dtype],M)}if(b&&n.disposeData(m.dataId),i){var A=t.backend_util.expandShapeToKeepDim(S.shape,h);S.shape=A}return S}},En=S(t.Tan),Dn=S(t.Tanh);var On,Tn={kernelName:t.Tile,backendName:"wasm",setupFunc:function(e){Nn=e.wasm.cwrap(t.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){for(var t=e.inputs,n=e.backend,a=e.attrs,r=t.x,u=n.dataIdMap.get(r.dataId).id,i=a.reps,s=new Array(r.shape.length),o=0;o<s.length;o++)s[o]=r.shape[o]*i[o];var p=new Uint8Array(new Int32Array(r.shape).buffer),l=new Uint8Array(new Int32Array(s).buffer),c=n.makeOutput(s,r.dtype),m=n.dataIdMap.get(c.dataId).id;return Nn(u,p,r.shape.length,l,s.length,d[c.dtype],m),c}};var Cn,Pn={kernelName:t.TopK,backendName:"wasm",setupFunc:function(e){On=e.wasm.cwrap(t.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:function(e){var t=e.inputs,n=e.backend,a=e.attrs,r=t.x,u=a.k,i=a.sorted,s=n.dataIdMap.get(r.dataId).id,o=new Uint8Array(new Int32Array(r.shape).buffer),p=r.shape.slice();p[p.length-1]=u;var l=n.makeOutput(p,r.dtype),c=n.dataIdMap.get(l.dataId).id,m=n.makeOutput(p,"int32"),f=n.dataIdMap.get(m.dataId).id;return On(s,o,r.shape.length,d[r.dtype],u,i,c,f),[l,m]}};var Wn={kernelName:t.Transform,backendName:"wasm",setupFunc:function(e){Cn=e.wasm.cwrap(t.Transform,null,["number","number","bool","number","number","number","number","number","number","array","number","array","number","number","number","number","number"])},kernelFunc:function(e){var n,a=e.backend,r=e.inputs,u=e.attrs,i=r.image,s=r.transforms,o=u.interpolation,d=u.fillMode,p=u.fillValue,l=u.outputShape,c=k(i.shape,4),m=c[0],f=c[1],h=c[2],b=c[3],_=k(null!=l?l:[f,h],2),y=_[0],g=_[1],v=[m,y,g,b],w=new Uint8Array(new Int32Array(t.util.computeStrides(i.shape)).buffer),I=new Uint8Array(new Int32Array(t.util.computeStrides(v)).buffer),S=a.makeOutput(v,i.dtype),M=a.dataIdMap.get(S.dataId).id,A=a.dataIdMap.get(i.dataId).id,x=a.dataIdMap.get(s.dataId).id,F="nearest"===o?1:2;switch(d){case"constant":default:n=1;break;case"reflect":n=2;break;case"wrap":n=3;break;case"nearest":n=4}return Cn(A,x,s.shape[0]>1,m,y,g,b,h,f,w,i.shape.length-1,I,v.length-1,F,n,p,M),S}};var zn={kernelName:t.Unpack,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,n=e.backend,a=e.attrs,r=t.value,u=a.axis;u<0&&(u+=r.shape.length);for(var i=r.shape[u],s=r.shape.length,o=new Array(s-1),d=0,p=0;p<s;p++)p!==u&&(o[d++]=r.shape[p]);var l=new Array(i),c=new Array(s).fill(0),m=r.shape.slice();for(m[u]=1,p=0;p<l.length;p++)c[u]=p,l[p]=Z({inputs:{x:r},attrs:{begin:c,size:m},backend:n});return l.map((function(e){return{dataId:e.dataId,dtype:e.dtype,shape:o}}))}};var jn,Ln,Bn={kernelName:t.ZerosLike,backendName:"wasm",kernelFunc:function(e){var t=e.inputs.x,n=e.backend,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(0),a}},Un=[I,M,F,N,z,L,U,q,K,$,ne,ae,re,se,de,ce,me,fe,be,ye,ve,we,Ie,Se,Me,Ae,Fe,Ee,Oe,Te,Ce,We,je,Be,qe,Ve,Ge,Ke,D,Qe,Je,Ze,Ye,$e,et,tt,nt,rt,ut,st,dt,ct,mt,ht,bt,_t,vt,wt,St,Mt,At,xt,Nt,Et,Dt,Tt,Pt,Wt,zt,jt,Lt,G,Ut,Ht,Gt,Xt,Qt,Jt,Yt,en,nn,an,Y,rn,sn,dn,ln,fn,hn,_n,yn,gn,vn,wn,In,Sn,Mn,xn,Fn,Rn,En,Dn,Tn,Pn,Wn,C,zn,Bn];try{for(var qn=v(Un),Hn=qn.next();!Hn.done;Hn=qn.next()){var Vn=Hn.value;t.registerKernel(Vn)}}catch(e){jn={error:e}}finally{try{Hn&&!Hn.done&&(Ln=qn.return)&&Ln.call(qn)}finally{if(jn)throw jn.error}}var Gn=t.env();Gn.registerFlag("WASM_HAS_SIMD_SUPPORT",(function(){return y(void 0,void 0,void 0,(function(){return g(this,(function(e){try{return[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))]}catch(e){return[2,!1]}return[2]}))}))})),Gn.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(function(){return y(void 0,void 0,void 0,(function(){return g(this,(function(e){if(Gn.get("IS_NODE"))return[2,!1];try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))]}catch(e){return[2,!1]}return[2]}))}))}));var Kn="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Xn(e){var t={exports:{}};return e(t,t.exports),t.exports}function Qn(e){throw new Error('Could not dynamically require "'+e+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var Jn=Xn((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){function t(){return P.buffer!=L&&Q(P.buffer),B}function a(){return P.buffer!=L&&Q(P.buffer),U}function r(){return P.buffer!=L&&Q(P.buffer),q}function u(){return P.buffer!=L&&Q(P.buffer),H}function i(){return P.buffer!=L&&Q(P.buffer),V}var s,o,d,p="undefined"!=typeof(e=e||{})?e:{};p.ready=new Promise((function(e,t){s=e,o=t})),"undefined"!=typeof process&&process.listeners&&(d={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var l,_,y,g=Object.assign({},p),k=function(e,t){throw t},w="object"==typeof window,I="function"==typeof importScripts,S="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,M=p.ENVIRONMENT_IS_PTHREAD||!1,A="";function x(e){return p.locateFile?p.locateFile(e,A):A+e}if(S){var F,N;A=I?c.default.dirname(A)+"/":__dirname+"/","function"==typeof Qn&&(F=m.default,N=c.default),l=function(e,t){return e=N.normalize(e),F.readFileSync(e,t?void 0:"utf8")},y=function(e){var t=l(e,!0);return t.buffer||(t=new Uint8Array(t)),t},_=function(e,t,n){e=N.normalize(e),F.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof le))throw e})),process.on("unhandledRejection",(function(e){throw e})),k=function(e,t){if(te())throw process.exitCode=e,t;var n;(n=t)instanceof le||C("exiting due to exception: "+n),process.exit(e)},p.inspect=function(){return"[Emscripten Module object]"};var R=void 0;try{R=f.default}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Kn.Worker=R.Worker}else(w||I)&&(I?A=self.location.href:"undefined"!=typeof document&&document.currentScript&&(A=document.currentScript.src),"undefined"!=typeof n&&n&&(A=n),A=0!==A.indexOf("blob:")?A.substr(0,A.replace(/[?#].*/,"").lastIndexOf("/")+1):"",S||(l=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},I&&(y=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),_=function(e,t,n){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)}));S&&"undefined"==typeof performance&&(Kn.performance=h.default.performance);var E=console.log.bind(console),D=console.warn.bind(console);S&&(E=function(e){return F.writeSync(1,e+"\n")},D=function(e){return F.writeSync(2,e+"\n")});var O,T=p.print||E,C=p.printErr||D;Object.assign(p,g),g=null,p.arguments,p.thisProgram,p.quit&&(k=p.quit),p.wasmBinary&&(O=p.wasmBinary);var P,W,z=p.noExitRuntime||!0;"object"!=typeof WebAssembly&&ie("no native wasm support detected");var j,L,B,U,q,H,V,G=!1,K="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function X(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&K)return K.decode(e.buffer instanceof SharedArrayBuffer?e.slice(t,r):e.subarray(t,r));for(var u="";t<r;){var i=e[t++];if(128&i){var s=63&e[t++];if(192!=(224&i)){var o=63&e[t++];if((i=224==(240&i)?(15&i)<<12|s<<6|o:(7&i)<<18|s<<12|o<<6|63&e[t++])<65536)u+=String.fromCharCode(i);else{var d=i-65536;u+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else u+=String.fromCharCode((31&i)<<6|s)}else u+=String.fromCharCode(i)}return u}function Q(e){L=e,p.HEAP8=B=new Int8Array(e),p.HEAP16=new Int16Array(e),p.HEAP32=q=new Int32Array(e),p.HEAPU8=U=new Uint8Array(e),p.HEAPU16=new Uint16Array(e),p.HEAPU32=H=new Uint32Array(e),p.HEAPF32=new Float32Array(e),p.HEAPF64=V=new Float64Array(e)}M&&(L=p.buffer);var J,Z=p.INITIAL_MEMORY||16777216;if(M)P=p.wasmMemory,L=p.buffer;else if(p.wasmMemory)P=p.wasmMemory;else if(!((P=new WebAssembly.Memory({initial:Z/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw C("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),S&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");P&&(L=P.buffer),Z=L.byteLength,Q(L);var Y=[],$=[],ee=[];function te(){return z}function ne(){M||_e($)}var ae,re=0,ue=null;function ie(e){M?postMessage({cmd:"onAbort",arg:e}):p.onAbort&&p.onAbort(e),C(e="Aborted("+e+")"),G=!0,j=1,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw o(t),t}function se(e){return e.startsWith("data:application/octet-stream;base64,")}function oe(e){return e.startsWith("file://")}function de(e){try{if(e==ae&&O)return new Uint8Array(O);if(y)return y(e);throw"both async and sync fetching of the wasm failed"}catch(e){ie(e)}}se(ae="tfjs-backend-wasm-threaded-simd.wasm")||(ae=x(ae));var pe={};function le(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function ce(e){var t,n=be.pthreads[e];n||ie(t),be.returnWorkerToPool(n)}function me(e){var t=be.getNewWorker();if(!t)return 6;be.runningWorkers.push(t),be.pthreads[e.pthread_ptr]=t,t.pthread_ptr=e.pthread_ptr;var n={cmd:"run",start_routine:e.startRoutine,arg:e.arg,pthread_ptr:e.pthread_ptr};return t.runPthread=function(){n.time=performance.now(),t.postMessage(n,e.transferList)},t.loaded&&(t.runPthread(),delete t.runPthread),0}function fe(e){if(M)return Ae(1,1,e);j=e,te()||(be.terminateAllThreads(),p.onExit&&p.onExit(e),G=!0),k(e,new le(e))}var he=function(e,t){if(j=e,!t&&M)throw ge(e),"unwind";fe(e)},be={unusedWorkers:[],runningWorkers:[],tlsInitFunctions:[],pthreads:{},init:function(){M?be.initWorker():be.initMainThread()},initMainThread:function(){for(var e=8;e--;)be.allocateUnusedWorker()},initWorker:function(){z=!1},setExitStatus:function(e){j=e},terminateAllThreads:function(){var e,t,n,a;try{for(var r=v(Object.values(be.pthreads)),u=r.next();!u.done;u=r.next()){var i=u.value;be.returnWorkerToPool(i)}}catch(t){e={error:t}}finally{try{u&&!u.done&&(t=r.return)&&t.call(r)}finally{if(e)throw e.error}}try{for(var s=v(be.unusedWorkers),o=s.next();!o.done;o=s.next())(i=o.value).terminate()}catch(e){n={error:e}}finally{try{o&&!o.done&&(a=s.return)&&a.call(s)}finally{if(n)throw n.error}}be.unusedWorkers=[]},returnWorkerToPool:function(e){var t=e.pthread_ptr;delete be.pthreads[t],be.unusedWorkers.push(e),be.runningWorkers.splice(be.runningWorkers.indexOf(e),1),e.pthread_ptr=0,Ve(t)},receiveObjectTransfer:function(e){},threadInitTLS:function(){be.tlsInitFunctions.forEach((function(e){return e()}))},loadWasmModuleToWorker:function(e,t){e.onmessage=function(n){var a,r=n.data,u=r.cmd;if(e.pthread_ptr&&(be.currentProxiedOperationCallerThread=e.pthread_ptr),r.targetThread&&r.targetThread!=ze()){var i=be.pthreads[r.targetThread];return i?i.postMessage(r,r.transferList):C('Internal error! Worker sent a message "'+u+'" to target pthread '+r.targetThread+", but that thread no longer exists!"),void(be.currentProxiedOperationCallerThread=void 0)}"processProxyingQueue"===u?Se(r.queue):"spawnThread"===u?me(r):"cleanupThread"===u?ce(r.thread):"killThread"===u?function(e){var t=be.pthreads[e];delete be.pthreads[e],t.terminate(),Ve(e),be.runningWorkers.splice(be.runningWorkers.indexOf(t),1),t.pthread_ptr=0}(r.thread):"cancelThread"===u?(a=r.thread,be.pthreads[a].postMessage({cmd:"cancel"})):"loaded"===u?(e.loaded=!0,t&&t(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===u?T("Thread "+r.threadId+": "+r.text):"printErr"===u?C("Thread "+r.threadId+": "+r.text):"alert"===u?alert("Thread "+r.threadId+": "+r.text):"setimmediate"===r.target?e.postMessage(r):"onAbort"===u?p.onAbort&&p.onAbort(r.arg):u&&C("worker sent an unknown command "+u),be.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){throw C("worker sent an error! "+e.filename+":"+e.lineno+": "+e.message),e},S&&(e.on("message",(function(t){e.onmessage({data:t})})),e.on("error",(function(t){e.onerror(t)})),e.on("detachedExit",(function(){}))),e.postMessage({cmd:"load",urlOrBlob:p.mainScriptUrlOrBlob||n,wasmMemory:P,wasmModule:W})},allocateUnusedWorker:function(){var e=x("tfjs-backend-wasm-threaded-simd.worker.js");be.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==be.unusedWorkers.length&&(be.allocateUnusedWorker(),be.loadWasmModuleToWorker(be.unusedWorkers[0])),be.unusedWorkers.pop()}};function _e(e){for(;e.length>0;)e.shift()(p)}function ye(e){var t=Xe(),n=e();return Qe(t),n}function ge(e){if(M)return Ae(2,0,e);try{he(e)}catch(e){!function(e){if(e instanceof le||"unwind"==e)return j;k(1,e)}(e)}}p.PThread=be,p.establishStackSpace=function(){var e=ze(),t=r()[e+44>>2],n=r()[e+48>>2];Ke(t,t-n),Qe(t)};var ve,ke=[];function we(e,t,n,a){return M?Ae(3,1,e,t,n,a):Ie(e,t,n,a)}function Ie(e,t,n,a){if("undefined"==typeof SharedArrayBuffer)return C("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;var r=[];if(M&&0===r.length)return we(e,t,n,a);var u={startRoutine:n,pthread_ptr:e,arg:a,transferList:r};return M?(u.cmd="spawnThread",postMessage(u,r),0):me(u)}function Se(e){Atomics.store(r(),e>>2,1),ze()&&He(e),Atomics.compareExchange(r(),e>>2,1,0)}function Me(e){Me.shown||(Me.shown={}),Me.shown[e]||(Me.shown[e]=1,S&&(e="warning: "+e),C(e))}function Ae(e,t){var n=arguments.length-2,a=arguments;return ye((function(){for(var r=n,u=Je(8*r),s=u>>3,o=0;o<n;o++){var d=a[2+o];i()[s+o]=d}return Le(e,r,u,t)}))}p.invokeEntryPoint=function(e,t){var n,a,r=((a=ke[n=e])||(n>=ke.length&&(ke.length=n+1),ke[n]=a=J.get(n)),a)(t);te()?be.setExitStatus(r):Ge(r)},p.executeNotifiedProxyingQueue=Se,ve=S?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:M?function(){return performance.now()-p.__performance_now_clock_drift}:function(){return performance.now()};var xe=[];function Fe(e){try{return P.grow(e-L.byteLength+65535>>>16),Q(P.buffer),1}catch(e){}}function Ne(e){return M?Ae(4,1,e):52}function Re(e,t,n,a,r){return M?Ae(5,1,e,t,n,a,r):70}var Ee=[null,[],[]];function De(e,t){var n=Ee[e];0===t||10===t?((1===e?T:C)(X(n,0)),n.length=0):n.push(t)}function Oe(e,t,n,r){if(M)return Ae(6,1,e,t,n,r);for(var i=0,s=0;s<n;s++){var o=u()[t>>2],d=u()[t+4>>2];t+=8;for(var p=0;p<d;p++)De(e,a()[o+p]);i+=d}return u()[r>>2]=i,0}function Te(e){return p["_"+e]}function Ce(e,n,r,u,i){var s={string:function(e){var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(n>=r)break;t[n++]=i}else if(i<=2047){if(n+1>=r)break;t[n++]=192|i>>6,t[n++]=128|63&i}else if(i<=65535){if(n+2>=r)break;t[n++]=224|i>>12,t[n++]=128|i>>6&63,t[n++]=128|63&i}else{if(n+3>=r)break;t[n++]=240|i>>18,t[n++]=128|i>>12&63,t[n++]=128|i>>6&63,t[n++]=128|63&i}}t[n]=0}(e,a(),t,n)}(e,t=Je(n),n)}return t},array:function(e){var n=Je(e.length);return function(e,n){t().set(e,n)}(e,n),n}};function o(e){return"string"===n?(t=e)?X(a(),t,r):"":"boolean"===n?Boolean(e):e;var t,r}var d=Te(e),p=[],l=0;if(u)for(var c=0;c<u.length;c++){var m=s[r[c]];m?(0===l&&(l=Xe()),p[c]=m(u[c])):p[c]=u[c]}var f=d.apply(null,p);return f=function(e){return 0!==l&&Qe(l),o(e)}(f)}be.init();var Pe=[null,fe,ge,we,Ne,Re,Oe],We={__emscripten_init_main_thread_js:function(e){je(e,!I,1,!w),be.threadInitTLS()},__emscripten_thread_cleanup:function(e){M?postMessage({cmd:"cleanupThread",thread:e}):ce(e)},__pthread_create_js:Ie,_emscripten_default_pthread_stack_size:function(){return 2097152},_emscripten_get_now_is_monotonic:function(){return!0},_emscripten_notify_task_queue:function(e,t,n,a){if(e==t)setTimeout((function(){return Se(a)}));else if(M)postMessage({targetThread:e,cmd:"processProxyingQueue",queue:a});else{var r=be.pthreads[e];if(!r)return;r.postMessage({cmd:"processProxyingQueue",queue:a})}return 1},_emscripten_set_offscreencanvas_size:function(e,t,n){return-1},abort:function(){ie("")},emscripten_check_blocking_allowed:function(){S||I||Me("Blocking on the main thread is very dangerous, see https://emscripten.org/docs/porting/pthreads.html#blocking-on-the-main-browser-thread")},emscripten_date_now:function(){return Date.now()},emscripten_get_heap_max:function(){return 2147483648},emscripten_get_now:ve,emscripten_memcpy_big:function(e,t,n){a().copyWithin(e,t,t+n)},emscripten_num_logical_cores:function(){return S?b.default.cpus().length:navigator.hardwareConcurrency},emscripten_receive_on_main_thread_js:function(e,t,n){xe.length=t;for(var a=n>>3,r=0;r<t;r++)xe[r]=i()[a+r];return(e<0?pe[-e-1]:Pe[e]).apply(null,xe)},emscripten_resize_heap:function(e){var t=a().length;if((e>>>=0)<=t)return!1;var n=2147483648;if(e>n)return!1;for(var r,u,i=1;i<=4;i*=2){var s=t*(1+.2/i);if(s=Math.min(s,e+100663296),Fe(Math.min(n,(r=Math.max(e,s))+((u=65536)-r%u)%u)))return!0}return!1},emscripten_unwind_to_js_event_loop:function(){throw"unwind"},exit:he,fd_close:Ne,fd_seek:Re,fd_write:Oe,memory:P||p.wasmMemory};!function(){var e={env:We,wasi_snapshot_preview1:We};function t(e,t){var n,a,r=e.exports;if(p.asm=r,n=p.asm._emscripten_tls_init,be.tlsInitFunctions.push(n),J=p.asm.__indirect_function_table,a=p.asm.__wasm_call_ctors,$.unshift(a),W=t,!M){var u=be.unusedWorkers.length;be.unusedWorkers.forEach((function(e){be.loadWasmModuleToWorker(e,(function(){--u||function(e){if(re--,p.monitorRunDependencies&&p.monitorRunDependencies(re),0==re&&ue){var t=ue;ue=null,t()}}()}))}))}}function n(e){t(e.instance,e.module)}function a(t){return function(){if(!O&&(w||I)){if("function"==typeof fetch&&!oe(ae))return fetch(ae,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+ae+"'";return e.arrayBuffer()})).catch((function(){return de(ae)}));if(_)return new Promise((function(e,t){_(ae,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return de(ae)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){C("failed to asynchronously prepare wasm: "+e),ie(e)}))}if(M||(re++,p.monitorRunDependencies&&p.monitorRunDependencies(re)),p.instantiateWasm)try{return p.instantiateWasm(e,t)}catch(e){C("Module.instantiateWasm callback failed with error: "+e),o(e)}(O||"function"!=typeof WebAssembly.instantiateStreaming||se(ae)||oe(ae)||S||"function"!=typeof fetch?a(n):fetch(ae,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return C("wasm streaming compile failed: "+e),C("falling back to ArrayBuffer instantiation"),a(n)}))}))).catch(o)}(),p.___wasm_call_ctors=function(){return(p.___wasm_call_ctors=p.asm.__wasm_call_ctors).apply(null,arguments)},p._init=function(){return(p._init=p.asm.init).apply(null,arguments)},p._init_with_threads_count=function(){return(p._init_with_threads_count=p.asm.init_with_threads_count).apply(null,arguments)},p._get_threads_count=function(){return(p._get_threads_count=p.asm.get_threads_count).apply(null,arguments)},p._register_tensor=function(){return(p._register_tensor=p.asm.register_tensor).apply(null,arguments)},p._dispose_data=function(){return(p._dispose_data=p.asm.dispose_data).apply(null,arguments)},p._dispose=function(){return(p._dispose=p.asm.dispose).apply(null,arguments)},p._Abs=function(){return(p._Abs=p.asm.Abs).apply(null,arguments)},p._Add=function(){return(p._Add=p.asm.Add).apply(null,arguments)},p._AddN=function(){return(p._AddN=p.asm.AddN).apply(null,arguments)},p._All=function(){return(p._All=p.asm.All).apply(null,arguments)},p._Any=function(){return(p._Any=p.asm.Any).apply(null,arguments)},p._ArgMax=function(){return(p._ArgMax=p.asm.ArgMax).apply(null,arguments)},p._AvgPool=function(){return(p._AvgPool=p.asm.AvgPool).apply(null,arguments)},p._BatchMatMul=function(){return(p._BatchMatMul=p.asm.BatchMatMul).apply(null,arguments)},p._Ceil=function(){return(p._Ceil=p.asm.Ceil).apply(null,arguments)},p._ClipByValue=function(){return(p._ClipByValue=p.asm.ClipByValue).apply(null,arguments)},p._Conv2D=function(){return(p._Conv2D=p.asm.Conv2D).apply(null,arguments)},p._Conv2DBackpropInput=function(){return(p._Conv2DBackpropInput=p.asm.Conv2DBackpropInput).apply(null,arguments)},p._Cos=function(){return(p._Cos=p.asm.Cos).apply(null,arguments)},p._Cosh=function(){return(p._Cosh=p.asm.Cosh).apply(null,arguments)},p._CropAndResize=function(){return(p._CropAndResize=p.asm.CropAndResize).apply(null,arguments)},p._Cumprod=function(){return(p._Cumprod=p.asm.Cumprod).apply(null,arguments)},p._Cumsum=function(){return(p._Cumsum=p.asm.Cumsum).apply(null,arguments)},p._DepthToSpace=function(){return(p._DepthToSpace=p.asm.DepthToSpace).apply(null,arguments)},p._DepthwiseConv2dNative=function(){return(p._DepthwiseConv2dNative=p.asm.DepthwiseConv2dNative).apply(null,arguments)},p._Elu=function(){return(p._Elu=p.asm.Elu).apply(null,arguments)},p._Equal=function(){return(p._Equal=p.asm.Equal).apply(null,arguments)},p._Exp=function(){return(p._Exp=p.asm.Exp).apply(null,arguments)},p._FlipLeftRight=function(){return(p._FlipLeftRight=p.asm.FlipLeftRight).apply(null,arguments)},p._Floor=function(){return(p._Floor=p.asm.Floor).apply(null,arguments)},p._FloorDiv=function(){return(p._FloorDiv=p.asm.FloorDiv).apply(null,arguments)},p._FusedBatchNorm=function(){return(p._FusedBatchNorm=p.asm.FusedBatchNorm).apply(null,arguments)},p._FusedConv2D=function(){return(p._FusedConv2D=p.asm.FusedConv2D).apply(null,arguments)},p._FusedDepthwiseConv2D=function(){return(p._FusedDepthwiseConv2D=p.asm.FusedDepthwiseConv2D).apply(null,arguments)},p._Gather=function(){return(p._Gather=p.asm.Gather).apply(null,arguments)},p._GatherNd=function(){return(p._GatherNd=p.asm.GatherNd).apply(null,arguments)},p._Greater=function(){return(p._Greater=p.asm.Greater).apply(null,arguments)},p._GreaterEqual=function(){return(p._GreaterEqual=p.asm.GreaterEqual).apply(null,arguments)},p._LeakyRelu=function(){return(p._LeakyRelu=p.asm.LeakyRelu).apply(null,arguments)},p._Less=function(){return(p._Less=p.asm.Less).apply(null,arguments)},p._LessEqual=function(){return(p._LessEqual=p.asm.LessEqual).apply(null,arguments)},p._Log=function(){return(p._Log=p.asm.Log).apply(null,arguments)},p._LogicalAnd=function(){return(p._LogicalAnd=p.asm.LogicalAnd).apply(null,arguments)},p._LogicalNot=function(){return(p._LogicalNot=p.asm.LogicalNot).apply(null,arguments)},p._LogicalOr=function(){return(p._LogicalOr=p.asm.LogicalOr).apply(null,arguments)},p._LogicalXor=function(){return(p._LogicalXor=p.asm.LogicalXor).apply(null,arguments)},p._Max=function(){return(p._Max=p.asm.Max).apply(null,arguments)},p._MaxPool=function(){return(p._MaxPool=p.asm.MaxPool).apply(null,arguments)},p._Maximum=function(){return(p._Maximum=p.asm.Maximum).apply(null,arguments)},p._Mean=function(){return(p._Mean=p.asm.Mean).apply(null,arguments)},p._Min=function(){return(p._Min=p.asm.Min).apply(null,arguments)},p._Minimum=function(){return(p._Minimum=p.asm.Minimum).apply(null,arguments)},p._MirrorPad=function(){return(p._MirrorPad=p.asm.MirrorPad).apply(null,arguments)},p._Multiply=function(){return(p._Multiply=p.asm.Multiply).apply(null,arguments)},p._Neg=function(){return(p._Neg=p.asm.Neg).apply(null,arguments)},p._NonMaxSuppressionV3=function(){return(p._NonMaxSuppressionV3=p.asm.NonMaxSuppressionV3).apply(null,arguments)},p._NonMaxSuppressionV4=function(){return(p._NonMaxSuppressionV4=p.asm.NonMaxSuppressionV4).apply(null,arguments)},p._NonMaxSuppressionV5=function(){return(p._NonMaxSuppressionV5=p.asm.NonMaxSuppressionV5).apply(null,arguments)},p._NotEqual=function(){return(p._NotEqual=p.asm.NotEqual).apply(null,arguments)},p._OneHot=function(){return(p._OneHot=p.asm.OneHot).apply(null,arguments)},p._PadV2=function(){return(p._PadV2=p.asm.PadV2).apply(null,arguments)},p._Pow=function(){return(p._Pow=p.asm.Pow).apply(null,arguments)},p._Prelu=function(){return(p._Prelu=p.asm.Prelu).apply(null,arguments)},p._Prod=function(){return(p._Prod=p.asm.Prod).apply(null,arguments)},p._RealDiv=function(){return(p._RealDiv=p.asm.RealDiv).apply(null,arguments)},p._Relu=function(){return(p._Relu=p.asm.Relu).apply(null,arguments)},p._Relu6=function(){return(p._Relu6=p.asm.Relu6).apply(null,arguments)},p._ResizeBilinear=function(){return(p._ResizeBilinear=p.asm.ResizeBilinear).apply(null,arguments)},p._ResizeNearestNeighbor=function(){return(p._ResizeNearestNeighbor=p.asm.ResizeNearestNeighbor).apply(null,arguments)},p._Reverse=function(){return(p._Reverse=p.asm.Reverse).apply(null,arguments)},p._RotateWithOffset=function(){return(p._RotateWithOffset=p.asm.RotateWithOffset).apply(null,arguments)},p._Round=function(){return(p._Round=p.asm.Round).apply(null,arguments)},p._Rsqrt=function(){return(p._Rsqrt=p.asm.Rsqrt).apply(null,arguments)},p._ScatterNd=function(){return(p._ScatterNd=p.asm.ScatterNd).apply(null,arguments)},p._SelectV2=function(){return(p._SelectV2=p.asm.SelectV2).apply(null,arguments)},p._Sigmoid=function(){return(p._Sigmoid=p.asm.Sigmoid).apply(null,arguments)},p._Sin=function(){return(p._Sin=p.asm.Sin).apply(null,arguments)},p._Softmax=function(){return(p._Softmax=p.asm.Softmax).apply(null,arguments)},p._SparseFillEmptyRows=function(){return(p._SparseFillEmptyRows=p.asm.SparseFillEmptyRows).apply(null,arguments)},p._SparseReshape=function(){return(p._SparseReshape=p.asm.SparseReshape).apply(null,arguments)},p._SparseSegmentReduction=function(){return(p._SparseSegmentReduction=p.asm.SparseSegmentReduction).apply(null,arguments)},p._Sqrt=function(){return(p._Sqrt=p.asm.Sqrt).apply(null,arguments)},p._Square=function(){return(p._Square=p.asm.Square).apply(null,arguments)},p._SquaredDifference=function(){return(p._SquaredDifference=p.asm.SquaredDifference).apply(null,arguments)},p._Step=function(){return(p._Step=p.asm.Step).apply(null,arguments)},p._StridedSlice=function(){return(p._StridedSlice=p.asm.StridedSlice).apply(null,arguments)},p._Sub=function(){return(p._Sub=p.asm.Sub).apply(null,arguments)},p._Sum=function(){return(p._Sum=p.asm.Sum).apply(null,arguments)},p._Tan=function(){return(p._Tan=p.asm.Tan).apply(null,arguments)},p._Tanh=function(){return(p._Tanh=p.asm.Tanh).apply(null,arguments)},p._Tile=function(){return(p._Tile=p.asm.Tile).apply(null,arguments)},p._TopK=function(){return(p._TopK=p.asm.TopK).apply(null,arguments)},p._Transform=function(){return(p._Transform=p.asm.Transform).apply(null,arguments)},p._Transpose=function(){return(p._Transpose=p.asm.Transpose).apply(null,arguments)},p.__FusedMatMul=function(){return(p.__FusedMatMul=p.asm._FusedMatMul).apply(null,arguments)},p._malloc=function(){return(p._malloc=p.asm.malloc).apply(null,arguments)},p._free=function(){return(p._free=p.asm.free).apply(null,arguments)},p.__emscripten_tls_init=function(){return(p.__emscripten_tls_init=p.asm._emscripten_tls_init).apply(null,arguments)};var ze=p._pthread_self=function(){return(ze=p._pthread_self=p.asm.pthread_self).apply(null,arguments)};p.___errno_location=function(){return(p.___errno_location=p.asm.__errno_location).apply(null,arguments)};var je=p.__emscripten_thread_init=function(){return(je=p.__emscripten_thread_init=p.asm._emscripten_thread_init).apply(null,arguments)};p.__emscripten_thread_crashed=function(){return(p.__emscripten_thread_crashed=p.asm._emscripten_thread_crashed).apply(null,arguments)},p._emscripten_main_thread_process_queued_calls=function(){return(p._emscripten_main_thread_process_queued_calls=p.asm.emscripten_main_thread_process_queued_calls).apply(null,arguments)},p._emscripten_main_browser_thread_id=function(){return(p._emscripten_main_browser_thread_id=p.asm.emscripten_main_browser_thread_id).apply(null,arguments)};var Le=p._emscripten_run_in_main_runtime_thread_js=function(){return(Le=p._emscripten_run_in_main_runtime_thread_js=p.asm.emscripten_run_in_main_runtime_thread_js).apply(null,arguments)};p._emscripten_dispatch_to_thread_=function(){return(p._emscripten_dispatch_to_thread_=p.asm.emscripten_dispatch_to_thread_).apply(null,arguments)};var Be,Ue,qe,He=p.__emscripten_proxy_execute_task_queue=function(){return(He=p.__emscripten_proxy_execute_task_queue=p.asm._emscripten_proxy_execute_task_queue).apply(null,arguments)},Ve=p.__emscripten_thread_free_data=function(){return(Ve=p.__emscripten_thread_free_data=p.asm._emscripten_thread_free_data).apply(null,arguments)},Ge=p.__emscripten_thread_exit=function(){return(Ge=p.__emscripten_thread_exit=p.asm._emscripten_thread_exit).apply(null,arguments)},Ke=p._emscripten_stack_set_limits=function(){return(Ke=p._emscripten_stack_set_limits=p.asm.emscripten_stack_set_limits).apply(null,arguments)},Xe=p.stackSave=function(){return(Xe=p.stackSave=p.asm.stackSave).apply(null,arguments)},Qe=p.stackRestore=function(){return(Qe=p.stackRestore=p.asm.stackRestore).apply(null,arguments)},Je=p.stackAlloc=function(){return(Je=p.stackAlloc=p.asm.stackAlloc).apply(null,arguments)};function Ze(e){if(!(re>0)){if(M)return s(p),ne(),void postMessage({cmd:"loaded"});!function(){if(p.preRun)for("function"==typeof p.preRun&&(p.preRun=[p.preRun]);p.preRun.length;)e=p.preRun.shift(),Y.unshift(e);var e;_e(Y)}(),re>0||(p.setStatus?(p.setStatus("Running..."),setTimeout((function(){setTimeout((function(){p.setStatus("")}),1),t()}),1)):t())}function t(){Be||(Be=!0,p.calledRun=!0,G||(ne(),s(p),p.onRuntimeInitialized&&p.onRuntimeInitialized(),function(){if(!M){if(p.postRun)for("function"==typeof p.postRun&&(p.postRun=[p.postRun]);p.postRun.length;)e=p.postRun.shift(),ee.unshift(e);var e;_e(ee)}}()))}}if(p.dynCall_iijjiiii=function(){return(p.dynCall_iijjiiii=p.asm.dynCall_iijjiiii).apply(null,arguments)},p.dynCall_jiji=function(){return(p.dynCall_jiji=p.asm.dynCall_jiji).apply(null,arguments)},p.keepRuntimeAlive=te,p.wasmMemory=P,p.cwrap=function(e,t,n,a){var r=(n=n||[]).every((function(e){return"number"===e||"boolean"===e}));return"string"!==t&&r&&!a?Te(e):function(){return Ce(e,t,n,arguments)}},p.ExitStatus=le,p.PThread=be,ue=function e(){Be||Ze(),Be||(ue=e)},p.preInit)for("function"==typeof p.preInit&&(p.preInit=[p.preInit]);p.preInit.length>0;)p.preInit.pop()();if(Ze(),d&&(Ue={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!d.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!d.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof WasmBackendModule)qe=WasmBackendModule;else{if("undefined"==typeof e)throw new Error("Could not find wasm module in post.js");qe=e}if(Ue){var Ye=qe._dispose;qe._dispose=function(){Ye(),Ue.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),Ue.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a})),Zn=o({__proto__:null,default:Jn},[Jn]),Yn=Xn((function(e,t){var n,a=(n="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(n=n||__filename),function(e){var t,a,r,u="undefined"!=typeof(e=e||{})?e:{};u.ready=new Promise((function(e,n){t=e,a=n})),"undefined"!=typeof process&&process.listeners&&(r={uncaughtException:process.listeners("uncaughtException"),unhandledRejection:process.listeners("unhandledRejection")});var i,s,o,d,p,l=Object.assign({},u),f="object"==typeof window,h="function"==typeof importScripts,b="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,_="";b?(_=h?c.default.dirname(_)+"/":__dirname+"/","function"==typeof Qn&&(d=m.default,p=c.default),i=function(e,t){return e=p.normalize(e),d.readFileSync(e,t?void 0:"utf8")},o=function(e){var t=i(e,!0);return t.buffer||(t=new Uint8Array(t)),t},s=function(e,t,n){e=p.normalize(e),d.readFile(e,(function(e,a){e?n(e):t(a.buffer)}))},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof B))throw e})),process.on("unhandledRejection",(function(e){throw e})),u.inspect=function(){return"[Emscripten Module object]"}):(f||h)&&(h?_=self.location.href:"undefined"!=typeof document&&document.currentScript&&(_=document.currentScript.src),n&&(_=n),_=0!==_.indexOf("blob:")?_.substr(0,_.replace(/[?#].*/,"").lastIndexOf("/")+1):"",i=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},h&&(o=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),s=function(e,t,n){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)});var y,g,v=u.print||console.log.bind(console),k=u.printErr||console.warn.bind(console);Object.assign(u,l),l=null,u.arguments,u.thisProgram,u.quit,u.wasmBinary&&(y=u.wasmBinary),u.noExitRuntime,"object"!=typeof WebAssembly&&W("no native wasm support detected");var w,I,S,M,A=!1,x="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function F(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.buffer&&x)return x.decode(e.subarray(t,r));for(var u="";t<r;){var i=e[t++];if(128&i){var s=63&e[t++];if(192!=(224&i)){var o=63&e[t++];if((i=224==(240&i)?(15&i)<<12|s<<6|o:(7&i)<<18|s<<12|o<<6|63&e[t++])<65536)u+=String.fromCharCode(i);else{var d=i-65536;u+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else u+=String.fromCharCode((31&i)<<6|s)}else u+=String.fromCharCode(i)}return u}function N(e){w=e,u.HEAP8=I=new Int8Array(e),u.HEAP16=new Int16Array(e),u.HEAP32=new Int32Array(e),u.HEAPU8=S=new Uint8Array(e),u.HEAPU16=new Uint16Array(e),u.HEAPU32=M=new Uint32Array(e),u.HEAPF32=new Float32Array(e),u.HEAPF64=new Float64Array(e)}u.INITIAL_MEMORY;var R,E,D=[],O=[],T=[],C=0,P=null;function W(e){u.onAbort&&u.onAbort(e),k(e="Aborted("+e+")"),A=!0,e+=". Build with -sASSERTIONS for more info.";var t=new WebAssembly.RuntimeError(e);throw a(t),t}function z(e){return e.startsWith("data:application/octet-stream;base64,")}function j(e){return e.startsWith("file://")}function L(e){try{if(e==R&&y)return new Uint8Array(y);if(o)return o(e);throw"both async and sync fetching of the wasm failed"}catch(e){W(e)}}function B(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function U(e){for(;e.length>0;)e.shift()(u)}function q(e){try{return g.grow(e-w.byteLength+65535>>>16),N(g.buffer),1}catch(e){}}z(R="tfjs-backend-wasm.wasm")||(E=R,R=u.locateFile?u.locateFile(E,_):_+E);var H=[null,[],[]];function V(e,t){var n=H[e];0===t||10===t?((1===e?v:k)(F(n,0)),n.length=0):n.push(t)}function G(e){return u["_"+e]}function K(e,t,n,a,r){var u={string:function(e){var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);!function(e,t,n){!function(e,t,n,a){if(!(a>0))return 0;for(var r=n+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(n>=r)break;t[n++]=i}else if(i<=2047){if(n+1>=r)break;t[n++]=192|i>>6,t[n++]=128|63&i}else if(i<=65535){if(n+2>=r)break;t[n++]=224|i>>12,t[n++]=128|i>>6&63,t[n++]=128|63&i}else{if(n+3>=r)break;t[n++]=240|i>>18,t[n++]=128|i>>12&63,t[n++]=128|i>>6&63,t[n++]=128|63&i}}t[n]=0}(e,S,t,n)}(e,t=ee(n),n)}return t},array:function(e){var t=ee(e.length);return function(e,t){I.set(e,t)}(e,t),t}};function i(e){return"string"===t?(n=e)?F(S,n,a):"":"boolean"===t?Boolean(e):e;var n,a}var s=G(e),o=[],d=0;if(a)for(var p=0;p<a.length;p++){var l=u[n[p]];l?(0===d&&(d=Y()),o[p]=l(a[p])):o[p]=a[p]}var c=s.apply(null,o);return c=function(e){return 0!==d&&$(d),i(e)}(c)}var X={abort:function(){W("")},emscripten_get_heap_max:function(){return 2147483648},emscripten_memcpy_big:function(e,t,n){S.copyWithin(e,t,t+n)},emscripten_resize_heap:function(e){var t=S.length,n=2147483648;if((e>>>=0)>n)return!1;for(var a,r,u=1;u<=4;u*=2){var i=t*(1+.2/u);if(i=Math.min(i,e+100663296),q(Math.min(n,(a=Math.max(e,i))+((r=65536)-a%r)%r)))return!0}return!1},fd_close:function(e){return 52},fd_seek:function(e,t,n,a,r){return 70},fd_write:function(e,t,n,a){for(var r=0,u=0;u<n;u++){var i=M[t>>2],s=M[t+4>>2];t+=8;for(var o=0;o<s;o++)V(e,S[i+o]);r+=s}return M[a>>2]=r,0}};!function(){var e={env:X,wasi_snapshot_preview1:X};function t(e,t){var n,a=e.exports;u.asm=a,N((g=u.asm.memory).buffer),u.asm.__indirect_function_table,n=u.asm.__wasm_call_ctors,O.unshift(n),function(e){if(C--,u.monitorRunDependencies&&u.monitorRunDependencies(C),0==C&&P){var t=P;P=null,t()}}()}function n(e){t(e.instance)}function r(t){return function(){if(!y&&(f||h)){if("function"==typeof fetch&&!j(R))return fetch(R,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+R+"'";return e.arrayBuffer()})).catch((function(){return L(R)}));if(s)return new Promise((function(e,t){s(R,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return L(R)}))}().then((function(t){return WebAssembly.instantiate(t,e)})).then((function(e){return e})).then(t,(function(e){k("failed to asynchronously prepare wasm: "+e),W(e)}))}if(C++,u.monitorRunDependencies&&u.monitorRunDependencies(C),u.instantiateWasm)try{return u.instantiateWasm(e,t)}catch(e){k("Module.instantiateWasm callback failed with error: "+e),a(e)}(y||"function"!=typeof WebAssembly.instantiateStreaming||z(R)||j(R)||b||"function"!=typeof fetch?r(n):fetch(R,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return k("wasm streaming compile failed: "+e),k("falling back to ArrayBuffer instantiation"),r(n)}))}))).catch(a)}(),u.___wasm_call_ctors=function(){return(u.___wasm_call_ctors=u.asm.__wasm_call_ctors).apply(null,arguments)},u._init=function(){return(u._init=u.asm.init).apply(null,arguments)},u._init_with_threads_count=function(){return(u._init_with_threads_count=u.asm.init_with_threads_count).apply(null,arguments)},u._get_threads_count=function(){return(u._get_threads_count=u.asm.get_threads_count).apply(null,arguments)},u._register_tensor=function(){return(u._register_tensor=u.asm.register_tensor).apply(null,arguments)},u._dispose_data=function(){return(u._dispose_data=u.asm.dispose_data).apply(null,arguments)},u._dispose=function(){return(u._dispose=u.asm.dispose).apply(null,arguments)},u._Abs=function(){return(u._Abs=u.asm.Abs).apply(null,arguments)},u._Add=function(){return(u._Add=u.asm.Add).apply(null,arguments)},u._AddN=function(){return(u._AddN=u.asm.AddN).apply(null,arguments)},u._All=function(){return(u._All=u.asm.All).apply(null,arguments)},u._Any=function(){return(u._Any=u.asm.Any).apply(null,arguments)},u._ArgMax=function(){return(u._ArgMax=u.asm.ArgMax).apply(null,arguments)},u._AvgPool=function(){return(u._AvgPool=u.asm.AvgPool).apply(null,arguments)},u._BatchMatMul=function(){return(u._BatchMatMul=u.asm.BatchMatMul).apply(null,arguments)},u._Ceil=function(){return(u._Ceil=u.asm.Ceil).apply(null,arguments)},u._ClipByValue=function(){return(u._ClipByValue=u.asm.ClipByValue).apply(null,arguments)},u._Conv2D=function(){return(u._Conv2D=u.asm.Conv2D).apply(null,arguments)},u._Conv2DBackpropInput=function(){return(u._Conv2DBackpropInput=u.asm.Conv2DBackpropInput).apply(null,arguments)},u._Cos=function(){return(u._Cos=u.asm.Cos).apply(null,arguments)},u._Cosh=function(){return(u._Cosh=u.asm.Cosh).apply(null,arguments)},u._CropAndResize=function(){return(u._CropAndResize=u.asm.CropAndResize).apply(null,arguments)},u._Cumprod=function(){return(u._Cumprod=u.asm.Cumprod).apply(null,arguments)},u._Cumsum=function(){return(u._Cumsum=u.asm.Cumsum).apply(null,arguments)},u._DepthToSpace=function(){return(u._DepthToSpace=u.asm.DepthToSpace).apply(null,arguments)},u._DepthwiseConv2dNative=function(){return(u._DepthwiseConv2dNative=u.asm.DepthwiseConv2dNative).apply(null,arguments)},u._Elu=function(){return(u._Elu=u.asm.Elu).apply(null,arguments)},u._Equal=function(){return(u._Equal=u.asm.Equal).apply(null,arguments)},u._Exp=function(){return(u._Exp=u.asm.Exp).apply(null,arguments)},u._FlipLeftRight=function(){return(u._FlipLeftRight=u.asm.FlipLeftRight).apply(null,arguments)},u._Floor=function(){return(u._Floor=u.asm.Floor).apply(null,arguments)},u._FloorDiv=function(){return(u._FloorDiv=u.asm.FloorDiv).apply(null,arguments)},u._FusedBatchNorm=function(){return(u._FusedBatchNorm=u.asm.FusedBatchNorm).apply(null,arguments)},u._FusedConv2D=function(){return(u._FusedConv2D=u.asm.FusedConv2D).apply(null,arguments)},u._FusedDepthwiseConv2D=function(){return(u._FusedDepthwiseConv2D=u.asm.FusedDepthwiseConv2D).apply(null,arguments)},u._Gather=function(){return(u._Gather=u.asm.Gather).apply(null,arguments)},u._GatherNd=function(){return(u._GatherNd=u.asm.GatherNd).apply(null,arguments)},u._Greater=function(){return(u._Greater=u.asm.Greater).apply(null,arguments)},u._GreaterEqual=function(){return(u._GreaterEqual=u.asm.GreaterEqual).apply(null,arguments)},u._LeakyRelu=function(){return(u._LeakyRelu=u.asm.LeakyRelu).apply(null,arguments)},u._Less=function(){return(u._Less=u.asm.Less).apply(null,arguments)},u._LessEqual=function(){return(u._LessEqual=u.asm.LessEqual).apply(null,arguments)},u._Log=function(){return(u._Log=u.asm.Log).apply(null,arguments)},u._LogicalAnd=function(){return(u._LogicalAnd=u.asm.LogicalAnd).apply(null,arguments)},u._LogicalNot=function(){return(u._LogicalNot=u.asm.LogicalNot).apply(null,arguments)},u._LogicalOr=function(){return(u._LogicalOr=u.asm.LogicalOr).apply(null,arguments)},u._LogicalXor=function(){return(u._LogicalXor=u.asm.LogicalXor).apply(null,arguments)},u._Max=function(){return(u._Max=u.asm.Max).apply(null,arguments)},u._MaxPool=function(){return(u._MaxPool=u.asm.MaxPool).apply(null,arguments)},u._Maximum=function(){return(u._Maximum=u.asm.Maximum).apply(null,arguments)},u._Mean=function(){return(u._Mean=u.asm.Mean).apply(null,arguments)},u._Min=function(){return(u._Min=u.asm.Min).apply(null,arguments)},u._Minimum=function(){return(u._Minimum=u.asm.Minimum).apply(null,arguments)},u._MirrorPad=function(){return(u._MirrorPad=u.asm.MirrorPad).apply(null,arguments)},u._Multiply=function(){return(u._Multiply=u.asm.Multiply).apply(null,arguments)},u._Neg=function(){return(u._Neg=u.asm.Neg).apply(null,arguments)},u._NonMaxSuppressionV3=function(){return(u._NonMaxSuppressionV3=u.asm.NonMaxSuppressionV3).apply(null,arguments)},u._NonMaxSuppressionV4=function(){return(u._NonMaxSuppressionV4=u.asm.NonMaxSuppressionV4).apply(null,arguments)},u._NonMaxSuppressionV5=function(){return(u._NonMaxSuppressionV5=u.asm.NonMaxSuppressionV5).apply(null,arguments)},u._NotEqual=function(){return(u._NotEqual=u.asm.NotEqual).apply(null,arguments)},u._OneHot=function(){return(u._OneHot=u.asm.OneHot).apply(null,arguments)},u._PadV2=function(){return(u._PadV2=u.asm.PadV2).apply(null,arguments)},u._Pow=function(){return(u._Pow=u.asm.Pow).apply(null,arguments)},u._Prelu=function(){return(u._Prelu=u.asm.Prelu).apply(null,arguments)},u._Prod=function(){return(u._Prod=u.asm.Prod).apply(null,arguments)},u._RealDiv=function(){return(u._RealDiv=u.asm.RealDiv).apply(null,arguments)},u._Relu=function(){return(u._Relu=u.asm.Relu).apply(null,arguments)},u._Relu6=function(){return(u._Relu6=u.asm.Relu6).apply(null,arguments)},u._ResizeBilinear=function(){return(u._ResizeBilinear=u.asm.ResizeBilinear).apply(null,arguments)},u._ResizeNearestNeighbor=function(){return(u._ResizeNearestNeighbor=u.asm.ResizeNearestNeighbor).apply(null,arguments)},u._Reverse=function(){return(u._Reverse=u.asm.Reverse).apply(null,arguments)},u._RotateWithOffset=function(){return(u._RotateWithOffset=u.asm.RotateWithOffset).apply(null,arguments)},u._Round=function(){return(u._Round=u.asm.Round).apply(null,arguments)},u._Rsqrt=function(){return(u._Rsqrt=u.asm.Rsqrt).apply(null,arguments)},u._ScatterNd=function(){return(u._ScatterNd=u.asm.ScatterNd).apply(null,arguments)},u._SelectV2=function(){return(u._SelectV2=u.asm.SelectV2).apply(null,arguments)},u._Sigmoid=function(){return(u._Sigmoid=u.asm.Sigmoid).apply(null,arguments)},u._Sin=function(){return(u._Sin=u.asm.Sin).apply(null,arguments)},u._Softmax=function(){return(u._Softmax=u.asm.Softmax).apply(null,arguments)},u._SparseFillEmptyRows=function(){return(u._SparseFillEmptyRows=u.asm.SparseFillEmptyRows).apply(null,arguments)},u._SparseReshape=function(){return(u._SparseReshape=u.asm.SparseReshape).apply(null,arguments)},u._SparseSegmentReduction=function(){return(u._SparseSegmentReduction=u.asm.SparseSegmentReduction).apply(null,arguments)},u._Sqrt=function(){return(u._Sqrt=u.asm.Sqrt).apply(null,arguments)},u._Square=function(){return(u._Square=u.asm.Square).apply(null,arguments)},u._SquaredDifference=function(){return(u._SquaredDifference=u.asm.SquaredDifference).apply(null,arguments)},u._Step=function(){return(u._Step=u.asm.Step).apply(null,arguments)},u._StridedSlice=function(){return(u._StridedSlice=u.asm.StridedSlice).apply(null,arguments)},u._Sub=function(){return(u._Sub=u.asm.Sub).apply(null,arguments)},u._Sum=function(){return(u._Sum=u.asm.Sum).apply(null,arguments)},u._Tan=function(){return(u._Tan=u.asm.Tan).apply(null,arguments)},u._Tanh=function(){return(u._Tanh=u.asm.Tanh).apply(null,arguments)},u._Tile=function(){return(u._Tile=u.asm.Tile).apply(null,arguments)},u._TopK=function(){return(u._TopK=u.asm.TopK).apply(null,arguments)},u._Transform=function(){return(u._Transform=u.asm.Transform).apply(null,arguments)},u._Transpose=function(){return(u._Transpose=u.asm.Transpose).apply(null,arguments)},u.__FusedMatMul=function(){return(u.__FusedMatMul=u.asm._FusedMatMul).apply(null,arguments)},u._malloc=function(){return(u._malloc=u.asm.malloc).apply(null,arguments)},u._free=function(){return(u._free=u.asm.free).apply(null,arguments)},u.___errno_location=function(){return(u.___errno_location=u.asm.__errno_location).apply(null,arguments)};var Q,J,Z,Y=u.stackSave=function(){return(Y=u.stackSave=u.asm.stackSave).apply(null,arguments)},$=u.stackRestore=function(){return($=u.stackRestore=u.asm.stackRestore).apply(null,arguments)},ee=u.stackAlloc=function(){return(ee=u.stackAlloc=u.asm.stackAlloc).apply(null,arguments)};function te(e){function n(){Q||(Q=!0,u.calledRun=!0,A||(U(O),t(u),u.onRuntimeInitialized&&u.onRuntimeInitialized(),function(){if(u.postRun)for("function"==typeof u.postRun&&(u.postRun=[u.postRun]);u.postRun.length;)e=u.postRun.shift(),T.unshift(e);var e;U(T)}()))}C>0||(function(){if(u.preRun)for("function"==typeof u.preRun&&(u.preRun=[u.preRun]);u.preRun.length;)e=u.preRun.shift(),D.unshift(e);var e;U(D)}(),C>0||(u.setStatus?(u.setStatus("Running..."),setTimeout((function(){setTimeout((function(){u.setStatus("")}),1),n()}),1)):n()))}if(u.dynCall_iijjiiii=function(){return(u.dynCall_iijjiiii=u.asm.dynCall_iijjiiii).apply(null,arguments)},u.dynCall_jiji=function(){return(u.dynCall_jiji=u.asm.dynCall_jiji).apply(null,arguments)},u.cwrap=function(e,t,n,a){var r=(n=n||[]).every((function(e){return"number"===e||"boolean"===e}));return"string"!==t&&r&&!a?G(e):function(){return K(e,t,n,arguments)}},P=function e(){Q||te(),Q||(P=e)},u.preInit)for("function"==typeof u.preInit&&(u.preInit=[u.preInit]);u.preInit.length>0;)u.preInit.pop()();if(te(),r&&(J={uncaughtException:process.listeners("uncaughtException").filter((function(e){return!r.uncaughtException.indexOf(e)>-1})),unhandledRejection:process.listeners("unhandledRejection").filter((function(e){return!r.unhandledRejection.indexOf(e)>-1}))}),"undefined"!=typeof e)Z=e;else{if("undefined"==typeof WasmBackendModuleThreadedSimd)throw new Error("Could not find wasm module in post.js");Z=WasmBackendModuleThreadedSimd}if(J){var ne=Z._dispose;Z._dispose=function(){ne(),J.uncaughtException.forEach((function(e){process.removeListener("uncaughtException",e)})),J.unhandledRejection.forEach((function(e){process.removeListener("unhandledRejection",e)}))}}return e.ready});e.exports=a})),$n=Jn||Zn,ea=Yn||o({__proto__:null,default:Yn},[Yn]),ta=function(e){function n(n){var a=e.call(this)||this;return a.wasm=n,a.dataIdNextNumber=1,a.wasm.tfjs.initWithThreadsCount(pa),la=a.wasm.tfjs.getThreadsCount(),a.dataIdMap=new t.DataStorage(a,t.engine()),a}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}_(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}(n,e),n.prototype.write=function(e,t,n){var a={id:this.dataIdNextNumber++};return this.move(a,e,t,n,1),a},n.prototype.numDataIds=function(){return this.dataIdMap.numDataIds()},n.prototype.time=function(e){return y(this,void 0,void 0,(function(){var n;return g(this,(function(a){return n=t.util.now(),e(),[2,{kernelMs:t.util.now()-n}]}))}))},n.prototype.move=function(e,n,a,r,u){var i=this.dataIdNextNumber++;if("string"!==r){var s=t.util.sizeFromShape(a),o=s*t.util.bytesPerElement(r),d=this.wasm._malloc(o);this.dataIdMap.set(e,{id:i,memoryOffset:d,shape:a,dtype:r,refCount:u}),this.wasm.tfjs.registerTensor(i,s,d),null!=n&&this.wasm.HEAPU8.set(new Uint8Array(n.buffer,n.byteOffset,o),d)}else{var p=n;this.dataIdMap.set(e,{id:i,stringBytes:p,shape:a,dtype:r,memoryOffset:null,refCount:u})}},n.prototype.read=function(e){return y(this,void 0,void 0,(function(){return g(this,(function(t){return[2,this.readSync(e)]}))}))},n.prototype.readSync=function(e,n,a){var r=this.dataIdMap.get(e),u=r.memoryOffset,i=r.dtype,s=r.shape,o=r.stringBytes;if("string"===i)return null!=n&&0!==n||!(null==a||a>=o.length)?o.slice(n,a):o;n=n||0,a=a||t.util.sizeFromShape(s);var d=t.util.bytesPerElement(i);return function(e,t){switch(t){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error("Unknown dtype ".concat(t))}}(this.wasm.HEAPU8.slice(u+n*d,u+a*d).buffer,i)},n.prototype.disposeData=function(e,t){if(void 0===t&&(t=!1),this.dataIdMap.has(e)){var n=this.dataIdMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}return!0},n.prototype.refCount=function(e){return this.dataIdMap.has(e)?this.dataIdMap.get(e).refCount:0},n.prototype.incRef=function(e){var t=this.dataIdMap.get(e);null!=t&&t.refCount++},n.prototype.floatPrecision=function(){return 32},n.prototype.getMemoryOffset=function(e){return this.dataIdMap.get(e).memoryOffset},n.prototype.dispose=function(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null},n.prototype.memory=function(){return{unreliable:!1}},n.prototype.makeOutput=function(e,n,a){var r;if(null==a)r=this.write(null,e,n);else{var u=this.dataIdNextNumber++;r={id:u},this.dataIdMap.set(r,{id:u,memoryOffset:a,shape:e,dtype:n,refCount:1});var i=t.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,i,a)}return{dataId:r,shape:e,dtype:n}},n.prototype.typedArrayFromHeap=function(e){var n=e.shape,a=e.dtype,r=e.dataId,u=this.wasm.HEAPU8.buffer,i=this.dataIdMap.get(r).memoryOffset,s=t.util.sizeFromShape(n);switch(a){case"float32":return new Float32Array(u,i,s);case"int32":return new Int32Array(u,i,s);case"bool":return new Uint8Array(u,i,s);default:throw new Error("Unknown dtype ".concat(a))}},n}(t.KernelBackend);function na(e,t,n){if(null!=ua)return ua;var a="tfjs-backend-wasm.wasm";return e&&t?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=sa&&null!=sa[a]?sa[a]:n+a}function aa(){return y(this,void 0,void 0,(function(){var e,n,a;return g(this,(function(r){switch(r.label){case 0:return[4,Promise.all([t.env().getAsync("WASM_HAS_SIMD_SUPPORT"),t.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")])];case 1:return e=k.apply(void 0,[r.sent(),2]),n=e[0],a=e[1],[2,new Promise((function(e,r){var u,i={};i.locateFile=function(e,t){if(e.endsWith(".worker.js")){var r='"use strict";var Module={};var ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string";if(ENVIRONMENT_IS_NODE){var nodeWorkerThreads=require("worker_threads");var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",data=>onmessage({data:data}));var fs=require("fs");Object.assign(global,{self:global,require:require,Module:Module,location:{href:__filename},Worker:nodeWorkerThreads.Worker,importScripts:function(f){(0,eval)(fs.readFileSync(f,"utf8"))},postMessage:function(msg){parentPort.postMessage(msg)},performance:global.performance||{now:function(){return Date.now()}}})}var initializedJS=false;var pendingNotifiedProxyingQueues=[];function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");if(ENVIRONMENT_IS_NODE){fs.writeSync(2,text+"\n");return}console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;self.alert=threadAlert;Module["instantiateWasm"]=(info,receiveInstance)=>{var instance=new WebAssembly.Instance(Module["wasmModule"],info);receiveInstance(instance);Module["wasmModule"]=null;return instance.exports};self.onunhandledrejection=e=>{throw e.reason??e};self.onmessage=e=>{try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob=="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance})}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.pthread_ptr,0,0,1);Module["establishStackSpace"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].threadInitTLS();if(!initializedJS){pendingNotifiedProxyingQueues.forEach(queue=>{Module["executeNotifiedProxyingQueue"](queue)});pendingNotifiedProxyingQueues=[];initializedJS=true}try{Module["invokeEntryPoint"](e.data.start_routine,e.data.arg)}catch(ex){if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["keepRuntimeAlive"]()){}else{Module["__emscripten_thread_exit"](ex.status)}}else{throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["__emscripten_thread_exit"](-1)}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processProxyingQueue"){if(initializedJS){Module["executeNotifiedProxyingQueue"](e.data.queue)}else{pendingNotifiedProxyingQueues.push(e.data.queue)}}else if(e.data.cmd){err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){if(Module["__emscripten_thread_crashed"]){Module["__emscripten_thread_crashed"]()}throw ex}};'.replace(/\n/g,"\\n"),u=new Blob([r],{type:"application/javascript"});return URL.createObjectURL(u)}return e.endsWith(".wasm")?na(n,a,null!=ia?ia:t):t+e},da&&(i.instantiateWasm=(u=na(n,a,null!=ia?ia:""),function(e,n){return t.util.fetch(u,{credentials:"same-origin"}).then((function(t){t.ok||e.env.a("failed to load wasm binary file at '".concat(u,"'")),t.arrayBuffer().then((function(t){WebAssembly.instantiate(t,e).then((function(e){n(e.instance,e.module)}))}))})),{}}));var s,o=!1;i.onAbort=function(){if(!o&&!oa){oa=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}},a&&n&&null==ua?(i.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+$n.toString()],{type:"text/javascript"}),s=$n(i)):s=ea(i),s.then((function(t){o=!0,oa=!1;t.tfjs={init:t.cwrap("init",null,[]),initWithThreadsCount:t.cwrap("init_with_threads_count",null,["number"]),getThreadsCount:t.cwrap("get_threads_count","number",[]),registerTensor:t.cwrap("register_tensor",null,["number","number","number"]),disposeData:t.cwrap("dispose_data",null,["number"]),dispose:t.cwrap("dispose",null,[])},e({wasm:t})})).catch(r)}))]}}))}))}var ra=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"],ua=null,ia=null,sa={},oa=!1,da=!1;var pa=-1,la=-1;t.registerBackend("wasm",(function(){return y(void 0,void 0,void 0,(function(){var e;return g(this,(function(t){switch(t.label){case 0:return[4,aa()];case 1:return e=t.sent().wasm,[2,new ta(e)]}}))}))}),2),e.BackendWasm=ta,e.getThreadsCount=function(){if(-1===la)throw new Error("WASM backend not initialized.");return la},e.setThreadsCount=function(e){pa=e},e.setWasmPath=function(e,n){if(void 0===n&&(n=!1),t.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),oa)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");ua=e,da=n},e.setWasmPaths=function(e,t){if(void 0===t&&(t=!1),oa)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)ia=e;else{sa=e;var n=ra.filter((function(e){return null==sa[e]}));if(n.length>0)throw new Error("There were no entries found for the following binaries: "+"".concat(n.join(","),". Please either call setWasmPaths with a ")+"map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.")}da=t},e.version_wasm="4.0.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.min.js.map
